<?php

include_once(DZSWTL_PATH . 'inc/php/DZSWTLHelpers.php');
include_once(DZSWTL_PATH . 'class_parts/helper-functions.php');
include_once(DZSWTL_PATH . 'inc/php/gutenberg-functions.php');
include_once(DZSWTL_PATH . 'inc/php/view-functions.php');
include_once(DZSWTL_PATH . 'inc/php/view-functions--parse-items.php');
include_once(DZSWTL_PATH . 'inc/php/misc/layouts-custom-transforms.php');
include_once(DZSWTL_PATH . "inc/php/DZSWTLAjax.php");
include_once(DZSWTL_PATH . "inc/php/DZSWTLAdmin.php");
include_once(DZSWTL_PATH . "inc/php/DZSWTLFilters.php");
include_once(DZSWTL_PATH . "inc/php/style-functions.php");

class DZSWooTable {


  public $thepath;
  public $base_url;
  public $base_path;
  public $indexnr = 0;


  public $mode = 'plugin';

  public $isEnableMultisharer = true;
  /** @var bool already feeded to one shop */
  public $isGetAlreadyConsumed = false;


  public $footer_extra_html = '';

  public $db_mainoptions = array();
  public $dbname_mainoptions = 'dzswtl_mo';

  public $admin_tax = 'category'; // -- the post taxonomy can be changed from $_GET
  public $admin_post_type = 'post'; // -- the post type we are trying to


  public $capability_admin = 'manage_options';


  public $debug_mode = false; // -- set this to "true" for preview mode
  public $plugin_justactivated = false; // -- set this to "true" for preview mode


  public $notifications = array();

  public $shop_index = 1; // -- the shop index
  public $call_index = 50; // -- only allow 50 calls of the main shortcode function to prevent stack overflow
  public $index_filter = 0; // -- only allow 50 calls of the main shortcode function to prevent stack overflow
  public $previousShortcodeCallsParams = array(); // -- detect if the shortcode has been called in the past

  public $options_item_meta = array();


  public $args_curr_wootable = array();
  public $sanitized_get = array();
  public $attribute_extra_types = array();
  public $generate_layout_item_default_margs = array();
  public $all_checks = array();
  public $hard_coded_keys = array(); // -- hard coded keys in the shortcode .. for now only cat is a possibility


  public $options_item_meta_sanitized = array(); // -- todo: temp
  public $cpt_posts = array(); // -- the layouts

  /** @var array DzsOptionArray to DzsOptionArrayForGutenberg */
  public $gutenberg_block_options = array();

  public $dzswtl_plugin_rpwcm = null;

  public $classAjax;
  public $classAdmin;
  public $classFilters;

  function __construct() {


    $this->thepath = plugins_url('', __FILE__) . '/';


    $this->base_path = dirname(__FILE__) . '/';
    $this->base_url = DZSWTL_URL;

    include_once "class_parts/default_layout_item_opts.php";

    if (defined(DZSWTL_KEY_IS_FILTERS_FROM_GET_ALREADY_CONSUMED) && get_defined_constants()[DZSWTL_KEY_IS_FILTERS_FROM_GET_ALREADY_CONSUMED] == 'on') {
      $this->isGetAlreadyConsumed = true;
    }

    if (isset($_GET['tax'])) {
      $this->admin_tax = $_GET['tax'];
    }
    if (isset($_GET['post_type'])) {
      $this->admin_post_type = $_GET['post_type'];
    }
    if (isset($_GET['debug_mode']) && $_GET['debug_mode'] == 'on') {
      $this->debug_mode = true;
    }
    if (defined('DZSWTL_DEBUG_MODE') && DZSWTL_DEBUG_MODE == 'ON') {
      $this->debug_mode = true;
    }

    $this->attribute_extra_types = array(
      'color' => esc_html__('Color', DZSWTL_ID),
    );

    $defaultOpts = array();
    include('inc/php/configs/default-main-options.php');
    $mainOptions = include('configs/config-main-options.php');
    foreach ($mainOptions as $key => $arr) {
      if (!isset($defaultOpts[$key])) {
        $defaultOpts[$key] = $mainOptions[$key]['default'];
      }
    }

    $this->db_mainoptions = get_option($this->dbname_mainoptions);

    // --  default opts / inject into db
    if ($this->db_mainoptions == '') {
      $this->db_mainoptions = $defaultOpts;
      update_option($this->dbname_mainoptions, $this->db_mainoptions);
    } else {

      $this->db_mainoptions = array_merge($defaultOpts, $this->db_mainoptions);
    }


    DZSWTLHelpers::mainInitialSetup($this);


    $this->base_url = plugins_url('', __FILE__) . '/';
    $this->base_path = dirname(__FILE__) . '/';


    if ($this->db_mainoptions['scripts_reinit_document_ready'] == 'on') {
    }

    $this->gutenberg_block_options = include(DZSWTL_PATH . 'configs/config-main-shortcode-attributes.php');


    include_once(DZSWTL_PATH . "widget.php");


    $this->classAjax = new DZSWTLAjax($this);

    $this->classFilters = new DZSWTLFilters($this);
    if (is_admin()) {
      $this->classAdmin = new DZSWTLAdmin($this);
    }
    dzswtl_view_init();
    dzswtl_gutenberg_add_actions($this);


    add_action('init', array($this, 'handle_init'));
    add_action('plugins_loaded', array($this, 'handle_plugins_loaded'));
    add_action('wp_loaded', array($this, 'handle_wp_loaded'));
    add_action('init', array($this, 'handle_init_end'), 999);


    add_action('wp_head', array($this, 'handle_wp_head'));
    add_action('wp_footer', array($this, 'handle_wp_footer'));


    add_action('the_post', array($this, 'handle_post_start'));


  }

  function handle_plugins_loaded(){
    load_plugin_textdomain(DZSWTL_ID, false, dirname( plugin_basename( __FILE__ ) ) . '/languages');
  }

  /**
   * restart shop_index when content appears
   */
  function handle_post_start() {

    $this->shop_index = 1;
    $this->isGetAlreadyConsumed = false;
    $this->previousShortcodeCallsParams = array();
  }


  function get_dzswtl_custom_term_meta($t_id) {

    $term_meta = get_option("taxonomy_$t_id");
    return $term_meta;
  }


  function import_demo_insert_post_complete($pargs = array()) {


    $margs = array(

      'post_title' => '',

      'post_content' => '',
      'post_type' => DZSWTL_POST_TYPE,
      'post_status' => 'publish',
      'post_name' => '',
      'img_url' => '',
      'img_path' => '',
      'term' => '',
      'taxonomy' => '',
      'attach_id' => '',


    );

    $margs = array_merge($margs, $pargs);


    if ($margs['post_name']) {


      $the_slug = $margs['post_name'];
      $args = array(
        'name' => $the_slug,
        'post_type' => $margs['post_type'],
        'post_status' => 'publish',
        'numberposts' => 1
      );
      $my_posts = get_posts($args);


      if ($my_posts) {

        if ($margs['term']) {

          if (is_object($margs['term']) && isset($margs['term']->term_id)) {
            $term = $margs['term']->term_id;
          } else {

            if (is_array($margs['term']) && isset($margs['term']['term_id'])) {
              $term = $margs['term']['term_id'];
            }
          }

          wp_set_post_terms($my_posts[0]->ID, $term, $margs['taxonomy']);
        }
        return $my_posts[0];


      }
    }

    $args = array(
      'post_type' => $margs['post_type'],
      'post_title' => $margs['post_title'],

      'post_content' => $margs['post_content'],
      'post_status' => $margs['post_status'],


      /*other default parameters you want to set*/
    );

    if ($margs['post_name']) {

      $args['post_name'] = $margs['post_name'];
    }


    if ($margs['term']) {

      $term = $margs['term'];
    }
    $taxonomy = $margs['taxonomy'];

    if ($margs['img_url']) {

      $img_url = $margs['img_url'];
    }
    $img_path = $margs['img_path'];


    $port_id = $this->import_demo_create_portfolio_item($args);

    if ($margs['term']) {
      $term = $margs['term'];


      if (is_object($margs['term']) && isset($margs['term']->term_id)) {
        $term = $margs['term']->term_id;
      }
      wp_set_post_terms($port_id, $term, $taxonomy);
    }


    foreach ($margs as $lab => $val) {
      if (strpos($lab, 'dzswtl_meta') === 0) {

        update_post_meta($port_id, $lab, $val);
      }
    }


    if ($margs['attach_id']) {

      set_post_thumbnail($port_id, $margs['attach_id']);
    } else {

      if ($margs['img_url']) {
        $attach_id = $this->import_demo_create_attachment($img_url, $port_id, $img_path);
        set_post_thumbnail($port_id, $attach_id);

        $this->import_demo_last_attach_id = $attach_id;
      }

    }


    return $port_id;


  }


  function import_demo_create_term_if_it_does_not_exist($pargs = array()) {


    $margs = array(

      'term_name' => '',
      'slug' => '',
      'taxonomy' => '',
      'description' => '',
      'parent' => '',
    );

    $margs = array_merge($margs, $pargs);

    $term = get_term_by('slug', $margs['slug'], $margs['taxonomy']);


    if ($term) {

    } else {


      $args = array(
        'description' => $margs['description'],
        'slug' => $margs['slug'],


      );

      if ($margs['parent']) {
        $args['parent'] = $margs['parent'];
      }

      $term = wp_insert_term($margs['term_name'], $margs['taxonomy'], $args);

    }
    return $term;

  }


  function import_demo_create_attachment($img_url, $port_id, $img_path) {


    $attachment = array(
      'guid' => $img_url,
      'post_mime_type' => 'image/jpeg',
      'post_title' => preg_replace('/\.[^.]+$/', '', basename($img_url)),
      'post_content' => '',
      'post_status' => 'inherit'
    );

    $attach_id = wp_insert_attachment($attachment, $img_url, $port_id);


    require_once(ABSPATH . 'wp-admin/includes/image.php');

    $attach_data = wp_generate_attachment_metadata($attach_id, $img_path);
    wp_update_attachment_metadata($attach_id, $attach_data);

    return $attach_id;
  }


  function import_demo_create_portfolio_item($pargs = array()) {


    $margs = array(

      'post_title' => '',
      'post_content' => '',
      'post_status' => '',
      'post_type' => 'product',
    );

    $margs = array_merge($margs, $pargs);


    $args = array(
      'post_type' => $margs['post_type'],
      'post_title' => $margs['post_title'],
      'post_content' => $margs['post_content'],
      'post_status' => $margs['post_status'],


      /*other default parameters you want to set*/
    );


    $post_id = wp_insert_post($args);

    return $post_id;


  }


  public function handle_plugin_activate() {
    $this->plugin_justactivated = "on";

  }


  function is_plugin_active($plugin) {


    return in_array($plugin, (array)get_option('active_plugins', array())) || is_plugin_active_for_network($plugin);
  }


  function generate_add_to_cart($margs, $ld, $po) {

    $iout = '';

    return $iout;

  }

  function register_links() {


    register_post_status(DZSWTL_POST_STATUS_PREVIEW, array(
      'label' => _x('DZS Preview', 'post'),
      'public' => false,
      'exclude_from_search' => true,
      'show_in_admin_all_list' => false,
      'show_in_admin_status_list' => true,
      'label_count' => _n_noop('Table Preview <span class="count">(%s)</span>', 'Table Preview  <span class="count">(%s)</span>'),
    ));

    $labels = array(
      'name' => esc_html__("Shop Layouts", DZSWTL_ID),
      'singular_name' => esc_html__("Shop Layout", DZSWTL_ID),
      'edit_item' => esc_html__("Edit Layout", DZSWTL_ID),
      'all_items' => esc_html__("All layouts", DZSWTL_ID),
    );

    $args = array(
      'labels' => $labels,
      'public' => true,
      'has_archive' => true,
      'hierarchical' => true,
      'supports' => array('title', 'editor', 'page-attributes', 'author', 'revisions'),
      'rewrite' => array('slug' => 'woo-layout'),
      'yarpp_support' => true,
      'exclude_from_search' => true,
    );
    register_post_type(DZSWTL_POST_TYPE, $args);
  }


  function handle_wp_loaded() {

    DZSWTLHelpers::checkInitQueryParams();
  }

  function handle_init() {


    global $pagenow, $post;


    if (defined('RPWCM_PLUGIN_PATH')) {
      include_once 'class_parts/woocommerce_memberships_profile.php';
      include_once 'inc/php/extra-functionality/DzswtlRpwcmPluginSupport.php';
      $this->dzswtl_plugin_rpwcm = new DzswtlRpwcmPluginSupport($this);
    }



    if (is_admin()) {

      include_once(DZSWTL_PATH . "inc/php/layout-builder--functions.php");
      include_once(DZSWTL_PATH . "inc/php/layout-builder--generate-layer-item.php");



      if (isset($_GET['page']) && $_GET['page'] == DZSWTL_ADMIN_PAGENAME_MAINOPTIONS) {


        DZSWTLHelpers::enqueue_script('fontawesome');

        wp_enqueue_style('dzstabsandaccordions', DZSWTL_URL . 'libs/dzstabsandaccordions/dzstabsandaccordions.css');
        wp_enqueue_script('dzstabsandaccordions', DZSWTL_URL . "libs/dzstabsandaccordions/dzstabsandaccordions.js");


        wp_enqueue_script('dzswtl-admin-mo', DZSWTL_URL . "admin/admin-mo.js");
        wp_enqueue_style('dzstoggle', DZSWTL_URL . 'libs/dzstoggle/dzstoggle.css');
        wp_enqueue_script('dzstoggle', DZSWTL_URL . "libs/dzstoggle/dzstoggle.js");

      }


      if (current_user_can('manage_options') == false) {

        if (strpos(dzs_curr_url(), 'edit.php?post_type=page') !== false) {

          $url = admin_url('post-new.php?post_type=page');

          wp_redirect($url);

          exit;

          // TODO: redirect

        }
      }


      if (current_user_can('manage_options') || current_user_can('directory_make_shortcode')) {

        wp_enqueue_script('dzswtl-add-generators', DZSWTL_URL . 'shortcodegenerator/add-generators-to-mce.js');
        wp_enqueue_script('dzswtl-shortcode-receiver', DZSWTL_URL . 'shortcodegenerator/shortcode-receiver.js');


        wp_enqueue_script('ultibox', DZSWTL_URL . 'libs/ultibox/ultibox.js');
        wp_enqueue_style('ultibox', DZSWTL_URL . 'libs/ultibox/ultibox.css');

      }

    }


    add_filter('pre_get_posts', array($this, 'posts_for_current_author'));


    $this->register_links();
    DZSWooTableHelper::get_all_checks_from_get();


    if ($this->plugin_justactivated == 'on') {
      flush_rewrite_rules();
    }


    add_action('created_term', 'dzswtl_handle_save_term_meta', 10, 2);
    add_action('edit_term', 'dzswtl_handle_save_term_meta', 10, 2);

  }


  /**
   * returns the query
   * @param $search
   * @param null $wp_query
   * @return mixed|string
   */
  public function filter_posts_search_include_tags($search, $wp_query = null) {
    global $wpdb;

    if (empty($search))
      return $search;

    $terms = $wp_query->query_vars['s'];
    $exploded = explode(' ', $terms);
    if ($exploded === FALSE || count($exploded) == 0)
      $exploded = array(0 => $terms);

    $search = '';


    $table_name = $wpdb->prefix . 'posts';


    foreach ($exploded as $tag) {
      $search .= " AND (
            (" . $wpdb->prefix . "posts.post_title LIKE '%$tag%')
            OR (" . $wpdb->prefix . "posts.post_content LIKE '%$tag%')
            OR EXISTS
            (
                SELECT * FROM " . $wpdb->prefix . "terms
                INNER JOIN " . $wpdb->prefix . "term_taxonomy
                    ON " . $wpdb->prefix . "term_taxonomy.term_id = " . $wpdb->prefix . "terms.term_id
                INNER JOIN " . $wpdb->prefix . "term_relationships
                    ON " . $wpdb->prefix . "term_relationships.term_taxonomy_id = " . $wpdb->prefix . "term_taxonomy.term_taxonomy_id
                WHERE taxonomy = 'product_tag'
                    AND object_id = " . $wpdb->prefix . "posts.ID
                    AND " . $wpdb->prefix . "terms.name LIKE '%$tag%'
            )
        )";
    }

    return $search;
  }


  function handle_init_end() {


    if (get_option('dzswtl_installed_sample_data')) {
    } else {
      update_option('dzswtl_installed_sample_data', 'yes');
    }

  }


  function handle_wp_head() {
    DZSWTLHelpers::init_sanitizeGetArray($this);


    global $post;


    if ($post && $post->post_type == DZSWTL_POST_TYPE) {
      add_filter('the_content', array($this, 'filter_the_content'));
    }

    if (function_exists('is_product_category') && is_product_category()) {
      if ($this->db_mainoptions['replace_woocommerce_category_page_shortcode']) {
        add_filter('product_cat_description', array($this, 'filter_product_cat_description'));
      }


    }
  }

  function filter_product_cat_description($content) {
    global $wp_query;


    $cat = $wp_query->query[DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY];

    $fout = do_shortcode(str_replace('{{cat}}', $cat, $this->db_mainoptions['replace_woocommerce_category_page_shortcode']));

    return $fout;
  }

  function filter_the_content($content) {

    global $post;


    if (function_exists('is_product_category') && is_product_category()) {
    }

    if ($post && $post->post_type == DZSWTL_POST_TYPE) {


      $str = '<div class="warning">' . wp_kses(sprintf(__('%swarning: %s this is not how to include the shop layout in a page, please read %sdocs%s', DZSWTL_ID), '<strong>', '</strong>', '<a href="' . DZSWTL_URL . 'readme/index.html" target="_blank">', '</a>'), DZSWTL_VIEW_ALLOWED_HTML_TAGS) . '</div>';

      $str .= '<h4>' . esc_html__("Preview", DZSWTL_ID) . '</h4>';
      $str .= '[dzs_woo_table layout="' . $post->post_name . '" show_filtered_by="on" posts_per_page="12"]';

      $str .= '<br><br><br><h6>' . esc_html__("How to install", DZSWTL_ID) . '</h6>';
      $str .= '<p>
            You can now add layouts you create in the <strong>Shop</strong> Admin into any post or page. To make it simple a Shortcode Generator is included. You can access it via this button.</p>';
      $str .= '<p>
            <a class="colorbox" href="https://i.imgur.com/5Dp7rzg.jpg"><a class="colorbox" href="https://i.imgur.com/5Dp7rzg.jpg"><img class="fig" src="https://i.imgur.com/5Dp7rzg.jpg"></a></a></p>';
      $str .= '<p>
            <em>The first button is the shortcode generator launcher and the second one ( the one with a plus ) ads a single audio player to the page from the media gallery.</em></p>';
      $str .= '<p>
            <iframe allowfullscreen="" frameborder="0" height="315" scrolling="no" src="//www.youtube.com/embed/9iGVUVxnaWY" width="100%"></iframe></p>';

      $content = do_shortcode($str);
    }


    return $content;
  }

  function handle_wp_footer() {
    dzswtl_wp_footer_scripts();


  }

  function posts_for_current_author($query) {
    global $pagenow;


    // show only own posts

    if ('edit.php' != $pagenow || !$query->is_admin) {
      return $query;
    }

    if (!current_user_can('manage_options')) {
      global $user_ID;
      $query->set('author', $user_ID);
    }
    return $query;
  }


  function handle_admin_notices() {

  }


}