<?php



wp_enqueue_style('wp-color-picker');
wp_enqueue_script('wp-color-picker');
wp_enqueue_script('jquery-ui-core');
wp_enqueue_script('jquery-ui-sortable');

$config_main_options = include(DZSWTL_PATH.'configs/config-main-options.php');
$arr_options = array();


$argsGetAllPages = array(
  'sort_order' => 'asc',
  'sort_column' => 'post_title',
  'hierarchical' => 1,
  'exclude' => '',
  'include' => '',
  'meta_key' => '',
  'meta_value' => '',
  'authors' => '',
  'child_of' => 0,
  'parent' => -1,
  'exclude_tree' => '',
  'number' => '',
  'offset' => 0,
  'post_type' => 'page',
  'post_status' => 'publish'
);

if (isset($_GET['dzswtl_filter_generator']) && $_GET['dzswtl_filter_generator'] == 'on') {
  include_once dirname(dirname(__FILE__)) . '/shortcodegenerator/filter-generator.php';
  dzswtl_shortcode_generator();
} elseif (isset($_GET['dzswtl_con_shortcode_generator']) && $_GET['dzswtl_con_shortcode_generator'] == 'on') {

  include_once dirname(dirname(__FILE__)) . '/shortcodegenerator/filter-con-generator.php';
  dzswtl_con_shortcode_generator();
} elseif (isset($_GET['dzswtl_shortcode_generator']) && $_GET['dzswtl_shortcode_generator'] == 'on') {

  include_once dirname(dirname(__FILE__)) . '/shortcodegenerator/shortcode-generator.php';
  dzswtl_shortcode_generator();
} elseif (isset($_GET['dzswtl_shortcode_preview']) && $_GET['dzswtl_shortcode_preview'] == 'on') {

  include_once dirname(dirname(__FILE__)) . '/shortcodegenerator/shortcode-preview.php';
  dzswtl_shortcode_preview();
} else {



  ?>

  <div class="wrap">
    <h2><?php echo esc_html__('WooTable Settings', DZSWTL_ID); ?></h2>
    <br/>

    <form class="mainsettings">

      <a class="ultibox-item button-secondary" href="<?php echo DZSWTL_URL; ?>readme/index.html"
         data-bigwidth="1100" data-scaling="fill"
         data-bigheight="700"><?php echo esc_html__("Documentation", 'dzswtl'); ?></a>


      <a href="<?php echo admin_url('admin.php?page=dzswtl_menu&dzswtl_filter_generator=on'); ?>" target="_blank"
         class="button-secondary action"><?php echo esc_html__('Filter generator', DZSWTL_ID); ?></a>


      <a href="<?php echo admin_url('admin.php?page=dzswtl_menu&dzswtl_shortcode_generator=on'); ?>" target="_blank"
         class="button-secondary action"><?php _e('Shortcode generator', DZSWTL_ID); ?></a>


      <?php
      do_action('dzswtl_mainoptions_before_tabs');
      ?>

      <h3><?php echo esc_html__("Admin Options", DZSWTL_ID); ?></h3>

      <div class="dzs-tabs auto-init" data-options="{ 'design_tabsposition' : 'top'
,design_transition: 'fade'
,design_tabswidth: 'default'
,toggle_breakpoint : '400'
,toggle_type: 'accordion'
,toggle_type: 'accordion'
,settings_enable_linking : 'on'
,settings_appendWholeContent: true
,refresh_tab_height: '1000'
}">

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-tachometer"></i> <?php echo esc_html__("Settings", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">

            <?php
            if (defined("DZSAP_VERSION")) {
              echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'main-dzsap');
            }


            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'main');
            ?>



            <?php
            if (defined('RPWCM_PLUGIN_PATH')) {
              $pages = get_pages($argsGetAllPages);
              $opts = array();
              foreach ($pages as $lab => $val) {
                $aux = array(
                  'label' => $val->post_title,
                  'value' => $val->post_name,
                );
                array_push($opts, $aux);
              }

              global $dzswtl_rpwcm_pages;
              $dzswtl_rpwcm_pages = $opts;

              echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'plugin-RPWCM');

            }
            ?>

          </div>
        </div>


        <?php
        DZSWooTableHelper::generateHtmlDzsTabsSeparator();
        ?>

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-shopping-cart"></i> <?php echo esc_html__("Add to cart", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">
            <?php

            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'add_to_cart');
            ?>
          </div>
        </div>


        <?php
        DZSWooTableHelper::generateHtmlDzsTabsSeparator();
        ?>

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-external-link"></i> <?php echo esc_html__("Redirect", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">
            <?php
            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'redirect_pages');
            ?>
          </div>
        </div>


        <?php
        DZSWooTableHelper::generateHtmlDzsTabsSeparator();
        ?>

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-flag"></i> <?php echo esc_html__("Translations", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">
            <?php

            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'translations');
            ?>
          </div>
        </div>


        <?php
        DZSWooTableHelper::generateHtmlDzsTabsSeparator();
        ?>

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-tags"></i> <?php echo esc_html__("Filters", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">
            <?php

            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'filters');
            ?>
          </div>
        </div>
        <?php
        // -- separator
        DZSWooTableHelper::generateHtmlDzsTabsSeparator();
        ?>


        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-paragraph"></i> <?php echo esc_html__("Short description", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">
            <?php

            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_main_options, 'short-description');
            ?>


          </div>
        </div>
        <?php
        // -- separator
        DZSWooTableHelper::generateHtmlDzsTabsSeparator();
        ?>

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="fa fa-tag"></i> <?php echo esc_html__("Attributes", DZSWTL_ID); ?>
          </div>
          <div class="tab-content">

            <?php

            $taxonomies = get_taxonomies(array(), 'objects');


            $atts = array();
            foreach ($taxonomies as $taxonomy) {
              if (strpos($taxonomy->name, DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) === 0) {
                array_push($atts, $taxonomy);
              }
            }
            foreach ($atts as $att) {


              ?>
              <div class="generate-attribute-sort-con"><span
                  class="the-label"><?php echo $att->label; ?></span>
                <button class="button-secondary btn-generate-attribute-sort"
                        data-pa-slug="<?php echo $att->name; ?>"><?php echo esc_html__("Generate", DZSWTL_ID); ?></button>
              </div>
              <?php
            }

            ?>
          </div>
        </div>


        <?php

        ?>


        <!-- system check END --><?php

        do_action('dzswtl_db_mainoptions_extra_in_tab');

        ?>

      </div><!-- end .dzs-tabs -->


      <?php


      do_action('dzswtl_db_mainoptions_extra');
      ?>
      <br/>
      <a href='#'
         class="button-primary dzswtl-mo-save-mainoptions"><?php echo esc_html__('Save Options', DZSWTL_ID); ?></a>
    </form>

    <br>
    <br>
    <br>
    <div class="dzstoggle">
      <div class="toggle-title"><?php echo esc_html__("Generate attribute data", DZSWTL_ID); ?></div>
      <div class="toggle-content">
        <div class="sidenote"><?php echo esc_html__("Generate sort data for sorting attributes"); ?></div>
        <button class="button-secondary"><?php echo esc_html__("Generate"); ?></button>
        <br>
        <br>
      </div>
    </div>
    <br/><br/>
    <div class="dzstoggle">
      <div class="toggle-title"><?php echo esc_html__("Plugin Data"); ?></div>
      <div class="toggle-content">
        <div class="sidenote"><?php echo __("delete some plugin data"); ?></div>
        <form action="" method="post">
          <button name="dzswtl_action" value="delete_sample_data"
                  class="button-secondary"><?php echo __("Delete sample data"); ?></button>
        </form>

        <br>
        <br>
      </div>
    </div>
    <br/><br/>

    <br/>

    <div class="feedbacker" style=""><img alt="" style="" id="save-ajax-loading2"
                                             src="<?php echo site_url(); ?>/wp-admin/images/wpspin_light.gif"/>
    </div>
  </div>
  <div class="clear"></div><br/>
  <?php
}