<?php
function dzswtl_cats_get_from_get($lab_sanitized) {
  $seekval = '';

  if (isset($_GET) && is_array($_GET) && count($_GET) > 0) {

    if (isset($_GET[$lab_sanitized])) {

      $cats = $_GET[$lab_sanitized];
      if (strpos($_GET[$lab_sanitized], '%252C') !== false) {

        $cats = str_replace('%252C', ',', $_GET[$lab_sanitized]);


      }

      if (strpos($_GET[$lab_sanitized], '%2C') !== false) {

        $cats = str_replace('%2C', ',', $_GET[$lab_sanitized]);

      }
      $cats = explode(',', $cats);
      $seekval = $cats;
    }
  }
  return $seekval;
}

function dzswtl_view_generateMultipleOption($opt, $margs, $attribute_type, $lab_sanitized, $lab) {


  global $dzswtl;

  $fout = '';
  $classes = '';
  $count = '';
  $isSelected = false;
  $argsCheckboxSelectedVal = '';


  if (is_array($dzswtl->all_checks) && isset($dzswtl->all_checks[$lab_sanitized])) {
    $valFromQuery = $dzswtl->all_checks[$lab_sanitized];

    if (strpos($valFromQuery, ',') !== false) {
      $isSelected = true;
      $argsCheckboxSelectedVal = explode(',', $valFromQuery);

    }else{
      if ($opt['value'] == $valFromQuery) {
        $isSelected = true;
        $argsCheckboxSelectedVal = $valFromQuery;
      }
    }
  }
  if (isset($opt['selected']) && $opt['selected'] == 'on') {
    $isSelected = true;
  }


  if (isset($opt['count']) && $opt['count'] !== '') {
    $count = $opt['count'];
  }


  $fout .= '<label class="multiple-option" ';


  if (isset($dzswtl->all_checks[$lab_sanitized])) {
    if ($opt['value'] == $dzswtl->all_checks[$lab_sanitized]) {
      $fout .= ' active';
    }
  }

  if (isset($opt['value']) && $opt['value']) {
    $fout .= ' data-term_slug="' . $opt['value'] . '"';
  }
  if (isset($opt['term_id']) && $opt['term_id']) {
    $fout .= ' data-term_id="' . $opt['term_id'] . '"';
  }
  if ($count !== '') {
    $fout .= ' data-count="' . $count . '"';
  }

  $fout .= '>';

  $checkboxArgs = array(
    'input_type' => 'checkbox',
    'val' => $opt['value'],
    'seekval' => $argsCheckboxSelectedVal,
    'class' => 'dzs-woo-table-filter-input ' . $classes,
  );


  if (isset($opt['selected']) && $opt['selected'] == 'disabled') {
    $checkboxArgs['disabled'] = 'on';
  }

  $fout .= DZSHelpers::generate_input_checkbox($lab, $checkboxArgs);

  $fout .= ' ';


  if ($attribute_type != 'color') {


    if ($margs['type_multiple_style'] == 'small-image-with-title') {


      $term_meta = $dzswtl->get_dzswtl_custom_term_meta($opt['term_id']);


      if (isset($term_meta['image']) && $term_meta['image']) {


        $fout .= '<div class="the-image" style="background-image:url(' . DZSWTLHelpers::sanitize_id_to_src($term_meta['image']) . ')">' . '</div>';
      }
    }

    // -- the label in multiple
    $fout .= '<span class="the-label">';

    $fout .= '<span class="the-label--name">' . $opt['label'] . '</span>';


    if ($margs['include_count'] == 'on' && $count !== '') {

      $fout .= ' <span class="the-count">(<span class="the-actual-count" data-original-count="' . $opt['count'] . '">' . $opt['count'] . '</span>)</span>';
    }

    $fout .= '</span>';
    // -- end .the-label
  }

  if ($attribute_type == 'color') {
    $fout .= '<span class="color-option" style="background-color: ' . $opt['meta_color'] . '"></span>';
  }


  if (isset($opt['subcategories']) && $opt['subcategories']) {
    foreach ($opt['subcategories'] as $subcat) {
      $fout .= dzswtl_view_generateMultipleOption($subcat, $margs, $attribute_type, $lab_sanitized, $lab);
    }
  }

  $fout .= '</label>';


  return $fout;

}

function dzswtl_generate_cats_array_with_count($categories, $lab_sanitized = 'cat', $pargs = array()) {
  // -- this will only consider cat

  global $dzswtl;
  $margs = array(
    'type_multiple_cascade' => 'off'
  );


  if (is_array($pargs)) {
    $margs = array_merge($margs, $pargs);
  }


  $foutarr = array();
  foreach ($categories as $lab => $cat) {




    $selected = 'off';


    if (isset($dzswtl->hard_coded_keys['cat'])) {
      if ($dzswtl->hard_coded_keys['cat'] != $cat->slug) {
        $selected = 'disabled';
      } else {
        $selected = 'on';
      }
    }
    if (isset($dzswtl->all_checks['cat']) && $dzswtl->all_checks['cat'] == $cat->slug) {
      $selected = 'on';
    }


    $aux = array(
      'label' => $cat->name,
      'value' => $cat->slug,
      'count' => $cat->count,
      'selected' => $selected,
    );

    if (isset($cat->subcategories) && count($cat->subcategories)) {
      $aux['subcategories'] = dzswtl_generate_cats_array_with_count($cat->subcategories, 'cat', $margs);
    }


    array_push($foutarr, $aux);


  }
  return $foutarr;
}