<?php
/**
 * Created by PhpStorm.
 * User: user
 * Date: 14/04/2019
 * Time: 15:34
 */

class DZSWooTableHelper {
  /**
   * @param WC_Product_Simple | null $product
   * @param DzswtlInnerConf $layerButtonAttrs
   * @return mixed|string
   */
  static function getAddToCartText($product = null, $layerButtonAttrs = null, $layerData = array()) {
    global $dzswtl;

    $addToCartText = esc_html__('Shop', DZSWTL_ID);
    if ($product) {
      $addToCartText = $product->add_to_cart_text();

      if (strtolower($dzswtl->db_mainoptions['translation__add_to_cart']) != 'add to cart' && strtolower($dzswtl->db_mainoptions['translation__add_to_cart']) != strtolower(esc_html($product->add_to_cart_text())) && $dzswtl->db_mainoptions['translation__add_to_cart']) {
        $addToCartText = $dzswtl->db_mainoptions['translation__add_to_cart'];
      }
      if ($layerButtonAttrs && $layerButtonAttrs->is_download_link) {
        $addToCartText = esc_html__("Download", DZSWTL_ID);
      }


      if (isset($layerData['button_style']) && $layerData['button_style'] == 'default') {
        if ($product->is_type('variable') || $product->is_type('grouped')) {
          $addToCartText = esc_html__("Options", DZSWTL_ID);
        }
      }
      if ($product->is_type('simple')) {
        if (DZSWTLHelpers::woocommerceProductIsOutOfStock($product)) {
          $addToCartText = esc_html__("Options", DZSWTL_ID);
        }
      }
    }


    return $addToCartText;

  }

  static function generateHtmlDzsTabsSeparator() {
    echo '<div class="dzs-tab-tobe tab-disabled"><div class="tab-menu ">&nbsp;&nbsp;</div><div class="tab-content"></div></div>';
  }

  static function generateOptionsFromConfigForMainOptions($config_main_options, $category = 'main', $argValsProvider = null, $extraOptions = array()) {

    global $dzswtl;

    $generateOptions = array_merge(array(
      'labelPrefix' => '',
      'labelSuffix' => '',
      'formsExtraClasses' => '',
    ), $extraOptions);

    $fout = '';
    foreach ($config_main_options as $optionKey => $main_option) {
      if ($main_option['category'] !== $category) {
        continue;
      }

      $inputLabel = $optionKey;


      $finalValue = '';

      if (isset($main_option['default']) && $main_option['default']) {
        $finalValue = $main_option['default'];
      }

      $valsProvider = null;

      if ($argValsProvider) {
        $valsProvider = $argValsProvider;
      } else {
        if (isset($dzswtl->db_mainoptions[$optionKey]) && $dzswtl->db_mainoptions[$optionKey]) {
          $valsProvider = $dzswtl->db_mainoptions;
        }
      }

      if ($optionKey === 'integrate_search_in_filters') {

      }

      if (isset($main_option['formsExtraClasses']) && $main_option['formsExtraClasses']) {
        $generateOptions['formsExtraClasses'] .= $main_option['formsExtraClasses'];
      }

      if (isset($valsProvider[$optionKey]) && $valsProvider[$optionKey]) {
        $finalValue = $valsProvider[$optionKey];
      }


      $fout .= '<div class="setting';

      if (isset($main_option['settingConExtraClasses']) && $main_option['settingConExtraClasses']) {
        $fout .= $main_option['settingConExtraClasses'];
      }

      $fout .= '" ';

      if (isset($main_option['dependency']) && $main_option['dependency']) {
        $fout .= ' data-dependency=\'' . json_encode($main_option['dependency']) . '\'';
      }


      $fout .= '>';
      $fout .= '<h4 class="setting-label">' . $main_option['title'] . '</h4>';


      $inputLabel = $generateOptions['labelPrefix'] . $inputLabel . $generateOptions['labelSuffix'];

      $argsForInput = array(
        'id' => $inputLabel,
        'val' => '',
        'extraattr' => '  data-label="' . $optionKey . '"',
        'class' => ' ' . $generateOptions['formsExtraClasses'] . ' ',
        'seekval' => $finalValue,
      );

      if ($main_option['type'] == 'textarea') {
        $fout .= DZSHelpers::generate_input_textarea($inputLabel, $argsForInput);
      }
      if ($main_option['type'] == 'text') {
        $fout .= DZSHelpers::generate_input_text($inputLabel, $argsForInput);
      }
      if ($main_option['type'] == 'select') {
        $argsForInput['class'] = 'dzs-style-me skin-beige ' . $generateOptions['formsExtraClasses'];
        $argsForInput['options'] = $main_option['choices'];
        $fout .= DZSHelpers::generate_select($inputLabel, $argsForInput);
      }
      if ($main_option['type'] == '{{download_capability}}') {
        include_once DZSWTL_PATH . 'inc/php/admin/admin-echo-registeredUsersCapabilityMainOption.php';
        $fout .= dzswtl_admin_echo_registeredUsersCapabilityMainOption($dzswtl, $optionKey, $main_option['title'], $main_option['sidenote']);
      }
      if ($main_option['type'] == 'checkbox') {

        $fout .= DZSHelpers::generate_input_text($inputLabel, array('id' => $inputLabel, 'val' => 'off', 'class' => 'fake-input', 'input_type' => 'hidden'));
        $fout .= '<div class="dzscheckbox skin-nova">';
        $fout .= DZSHelpers::generate_input_checkbox($inputLabel, array('id' => $inputLabel, 'val' => 'on', 'seekval' => $finalValue, 'class' => $generateOptions['formsExtraClasses']));
        $fout .= '<label for="' . $inputLabel . '"></label>';
        $fout .= '</div>';
      }
      if (isset($main_option['sidenote']) && $main_option['sidenote']) {
        $fout .= '<div class="sidenote">' . $main_option['sidenote'] . '</div>';
      }

      $fout .= '</div>';


    }
    return $fout;

  }

  static function export_svgs() {
    return array(
      'hearts' => '<svg xmlns:svg="http://www.w3.org/2000/svg" xmlns="http://www.w3.org/2000/svg" version="1.0" width="15" height="15"  viewBox="0 0 645 700" id="svg2"> <defs id="defs4" /> <g id="layer1"> <path d="M 297.29747,550.86823 C 283.52243,535.43191 249.1268,505.33855 220.86277,483.99412 C 137.11867,420.75228 125.72108,411.5999 91.719238,380.29088 C 29.03471,322.57071 2.413622,264.58086 2.5048478,185.95124 C 2.5493594,147.56739 5.1656152,132.77929 15.914734,110.15398 C 34.151433,71.768267 61.014996,43.244667 95.360052,25.799457 C 119.68545,13.443675 131.6827,7.9542046 172.30448,7.7296236 C 214.79777,7.4947896 223.74311,12.449347 248.73919,26.181459 C 279.1637,42.895777 310.47909,78.617167 316.95242,103.99205 L 320.95052,119.66445 L 330.81015,98.079942 C 386.52632,-23.892986 564.40851,-22.06811 626.31244,101.11153 C 645.95011,140.18758 648.10608,223.6247 630.69256,270.6244 C 607.97729,331.93377 565.31255,378.67493 466.68622,450.30098 C 402.0054,497.27462 328.80148,568.34684 323.70555,578.32901 C 317.79007,589.91654 323.42339,580.14491 297.29747,550.86823 z" id="path2417" style="" /> <g transform="translate(129.28571,-64.285714)" id="g2221" /> </g> </svg>',
      'icon_list' => '<svg  version="1.1"  x="0px" y="0px" viewBox="0 0 384 384" style="enable-background:new 0 0 384 384;" xml:space="preserve" width="24px" height="20px"> <g> <g> <g> <rect x="0" y="170.667" width="42.667" height="42.667" fill="#474747"/> <rect x="0" y="85.333" width="42.667" height="42.667" fill="#474747"/> <rect x="0" y="256" width="42.667" height="42.667" fill="#474747"/> <rect x="85.333" y="85.333" width="298.667" height="42.667" fill="#474747"/> <rect x="85.333" y="170.667" width="298.667" height="42.667" fill="#474747"/> <rect x="85.333" y="256" width="298.667" height="42.667" fill="#474747"/> </g> </g> </g></svg>',
      'icon_grid' => '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Capa_1" x="0px" y="0px" width="32px" height="18px" viewBox="0 0 433.5 433.5" style="enable-background:new 0 0 433.5 433.5;" xml:space="preserve"> <g> <g id="view-module"> <path d="M0,204h127.5V51H0V204z M0,382.5h127.5v-153H0V382.5z M153,382.5h127.5v-153H153V382.5z M306,382.5h127.5v-153H306V382.5z M153,204h127.5V51H153V204z M306,51v153h127.5V51H306z" fill="#363636"/> </g></svg>',
      'sort_input' => '<svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
	 width="12px" height="12px" viewBox="90.867 89.983 430.25 612.015"
	 enable-background="new 90.867 89.983 430.25 612.015" xml:space="preserve">
<path fill="#4D4E4A" d="M97.34,502.354c-8.628-8.628-8.628-22.211,0-30.839c8.336-8.336,22.211-8.336,30.527,0L284.24,627.888
	l0-516.005c0-12.029,9.561-21.9,21.589-21.9s21.9,9.871,21.9,21.9v516.005l156.08-156.372c8.628-8.336,22.521-8.336,30.839,0
	c8.628,8.628,8.628,22.211,0,30.839L321.258,695.745c-8.336,8.336-22.21,8.336-30.528,0L97.34,502.354z"/>
</svg>',
      'sort_input2' => '<svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
	 width="12px" height="12px" viewBox="90.867 89.983 430.25 612.015"
	 enable-background="new 90.867 89.983 430.25 612.015" xml:space="preserve">
<path fill="#4D4E4A" d="M514.646,289.625c8.628,8.628,8.628,22.211,0,30.839c-8.336,8.336-22.211,8.336-30.527,0L327.747,164.093
	v516.005c0,12.029-9.561,21.9-21.589,21.9c-12.028,0-21.9-9.871-21.9-21.9V164.093l-156.08,156.372
	c-8.628,8.336-22.521,8.336-30.839,0c-8.628-8.628-8.628-22.211,0-30.839l193.391-193.39c8.336-8.336,22.21-8.336,30.528,0
	L514.646,289.625z"/>
</svg>',
    );
  }

  /**
   * @param $po
   * @param $im_arrs
   * @param $thumbnailsArr
   * @param $product
   * @param $price
   * @return false|string
   */
  static function get_purchase_lightbox_html($po, $im_arrs, $thumbnailsArr, $product, $price) {

    global $dzswtl;


    // -- @void

    ob_start();


    ?>

  <div id="purchase-lightbox-<?php echo $po->ID; ?>"
       class="  purchase-lightbox-ultibox show-in-ultibox">
    <div class="dzs-row row row-for-ultibox">
      <div class="dzs-col-md-4 col-md-4">
        <div class="contentscroller auto-init bullets-right animate-height " style="width: 100%; height: auto;"
             data-options='{
    "settings_direction": "vertical",
    "settings_onlyone": "on"
}'>
          <div class="items">
            <?php

            foreach ($im_arrs as $image) {

              $imageUrl = '';

              if (isset($image['url'])) {
                $imageUrl = $image['url'];
              }
              ?>
              <div class="csc-item">
              <img class="fullwidth" src="<?php echo $imageUrl; ?>"/>
              </div><?php
            }

            ?>

          </div>
        </div><?php
        if (is_array($thumbnailsArr) && count($thumbnailsArr) > 1) {
          ?>


          <div class="contentscroller is-functional skin-nova auto-init bullets-right animate-height "
               style="width: 100%; height: 80px;" data-options='{
    "settings_direction": "horizontal"
    ,"settings_onlyone": "off"
    ,"settings_autoHeight_proportional": "off"
    ,"settings_autoHeight": "off"
    ,"nav_type": "slide"
}'>

          <div class="items">
            <?php

            foreach ($thumbnailsArr as $image) {

              $imageUrl = '';


              if (isset($image['url'])) {
                $imageUrl = $image['url'];
              }

              ?>
              <div class="csc-item">
              <div class="fullwidth divimage" style="background-image: url(<?php echo $imageUrl; ?>)"></div>
              </div><?php
            }

            ?></div></div><?php
        }
        ?>
      </div>
      <div class="dzs-col-md-8 col-md-8">
        <h3><?php echo $po->post_title; ?></h3>
        <div class="price-highlight"><span class="currency-symbol"><?php
            if (function_exists('get_woocommerce_currency_symbol')) {
              echo get_woocommerce_currency_symbol();
            }
            ?></span><span class="the-price-number"><?php echo $price; ?></span></div>

        <div class="product-small-description">
          <?php
          echo do_shortcode($po->post_content);
          ?>

        </div>
        <form class=" dzswtl--purchase-lightbox--form " method="post" enctype="multipart/form-data">
          <input type="hidden" name="add-to-cart" value="<?php echo $po->ID; ?>"/>

          <?php


          if ($product->is_type('variable')) {


            $attributes = $product->get_attributes();
            $attribute_keys = array_keys($attributes);
            $available_variations = $product->get_available_variations();;
            $variation_attributes = $product->get_variation_attributes();;


            DZSWTLHelpers::enqueue_dzsSelector();

            foreach ($variation_attributes as $lab => $val) {


              $tax = get_taxonomy($lab);


              echo '<h6 class="pa-tax-label">' . $tax->label . '</h6>';

              if (empty($available_variations) && false !== $available_variations) {
                ?>

                <?php
              } else {
                ?>
                <div class="variations" cellspacing="0">
                  <select
                    class="dzs-style-me attribute-selector  opener-listbuttons option-display-block skin-btn-secondary "
                    name="variation_id">


                    <?php

                    $extra_feeding = '';
                    foreach ($available_variations as $lab2 => $val2) {


                      $atts = $val2['attributes'];


                      foreach ($atts as $lab3 => $val3) {


                        if (strpos($lab3, $lab) !== false) {

                        } else {
                        }
                      }
                      $atts_vals = array_values($atts);


                      $variationText = $atts_vals[0];

                      echo '<option data-price="' . $val2['display_price'] . '" value="' . $val2['variation_id'] . '"></option>';
                      $extra_feeding .= '<li class="bigoption fig-position selector-btn-secondary"><span class="the-text">' . $variationText . '</span></li>';


                      ?>


                      <?php
                    };
                    ?>
                  </select>
                  <ul class="dzs-style-me-feeder"><?php echo $extra_feeding; ?></ul>
                </div>
                <?php
              };

            }


          }
          ?>
          <div class="cart-add">
            <div class="btn-border-circle decrement-val">
              <div class="icon-inside css-minus"></div>
            </div>
            <div class="quantity">
              <div class="quantity-graphic">
                <input type="text" class="input-text qty text" name="quantity" value="1" title="<?php echo esc_html__('Qty', DZSWTL_ID); ?>>" pattern="[0-9]*">
              </div>
            </div>
            <div class="btn-border-circle increment-val">
              <div class="icon-inside css-plus">

              </div>
            </div><?php

            $product = wc_get_product($po->ID);
            $addToCartText = DZSWooTableHelper::getAddToCartText($product);

            if ($addToCartText === '') {
              $addToCartText = esc_html__('Shop', DZSWTL_ID);
            }
            ?>
            <button type="submit"
                    class="dzs-button padding-big add-to-cart single_add_to_cart_button button  color-normal-highlight btn-style-default color-over-dark style-orange">
              <span class="the-bg"></span><span
                class="the-text"><?php echo $addToCartText; ?></span>
            </button>
          </div>
        </form>
      </div><!-- end .col-md-8-->
    </div>
    </div><?php


    return ob_get_clean();
  }

  static function get_all_checks_from_get_treatWooMinAndMax($lab, $fulllab, $fullval, $dzswtl, &$margs) {


    if (strpos($lab, DZSWTL_QUERY_MINIMUM_ABBREVIATION) !== false) {

      // -- woomin

      $lab = str_replace(DZSWTL_QUERY_MINIMUM_ABBREVIATION, '', $fulllab);


      if (isset($temp_ranges_arr[$lab]) && isset($temp_ranges_arr[$lab]['max'])) {

        $margs[$lab] = $fullval . DZSWTL_QUERY_WITHIN_ABBREVIATION . $temp_ranges_arr[$lab]['max'];
      } else {
        $temp_ranges_arr[$lab] = array(
          'min' => $fullval,
          'max' => '',
        );


        $margs[$lab] = $fullval . 'wtn-wtninfinite';
      }

      unset($dzswtl->all_checks[$fulllab]);


    } elseif (strpos($lab, DZSWTL_QUERY_MAXIMUM_ABBREVIATION) !== false) {

      // -- woomax


      $lab = str_replace(DZSWTL_QUERY_MAXIMUM_ABBREVIATION, '', $lab);

      if (isset($temp_ranges_arr[$lab]) && isset($temp_ranges_arr[$lab]['max'])) {

        $margs[$lab] = $temp_ranges_arr[$lab]['min'] . DZSWTL_QUERY_WITHIN_ABBREVIATION . $dzswtl->all_checks[$fulllab];
      } else {
        $temp_ranges_arr[$lab] = array(
          'max' => $fullval,
          'min' => '',
        );
        $margs[$lab] = '0' . DZSWTL_QUERY_WITHIN_ABBREVIATION . $fullval;
      }

      unset($dzswtl->all_checks[$fulllab]);

    } else {

      // -- final else

      $margs[$lab] = $fullval;
    }
  }

  static function get_all_checks_from_get() {

    global $dzswtl;


    // -- @void


    $dzswtl->all_checks = array(); // -- all checks for product attributes
    if (isset($_GET)) {
      // -- margs are shortcode attributes .. hard set
      $dzswtl->all_checks = array_merge($_GET, array());
    }
    $temp_ranges_arr = array();


    // -- all checks include pa
    foreach ($dzswtl->all_checks as $lab => $val) {


      // -- destroy wrong vals
      if (strpos($lab, DZSWTL_QUERY_META_VALUE_ABBREVIATION . 'metapa_' . DZSWTL_QUERY_META_VALUE_ABBREVIATION . 'metapa') === 0) {
        // -- obviously wrong
        $wrong_lab = $lab;
        $lab = str_replace(DZSWTL_QUERY_META_VALUE_ABBREVIATION . 'metapa_' . DZSWTL_QUERY_META_VALUE_ABBREVIATION . 'metapa', DZSWTL_QUERY_META_VALUE_ABBREVIATION . 'metapa', $lab);
        $dzswtl->all_checks[$lab] = $val;
        // -- delete wrong labs
        unset($dzswtl->all_checks[$wrong_lab]);
      }
      // -- destroy wrong vals END


      // -- if we have get meta value it is okay ;)
      if (strpos($lab, DZSWTL_QUERY_META_VALUE_ABBREVIATION) === 0) {

        $fulllab = $lab;
        $fullval = $dzswtl->all_checks[$fulllab];

        DZSWooTableHelper::get_all_checks_from_get_treatWooMinAndMax($lab, $fulllab, $fullval, $dzswtl, $margs);

      }


      if ($lab == 'subcat') {
        $margs[$lab] = $val;
      }
      if (strpos($lab, DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION) === 0) {


        // -- if it is custom tax


        $lab_sanitized = str_replace(DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION, '', $lab);

        $term_taxonomy = $lab_sanitized;

        $term_slug = $val;
        $term_id = $term_slug;


        $term_slug = explode(',', $term_slug);


        foreach ($term_slug as $lab2 => $val2) {
          $term = get_term_by('slug', $val2, $term_taxonomy);
          if ($term && isset($term->term_id)) {
            $term_id = $term->term_id;
          }
        }


        // -- todo: why do we need this ?


        // -- what do we do with margs ?
        $margs[$lab] = $val;


      }
    }


  }

  static function deprecated_generateMainOptionsFromConfig($arr_options) {
    global $dzswtl;
    foreach ($arr_options as $labmain => $val) {

      $fout = '';

      $fout .= '
        

        <div class="dzs-tab-tobe">
          <div class="tab-menu with-tooltip">
            <i class="' . $val['icon'] . '"></i> ' . $val['label'] . '
          </div>
          <div class="tab-content">';

      foreach ($val['items'] as $labitem => $item) {

        $fout .= '<div class="setting">';

        if ($item['type'] == 'checkbox') {
          $lab = $labitem;


          $value = '';

          if (isset($dzswtl->db_mainoptions[$lab]) && $dzswtl->db_mainoptions[$lab]) {
            $value = $dzswtl->db_mainoptions[$lab];
          }

          $fout .= DZSHelpers::generate_input_text($lab, array(
            'id' => $lab,
            'val' => 'off',
            'input_type' => 'hidden'
          ));

          $fout .= '<h4 class="setting-label">';
          $fout .= $item['label'];
          $fout .= '</h4>';
          $fout .= '<div class="dzscheckbox skin-nova">';
          $fout .= DZSHelpers::generate_input_checkbox($lab, array('id' => $lab,
            'val' => 'on',
            'seekval' => $value
          ));
          $fout .= '<label for="' . $lab . '"></label>';
          $fout .= '</div>';

          if (isset($item['sidenote']) && $item['sidenote']) {

            $fout .= '<div class="sidenote">' . $item['sidenote'] . '</div>';
          }


        }


        $fout .= '</div>';


      }

      $fout .= '</div></div>';

      $fout .= '
        <div class="dzs-tab-tobe tab-disabled">
          <div class="tab-menu ">
            &nbsp;&nbsp;
          </div>
          <div class="tab-content">


          </div>
        </div>';

      echo $fout;
    }

  }

  static function generate_str_dzswtl_import_layout($base_url, $lab, $str_lab = '') {


    ob_start();
    ?>
    <div class="dzs-col-md-4">
    <div class="dzswtl-import-layout" data-layout-name="<?php echo $lab; ?>">

      <div class="divimage fullwidth  "
           style="background-image: url(<?php echo $base_url; ?>sampledata/img/<?php echo $lab; ?>.jpg)"></div>
      <?php
      if ($str_lab) {
        ?>
        <div class="import-layout--label"><?php echo $str_lab; ?></div><?php
      }
      ?>
    </div>
    </div><?php

    $fout = ob_get_clean();


    return $fout;
  }
}