<?php

function dzswtl_view_sorter($pargs) {

  $margs = array(

    'style_float' => '', // -- not recommended float.. use flex ;)
    'flex_align' => "",
    'flex_width' => "",
    'options' => "newest-to-oldest,oldest-to-newest,cheap-to-expensive,expensive-to-cheap",


  );


  if (is_array($pargs)) {

    $margs = array_merge($margs, $pargs);
  }


  $fout = '';

  $lab = 'woo_sort';


  $fout .= '<div class="woo-table-sorter';


// -- you can cover
  if ($margs['flex_width']) {
    $fout .= ' flex-width-' . $margs['flex_width'];
  }

  if ($margs['flex_align']) {
    $fout .= ' flex-align-' . $margs['flex_align'];
  }

  $fout .= '" style="';


  if ($margs['style_float']) {
    $fout .= ' float: ' . $margs['style_float'] . ';';
  }


  $fout .= dzswtl_generate_style_for_flex($margs);

  $fout .= '"">';


  $opts = array();

  $seekval = '';

  if(isset($_GET['sort_by']) && $_GET['sort_by']){
    $seekval = $_GET['sort_by'];
  }

  $options_string_arr = explode(',', $margs['options']);

  foreach ($options_string_arr as $opt) {
    $label = $opt;
    $val = $opt;

    if ($opt == 'date{desc}') {
      $label = esc_html__("Newest to oldest", DZSWTL_ID);


      if (isset($_GET['orderby']) && $_GET['orderby'] == 'date' && isset($_GET['order']) && $_GET['order'] == 'desc') {

        $seekval = $val;
      }
    }
    if ($opt == 'date{asc}') {
      $label = esc_html__("Oldest to newest", 'dzswtl');


      if (isset($_GET['orderby']) && $_GET['orderby'] == 'date' && isset($_GET['order']) && $_GET['order'] == 'asc') {

        $seekval = $val;
      }
    }
    if ($opt == 'price{asc}') {
      $label = esc_html__("Low Price to High Price", DZSWTL_ID);
    }
    if ($opt == 'price{desc}') {
      $label = esc_html__("High Price to Low Price", DZSWTL_ID);


      if (isset($_GET['orderby']) && $_GET['orderby'] == 'price' && isset($_GET['order']) && $_GET['order'] == 'desc') {

        $seekval = $val;
      }
    }
    if ($opt == 'rand{asc}' || $opt == 'rand{desc}') {

      $label = esc_html__("Random", DZSWTL_ID);
    }
    if ($opt == 'alphabetical{asc}') {
      $label = esc_html__("Alphabetical", DZSWTL_ID);
      if (isset($_GET['orderby']) && $_GET['orderby'] == 'title') {
        $seekval = $val;
      }
    }
    if ($opt == 'alphabetical{desc}') {
      $label = esc_html__("Alphabetical Reversed", DZSWTL_ID);


      if (isset($_GET['orderby']) && $_GET['orderby'] == 'title' && isset($_GET['order']) && $_GET['order'] == 'desc') {

        $seekval = $val;
      }
    }
    if ($opt == 'ratings_score{asc}') {
      $label = esc_html__("Most popular", DZSWTL_ID);
      if (isset($_GET['orderby']) && $_GET['orderby'] == 'ratings_score') {
        $seekval = $val;
      }
    }
    if ($opt == 'ratings_score{desc}') {
      $label = esc_html__("Least popular", DZSWTL_ID);


      if (isset($_GET['orderby']) && $_GET['orderby'] == 'ratings_score' && isset($_GET['order']) && $_GET['order'] == 'desc') {

        $seekval = $val;
      }
    }


    // -- starts with pa_
    if (strpos($opt, DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) === 0) {


      $taxonomy_name = preg_replace("/{.*?}/", "", $opt);;

      $tax = get_taxonomy($taxonomy_name);

      $label = $tax->label;


      preg_match("/{.*?}/", $opt, $output_array);


      if (isset($output_array[0])) {
        if ($output_array[0] == '{asc}') {
          $label .= ' ' . esc_html__("ascending", DZSWTL_ID);


          if (isset($_GET['orderby']) && $_GET['orderby'] == $taxonomy_name) {
            if (isset($_GET['order']) && $_GET['order'] == 'asc') {

              $seekval = $val;
            }
          }
        }
        if ($output_array[0] == '{desc}') {
          $label .= ' ' . esc_html__("descending", DZSWTL_ID);


          if (isset($_GET['orderby']) && $_GET['orderby'] == $taxonomy_name) {
            if (isset($_GET['order']) && $_GET['order'] == 'desc') {

              $seekval = $val;
            }
          }
        }
      }




    }

    $aux = array(
      'label' => $label,
      'value' => $val,
    );

    array_push($opts, $aux);


  }


  $fout .= DZSHelpers::generate_select($lab, array(
    'class' => 'dzs-style-me skin-beige do-not-trigger-change-on-init do-not-trigger-change-on-reinit',
    'options' => $opts,
    'seekval' => $seekval,
  ));

  $fout .= '</div>';

  DZSWTLHelpers::enqueue_dzsSelector();
  return $fout;

}