/**
 * Block dependencies
 */

// import classnames from 'classnames'; 2

/**
 * Internal block libraries
 */


import './block-shop.scss';
import * as configSampleData from '../configs/sampledata-playlists';
import * as helpers from './js_common/_helpers';


import CustomInspectorControls from './js_common/CustomInspectorControls';
import BlockShop from './js_dzsap/BlockShop';

const key_block = 'dzswtl/gutenberg-block';

// import SamplesHolder from './js_dzsap/SamplesHolder';
let __ = (arg) => {
  return arg;
};


if (wp.i18n) {
  __ = wp.i18n.__;
}

const {registerBlockType} = wp.blocks;

const {
  InspectorControls
} = wp.blockEditor;


/**
 * Register block
 */

let player_inspector_controls = null;



// console.info('player_attributes - ',player_attributes);
export default registerBlockType(key_block, {
  // Block Title
  title: __('Shop layout'),
  // Block Description
  description: __('Customizable woocommerce shop layout'),
  // Block Category
  category: 'common',
  // Block Icon
  icon: 'format-audio',
  // Block Keywords
  keywords: [
    __('Shop'),
    __('Table'),
    __('List'),
    __('Sound'),
  ],
  attributes: window.dzswtl_gutenberg_block_settings,
  // Defining the edit interface
  edit: props => {
    const {
      attributes
    } = props;


    let uploadButtonLabel = __('Upload');

    if (props.attributes.dzsap_meta_item_source || props.attributes.source) {
      uploadButtonLabel = __('Select another upload');
    }

    // console.info('window.dzswtl_gutenberg_block_settings - ', window.dzswtl_gutenberg_block_settings);


    // console.log('lets wee what props we have',props); 2


    player_inspector_controls = (
      <CustomInspectorControls
        arr_options={window.dzswtl_gutenberg_block_settings}
        uploadButtonLabel={uploadButtonLabel}
        {...props}
      />
    );

    // console.info('player_inspector_controls- ',player_inspector_controls);






    const cpt_posts = window.dzswtl_settings.cpt_posts;
    // console.log('cpt_posts -5 ' , cpt_posts);
    // console.log('props - ' , props);
    // console.log('props -5 ',props);
    let selectedPostId = '';


    if (props.attributes.layout) {
      cpt_posts.forEach((arg) => {
        // console.log('arg cpt_post for layout search- ',arg);
        if (props.attributes.layout === arg.value) {
          selectedPostId = arg.term_id;
        }
      })
    }
    let editUrl = helpers.add_query_arg(dzswtl_settings.admin_url+'post.php', 'post',selectedPostId);//helpers.add_query_arg(dzswtl_settings.admin_url, 'taxonomy','dzsap_sliders');
    editUrl = helpers.add_query_arg(editUrl, 'action','edit');
    return [
      !!props.isSelected && (
        <InspectorControls key="inspector">
          {player_inspector_controls}
        </InspectorControls>
      ),
      <div className={props.className}>
        <BlockShop
          mainprops={props}
          cpt_posts={cpt_posts}
          editUrl={editUrl}
          key_block={key_block}
          player_inspector_controls={player_inspector_controls}
        />
      </div>
    ];
  },

  save() {
    // -- Rendering in PHP
    return null;
  },
});
