import React from 'react';

const {
  TextControl,
  SelectControl,
} = wp.components;

let __ = (arg) => {
  return arg;
};

if (wp.i18n) {
  __ = wp.i18n.__;
}
const {
  PlainText,
  MediaUpload
} = wp.editor;

export default class CustomInspectorControls extends React.Component {
  constructor(props) {
    super(props);
    this.props = props;
    // console.log('this.props - ', this.props);
  }

  render() {

    const ALLOWED_MEDIA_TYPES = ['audio'];
    let uploadSongLabel = __('Upload song');

    // const self = this;
    // console.log('CustomInspectorControls this.props - , ', this.props)
    return Object.keys(this.props.arr_options).map((key) => {

      const props = this.props;
      let option_array = this.props.arr_options[key];
      // console.log('this - ', this);
      // console.log('option_array - ', option_array);

      // console.log('option_array - ', option_array);
      if (key === 'layout' || key === 'source' || key === 'item_source') {
        return '';
      }

      if (key === 'cat'){
        option_array.options = dzswtl_settings.cats;
      }

      var args = {
          label: option_array.title,
          value: props.attributes[key] ? props.attributes[key] : '',
          instanceId: key,
          onChange: (value) => {
            props.setAttributes({[key]: value});
          }
          // onChange: (e,arg2) => {console.info(this, e,arg2); onValueChange(e,this)}
        }
      ;


      let Sidenote = null;

      if (option_array.sidenote) {
        Sidenote = (
          <div className="sidenote" dangerouslySetInnerHTML={{__html: option_array.sidenote}}/>
        )
      }


      if (option_array.type == 'text') {
        const divAtts = {
          className: "zoomsounds-inspector-setting type-"
        };

        divAtts.className += option_array.type;
        return (
          <div {...divAtts}>
            <TextControl
              {...args}
            />
            {Sidenote}
          </div>
        )
          ;
      }
      if (option_array.type == 'select') {

        if (option_array.choices && !(option_array.options)) {
          option_array.options = option_array.choices;
        }

        // delete args.instanceId ;

        // args.options = option_array.options;
        // console.info('select args - ',args);
        // console.info('option_array.options - ',option_array.options);
        const divAtts = {
          className: "zoomsounds-inspector-setting type-"
        };

        divAtts.className += option_array.type;
        return (
          <div {...divAtts}>
            <SelectControl
              {...args}
              options={option_array.options}
            />
            {Sidenote}
          </div>

        )
          ;
      }


      if (option_array.type == 'attach') {

        if (option_array.upload_type) {

          // args.type = option_array.upload_type;
          args.allowedTypes = [option_array.upload_type];
        }
        args.onChange = null;


        if (props.attributes[key]) {
          uploadSongLabel = __('Select another upload');
        }

        return (
          <div className="zoomsounds-inspector-setting type-attach">
            <label className="components-base-control__label">{option_array.title}</label>
            <MediaUpload
              {...args}
              onSelect={(imageObject) => {
                props.setAttributes({[key]: imageObject.url});
                console.log('imageObject - ', imageObject);
                console.info(' props - ', props);
              }}
              render={({open}) => (
                <div className="render-song-selector">
                  {props.attributes[key] ? (
                    <PlainText
                      format="string"
                      formattingControls={[]}
                      placeholder={__('Input song name')}
                      onChange={(val) => props.setAttributes({[key]: val})}
                      value={props.attributes[key]}
                    />
                  ) : ""}
                  <button className="button-secondary" onClick={open}>{this.props.uploadButtonLabel}</button>
                </div>
              )}
            />
          </div>
        )
          ;
      }


    });

  }
}