<?php
include_once(DZSWTL_PATH . 'inc/php/ajax-functions.php');

class DZSWTLAjax {

  function __construct($dzswtl) {

    $this->dzswtl = $dzswtl;


    add_action('init', array($this, 'handle_init'), 5);
    add_action('init', array($this, 'handle_init_end'), 999);

    add_action('wp_ajax_dzswtl_ajax_mo', array($this, 'post_save_mo'));
    add_action('wp_ajax_dzswtl_listBuilder_previewFout', array($this, 'ajax_dzswtl_prev_array'));
    add_action('wp_ajax_dzswtl_quick_save_layout', array($this, 'ajax_quick_save_layout'));
    add_action('wp_ajax_ dzswtl_generate_attribute_sort', array($this, 'ajax_generate_attribute_sort'));
    add_action('wp_ajax_dzswtl_con_generator_preview_shortcode', array($this, 'ajax_con_generator_preview_shortcode'));
    add_action('wp_ajax_dzswtl_import_layout', array($this, 'ajax_import_layout'));

    add_action('wp_ajax_dzswtl_add_to_wishlist', array($this, 'ajax_add_to_wishlist'));
    add_action('wp_ajax_nopriv_dzswtl_add_to_wishlist', array($this, 'ajax_add_to_wishlist'));


    add_action('template_redirect', array($this, 'handle_template'));
  }

  function handle_init() {
    $anyAllowedCharacter = '([\w\.]+)';


    add_rewrite_tag('%' . DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT . '%', $anyAllowedCharacter);
//    error_log('\'ajax-api/\'.DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT.\'/\'.$anyAllowedCharacter.\'/?\' - '.'ajax-api/'.DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT.'/'.$anyAllowedCharacter.'/?');
//    error_log('\'index.php?\'.DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT.\'=$matches[1]\''.'index.php?'.DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT.'=$matches[1]');

    add_rewrite_rule('ajax-api/' . DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT . '/' . $anyAllowedCharacter . '/?', 'index.php?' . DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT . '=$matches[1]', 'top');
  }

  /**
   * ajax redirects
   */
  function handle_template() {

    global $wp_query;

    if ($wp_query->query && isset($wp_query->query[DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT]) && $wp_query->query[DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT] === DZSWTL_AJAX_KEY_LOAD_NEW_CONTENT) {

      $this->load_new_content();

      die();


    }
    if ($wp_query->query && isset($wp_query->query[DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT]) && $wp_query->query[DZSWTL_AJAX_KEY_GENERAL_AJAX_ENDPOINT] === DZSWTL_AJAX_KEY_LOAD_FILTER_COUNT) {


      echo $this->load_filter_availability();


      die();
    }

  }

  /**
   * @return string this will just return the ids which have each filter . count calculation is done on javascript
   */
  function load_filter_availability() {



    $taxonomiesFromPost = json_decode(stripslashes($_POST['postdata']), true);
    $finalTermsAggregated = array();

    foreach ($taxonomiesFromPost as $taxonomyName) {
      $finalTermsAggregated[$taxonomyName] = array();

      $terms = get_terms($taxonomyName, array(
        'hide_empty' => false,
      ));


      $termsIds = array();
      $termIdsArray = array();


      foreach ($terms as $term) {
        array_push($termsIds, $term->term_id);
      }


      global $wpdb;


      $sqlQuery = "SELECT SQL_CALC_FOUND_ROWS {$wpdb->prefix}posts.ID,{$wpdb->prefix}term_relationships.term_taxonomy_id
FROM {$wpdb->prefix}posts
INNER JOIN {$wpdb->prefix}term_relationships ON ({$wpdb->prefix}posts.ID = {$wpdb->prefix}term_relationships.object_id)

WHERE ( {$wpdb->prefix}term_relationships.term_taxonomy_id IN (".esc_sql(implode(',',$termsIds)).") )
AND {$wpdb->prefix}posts.post_type IN ('post', 'page', 'attachment', 'dzsap_items', 'product', 'dzswtl_list_layout')
AND ({$wpdb->prefix}posts.post_status = 'publish')
GROUP BY {$wpdb->prefix}posts.ID ORDER BY {$wpdb->prefix}posts.post_date DESC LIMIT 0, 300000";



      $results = $wpdb->get_results(
        $sqlQuery
      );





      foreach ($results as $result){


        if(isset($termIdsArray[$result->term_taxonomy_id]) && is_array($termIdsArray[$result->term_taxonomy_id])){
          array_push($termIdsArray[$result->term_taxonomy_id], $result->ID);
        }else{
          $termIdsArray[$result->term_taxonomy_id] = array($result->ID);
        }
      }

      $finalTermsAggregated[$taxonomyName] = $termIdsArray;
    }


    return json_encode($finalTermsAggregated);
  }

  /**
   * load new content based on $_POST
   * echoes result
   */
  function load_new_content() {
    global $dzswtl;

    // -- load new content
    error_reporting(0);
    add_filter('posts_search', array($dzswtl, 'filter_posts_search_include_tags'), 500, 2);


    if (isset($_POST['postdata'])) {
      try {
        $args = json_decode(stripslashes($_POST['postdata']), true);




        if (isset($args['cookie_set_posts_per_page']) && $args['cookie_set_posts_per_page'] == 'on' && isset($args['posts_per_page']) && $args['posts_per_page']) {

          // -- we set cookie to remembers

          @setcookie('dzswtl_posts_per_page_' . $args['called_from_post_id'], $args['posts_per_page'], time() + DZSWTL_COOKIE_DURATION, COOKIEPATH, COOKIE_DOMAIN);
        }
        if (isset($args['cookie_set_layout']) && $args['cookie_set_layout'] == 'on' && isset($args['layout']) && $args['layout']) {

          // -- we set cookie to remembers

          @setcookie('dzswtl_layout_' . $args['called_from_post_id'], $args['layout'], time() + DZSWTL_COOKIE_DURATION, COOKIEPATH, COOKIE_DOMAIN);

        }
        // -- we return_only_items to on
        $args['called_from'] = 'check_posts()';
        if (isset($_POST['userSetFilters'])) {
          $args['userSetFilters'] = $_POST['userSetFilters'];
        }
        echo dzswtl_shortcode_woo_table($args);

      } catch (Exception $e) {
        error_log('no json ' . print_rr($e));
      }
    }
  }

  function ajax_load_new_content() {


    $this->load_new_content();

    die();
  }

  function handle_init_end() {

    $this->check_posts();
  }

  function check_posts() {

    // -- call in init_end
    $dzswtl = $this->dzswtl;

    if (isset($_GET['dzswtl_action'])) {

      if ($_GET['dzswtl_action'] == 'load_subcats') {


        $term_parent = $_POST['postdata'];


        $taxonomy = DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY;
        $term_parent_id = DZSWTLHelpers::sanitize_term_slug_to_id($term_parent, $taxonomy);



        $terms = get_terms($taxonomy, array(
          'hide_empty' => false,
          'parent' => $term_parent_id,
        ));



        echo json_encode($terms);

        die();

      }


      // -- *deprecated
      if ($_GET['dzswtl_action'] == 'load_new_content') {
        // -- load_new_content / load new content
        $this->load_new_content();
        die();
      }
    }

    if (isset($_POST['dzswtl_action'])) {
      if ($_POST['dzswtl_action'] == 'delete_sample_data') {


        $the_slug = 'preview-post-1';
        $args = array(
          'name' => $the_slug,
          'post_type' => 'any',
          'post_status' => 'any',
          'numberposts' => 1
        );
        $my_posts = get_posts($args);
        if ($my_posts) {
          wp_delete_post($my_posts[0]->ID);
        }


        $the_slug = 'preview-post-2';
        $args = array(
          'name' => $the_slug,
          'post_type' => 'any',
          'post_status' => 'any',
          'numberposts' => 1
        );
        $my_posts = get_posts($args);
        if ($my_posts) {
          wp_delete_post($my_posts[0]->ID);
        }

        $taxonomy = DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY;
        $category = get_term_by('slug', DZSWTL_POST_STATUS_PREVIEW, $taxonomy);


        wp_delete_term($category->term_id, $taxonomy);
      }
    }




    global $dzsap;


    if (isset($_GET['action'])) {
      // -- download get
      if ($_GET['action'] == DZSWTL_QUERY_KEY_DOWNLOAD_TRACK) {
        dzswtl_ajax_download_action($dzswtl);
        die();
      }
    }

  }


  function post_save_mo() {

    $auxarray_defs = array('disable_api_caching' => 'off', 'disable_fontawesome' => 'off', 'tinymce_enable_preview_shortcodes' => 'off', 'force_file_get_contents' => 'off', 'debug_mode' => 'off', 'settings_trigger_resize' => 'off', 'replace_wpvideo' => 'off',
      'usewordpressuploader' => 'on',
      'dzsvp_enable_visitorupload' => 'off',
      'dzsvp_enable_ratings' => 'off',
      'dzsvp_enable_ratingscount' => 'off',
    );
    $auxarray = array();
    //parsing post data
    parse_str($_POST['postdata'], $auxarray);


    $auxarray = array_merge($auxarray_defs, $auxarray);


    $lab = 'dzsvp_enable_user_upload_capability';




    $auxarray = array_merge($this->dzswtl->db_mainoptions, $auxarray);


    update_option($this->dzswtl->dbname_mainoptions, $auxarray);
    die();
  }

  function ajax_dzswtl_prev_array() {



    parse_str($_POST['postdata'], $arr_data);



    echo dzswtl_shortcode_woo_table(array(
      'layout' => $arr_data,
      'called_from' => 'ajax_dzswtl_prev_array',
      'get_preview_data' => 'on',
    ));


    die();

  }

  function ajax_quick_save_layout() {


    // Update post 37
    $my_post = array(
      'ID' => $_POST['post_id'],
      'post_content' => $_POST['postdata'],
    );


    wp_update_post($my_post);


    die();

  }

  /**
   * postdata (postdata: pa_bpm)
   * genreates
   */
  function ajax_generate_attribute_sort() {


    $args = array(
      'post_type' => 'product',
      'posts_per_page' => -1,
    );

    $query = new WP_Query($args);
    $pos = $query->posts;

    $pa_slug = $_POST['postdata'];
    $taxonomy = $pa_slug;


//		// -- todo: find the order in which to order ? default by number value

    if (is_array($pos) && count($pos)) {
      foreach ($pos as $po) {


        $po_terms = wp_get_post_terms($po->ID, $taxonomy);
        if (is_array($po_terms) && count($po_terms)) {
          update_post_meta($po->ID, DZSWTL_DB_TAX_TO_META_ABBREVIATION . $taxonomy, $po_terms[0]->name);
        }

      }
    }


    die();
  }


  function ajax_con_generator_preview_shortcode() {


    echo do_shortcode(stripslashes($_POST['postdata']));
    die();
  }


  function ajax_import_layout() {


    $sampleLayoutKey = $_POST['postdata'];

    $sampleLayouts = include_once(DZSWTL_PATH . '/configs/config-sample-layouts.php');

    $postTitle = $sampleLayouts[$sampleLayoutKey]['title'];


    $path = DZSWTL_PATH . "sampledata/" . $sampleLayoutKey . '.txt';


    error_log(' path - ' . $path);
    error_log(' $postTitle - ' . $postTitle);
    if (file_exists($path)) {

      $content = file_get_contents($path, true);
      error_log(' $content - ' . $content);


      if ($sampleLayoutKey == 'e-pro-sounds') {
        $path2 = 'sampledata/dzsap-slider-pro-sounds.txt';
        $content2 = file_get_contents($path2, true);

        global $dzsap;

        if ($dzsap) {

          $isGoingToImport = true;
          $slider = unserialize($content2);

          foreach ($dzsap->mainitems_configs as $mainitem) {


            if ($slider['settings']['id'] === $mainitem['settings']['id']) {

              $isGoingToImport = false;
            }
          }


          if ($isGoingToImport) {
            array_push($dzsap->mainitems_configs, $slider);
            error_log('mainitems_configs - ' . print_r($dzsap->mainitems_configs, true));
            update_option($dzsap->dbname_mainitems_configs, $dzsap->mainitems_configs);
          }
        }


      }

      $this->dzswtl->import_demo_insert_post_complete(array(
        'post_content' => $content,
        'post_title' => $postTitle,
      ));

      $ajaxResponse = array(
        'status_txt' => esc_html__('Imported layout', DZSWTL_ID),
        'status' => 'success',
      );


      if (!$content) {

        $ajaxResponse = array(
          'status_txt' => esc_html__('Layout empty', DZSWTL_ID),
          'status' => 'error',
        );
      }
    } else {

      $ajaxResponse = array(
        'status_txt' => esc_html__('Layout not found', DZSWTL_ID),
        'status' => 'error',
      );
    }


    echo json_encode($ajaxResponse);

    die();
  }

  function ajax_add_to_wishlist() {


    $arr_wishlist = DZSWTLHelpers::get_wishlist();


    if ($_POST['wishlist_action'] == 'add') {

      if (in_array($_POST['playerid'], $arr_wishlist) == false) {

        array_push($arr_wishlist, $_POST['playerid']);
      }

    } else {

      foreach ($arr_wishlist as $lab => $val) {
        if ($val == $_POST['playerid']) {
          unset($arr_wishlist[$lab]);
        }
      }
    }


    if (get_current_user_id()) {

      update_user_meta(get_current_user_id(), DZSWTL_POST_META_WISHLIST_NAME, json_encode($arr_wishlist));
    } else {


      @setcookie(DZSWTL_COOKIE_WISHLIST_NAME, json_encode($arr_wishlist), time() + (30 * 24 * 3600), COOKIEPATH, COOKIE_DOMAIN);
    }


    die();
  }


}