<?php

/**
 * @param DZSWooTable $dzswtl
 * @param $lab
 * @param $title
 * @param $sidenote
 */
function dzswtl_admin_echo_registeredUsersCapabilityMainOption($dzswtl, $lab, $title, $sidenote) {

  ob_start();
  $dependency = array(
    array(
      'element' => 'allow_download_only_for_registered_users',
      'value' => array('on'),
    ),
  );
  ?>
  <?php


  $seekval = 'read';

  if ($dzswtl->db_mainoptions[$lab]) {
    $seekval = $dzswtl->db_mainoptions[$lab];
  }


  $opts = array(
    array(
      'label' => __("Subscriber"),
      'value' => 'read'
    ),
    array(
      'label' => __("Contributor"),
      'value' => 'edit_posts'
    ),
    array(
      'label' => __("Author"),
      'value' => 'edit_published_posts',
    ),

  );
  $opts_default = $opts;

  $optsAllCaps = array();
  $all_caps = get_role('administrator')->capabilities;
  foreach ($all_caps as $keyCap => $valCap) {
    if ($keyCap != 'read' && $keyCap != 'edit_posts' && $keyCap != 'edit_published_posts') {
      array_push($optsAllCaps, array(
        'label' => $keyCap,
        'value' => $keyCap,
      ));
    }
  }

  global $wp_roles;
  $roles = $wp_roles->roles;

  ?>
  <select name="<?= $lab ?>" class=" dzs-style-me skin-beige ">
    <optgroup label="<?= esc_html__("Default roles", DZSWTL_ID) ?>"><?php
      $fout = '';
      foreach ($opts_default as $key => $valOpt) {

        $fout .= '<option value="' . $valOpt['value'] . '"';
        if ($seekval != '' && $seekval == $valOpt['value']) {
          $fout .= ' selected';
        }

        $fout .= '>' . $valOpt['label'] . '</option>';
      }
      echo $fout;
      ?></optgroup>
    <optgroup label="<?= esc_html__("Site Roles", DZSWTL_ID) ?>"><?php
      $fout = '';
      foreach ($roles as $key => $valOpt){

        if($key==='subscriber' || $key==='author'){
          continue;
        }
        $fout .= '<option value="' . $key . '"';
        if ($seekval != '' && $seekval == $key) {
          $fout .= ' selected';
        }

        $fout .= '>' . $valOpt['name'] . '</option>';
      }
      echo $fout;
      ?></optgroup>
    <optgroup label="<?= esc_html__("Custom permissions", DZSWTL_ID) ?>"><?php
      $fout = '';
      foreach ($optsAllCaps as $key => $valOpt) {

        $fout .= '<option value="' . $valOpt['value'] . '"';
        if ($seekval != '' && $seekval == $valOpt['value']) {
          $fout .= ' selected';
        }

        $fout .= '>' . $valOpt['label'] . '</option>';
      }
      echo $fout;
      ?></optgroup>
  </select>
<?php

  return ob_get_clean();
}