<?php

/**
 * @param DZSWooTable $dzswtl
 */
function dzswtl_ajax_download_action($dzswtl) {
  if (isset($_GET['id']) && $_GET['id']) {
    $downloadPost = get_post($_GET['id']);
    $fileTitle = 'song';


    if ($downloadPost && $downloadPost->post_title) {
      $fileTitle = $downloadPost->post_title;
    }
    if (isset($dzswtl->db_mainoptions['rpwcm_download_with_it']) && $dzswtl->db_mainoptions['rpwcm_download_with_it'] === 'on' && $dzswtl->dzswtl_plugin_rpwcm !== null) {
      // -- external WooCommerce Memberships plugin
      $dzswtl->dzswtl_plugin_rpwcm->checkIfUserCanDownloadAndDenyIfNot($downloadPost);
    }

    if (function_exists('WC') && defined('DZSPSY_VERSION')) {
      // -- dzspoint system

      global $dzspsy;

      $postId = $_GET['id'];

      if ($dzspsy->db_mainoptions && isset($dzspsy->db_mainoptions['dzswtl_downloads_pay_by_points']) && $dzspsy->db_mainoptions['dzswtl_downloads_pay_by_points'] === 'on') {

        $currentUserId = get_current_user_id();

        if ($currentUserId) {

          $isAlreadyDownloaded = DZSWTLHelpers::view_isProductDownloaded($postId);


          if ($isAlreadyDownloaded) {

          } else {

            $canDownload = DZSWTLHelpers::view_canUserDownload(1, array(
              'subtotal' => 1
            ));
            if ($canDownload['can_download']) {
              // -- continue
              $deductable_points = 1;
              $count = 0;
              if ($dzspsy) {
                $count = $dzspsy->classDb->get_points();
              }
              if ($count) {

                $dzspsy->classDb->set_points($count - $deductable_points);
                $dzspsy->classDb->db_addUserDownloadedTrack($postId);
                $dzspsy->classDb->add_points_history_entry(array(
                  'title' => esc_html__('Spent ( via download )', DZSWTL_ID) . ' ' . '<strong>' . $deductable_points . '</strong>' . ' ' . esc_html__('points for order ', DZSWTL_ID) . '<strong>' . $postId . '</strong>',
                  'type' => 'substract',
                  'amount' => $deductable_points,
                ));
              }
            } else {
              die($canDownload['can_download_status']);
            }

          }
        }
      }
    } else {

      if (isset($downloadPost->ID)) {
        DZSWTLHelpers::db_addUserDownloadedTrack($downloadPost->ID);
      }
    }


    $isCanDownload = DZSWTLHelpers::productIsDownloadable($downloadPost);

    if (!$isCanDownload) {
      if ($dzswtl->db_mainoptions['downloads_restrict_redirect_url']) {
        wp_redirect($dzswtl->db_mainoptions['downloads_restrict_redirect_url']);
      } else {
        die('Restricted download');
      }
    }

    $downloadFileUrl = DZSWTLHelpers::productGetDownloadUrl($downloadPost);


    $fileExtension = 'mp3';
    $content_type = 'application/octet-stream';

    // -- dzs ap download
    if (strpos($downloadFileUrl, '.m4a') !== false) {
      $fileExtension = 'm4a';
      $content_type = 'audio/mp4';
    }
    if (strpos($downloadFileUrl, '.wav') !== false) {
      $fileExtension = 'wav';
      $content_type = 'audio/wav';
    }


    header("Pragma: public");
    header("Expires: 0");
    header("Content-Type: '.$content_type.'");
    header("Content-Disposition: attachment; filename=\"" . strtolower($fileTitle) . "." . $fileExtension . "\"");
    header("Content-Transfer-Encoding: binary");




    if ($isCanDownload) {
      if (strpos($downloadFileUrl, 'http') === 0) {
        echo file_get_contents($downloadFileUrl);
      } else {
        header('Content-Length: ' . filesize($downloadFileUrl));
        readfile($downloadFileUrl);
      }
    }


    // --end id


  }

}
