<?php
@include_once DZSWTL_PATH.'inc/gutenberg-block-factory/DzsGutenbergBlockFactory.php';

/**
 * @param $dzswtl DZSWooTable
 */
function dzswtl_gutenberg_add_actions($dzswtl) {


  $filterBlock = new DzsGutenbergBlockFactory(array(
    'gutenbergBlockName' => 'dzswtl/filters-block',
    'gutenbergBlockNameJs' => 'dzswtl/filters-block',
    'blockJsUrl' => DZSWTL_URL.'inc/js-gutenberg/filters-block/filters-block.js',
    'blockShortcode' => 'dzs_woo_filter_gutenberg',
    'actualShortcode' => array($dzswtl->classFilters, 'shortcode_woo_filter'),
    'blockOptions' => include(DZSWTL_PATH.'configs/config-filter-options.php'),
  ));


  add_action('init', 'dzswtl_gutenberg_handle_init', 2);
  add_action('init', 'dzswtl_gutenberg_add_support_block', 500);
  add_action('admin_footer', 'dzswtl_gutenberg_add_support', 500);
  add_action('enqueue_block_editor_assets', 'dzswtl_gutenberg_handle_enqueue_block_editor_assets');
}

/**
 * called on init start
 */
function dzswtl_gutenberg_handle_init() {

  // -- we store this for loading in the footer once all dependencies are loaded
  if (is_admin() && function_exists('register_block_type')) {

    wp_register_script(
      DZSWTL_GUTENBERG_BLOCK_NAME,
      DZSWTL_URL . 'dist/block-shop.js',
      array('wp-blocks', 'wp-element', 'wp-components', 'wp-editor')
    );
  }


  if(is_admin()){
    DZSWTLHelpers::enqueue_ultibox();
  }

  add_shortcode('dzswtl_gutenberg_block', 'dzswtl_gutenberg_table_render');

}

/**
 * init end
 */
function dzswtl_gutenberg_add_support_block() {
  // -- in init
  global $dzswtl;


  // -- default atrributes gallery


  $atts_gutenberg_block = DZSWTLHelpers::sanitize_config_to_gutenberg_register_block_type($dzswtl->gutenberg_block_options);


  if (function_exists('register_block_type')) {

    // -- register gutenberg
    // todo: real atts
    register_block_type('dzswtl/gutenberg-block', array(
      'attributes' => $atts_gutenberg_block,
      'render_callback' => 'dzswtl_gutenberg_table_render',
    ));
  }

}

function dzswtl_gutenberg_handle_enqueue_block_editor_assets() {
  // -- enqueue for gutenberg

  if (is_admin()) {
    wp_enqueue_script('dzswtl-gutenberg-admin', DZSWTL_URL . 'gutenberg/gutenberg-admin.js');
    DZSWTLHelpers::enqueue_script();
  }
}


/**
 * called in admin_footer
 */
function dzswtl_gutenberg_add_support() {



  global $post;

//     -- we need to remove gutenberg support if this is avada or wpbakery

  $configFilterOptions = include DZSWTL_PATH.'configs/config-filter-options.php';

  $isLoadScript = true;

  if ($post && $post->post_content && strpos($post->post_content, 'vc_row') !== false) {
    $isLoadScript = false;
  }
  if ((defined('AVADA_VERSION'))) {

    $isLoadScript = false;
  }

  // -- disable if it's not gutenberg
  if (function_exists('get_current_screen')) {
    if (method_exists('get_current_screen', 'is_block_editor') && get_current_screen()->is_block_editor() == false) {
      $isLoadScript = false;
    }
  }

  if (isset($_GET['post_type']) && $_GET['post_type'] == 'sp_easy_accordion') {

    $isLoadScript = false;
  }



  if ($isLoadScript) {
    wp_enqueue_script('wp-blocks');
    wp_enqueue_script('wp-element');
    wp_enqueue_script(DZSWTL_GUTENBERG_BLOCK_NAME);
  }

}


function dzswtl_gutenberg_table_render($attributes) {
  // -- player render
  global $dzswtl;

  $fout = '';

  if (is_admin()) {
  }



  $attributes['called_from'] = 'gutenberg_player_render';
  // todo: here
  $fout .= '<div class="gutenberg-dzsap-con">' . dzswtl_shortcode_woo_table($attributes);


  $fout .= '</div>';

  return $fout;
}

