<?php


function dzswtl_generate_layout_builder() {
  global $pagenow, $dzswtl, $post;


  if ((isset($_GET['post']) || $pagenow == 'post-new.php')) {


    $the_slug = 'preview-post-1';
    $args = array(
      'post_type' => 'product',
      'post_status' => DZSWTL_POST_STATUS_PREVIEW,
      'post_name__in' => array($the_slug),
      'numberposts' => 1,
    );
    $my_posts = get_posts($args);

    if (is_array($my_posts) && count($my_posts) > 0) {


    } else {

      // -- if we don't have preview posts


      $upload_dir = wp_upload_dir();
      $image_data = file_get_contents(DZSWTL_URL . 'sampledata/sampleimage.png');
      $fileName = basename('sampleimage.png');
      if (wp_mkdir_p($upload_dir['path'])) $file = $upload_dir['path'] . '/' . $fileName;
      else                                    $file = $upload_dir['basedir'] . '/' . $fileName;
      file_put_contents($file, $image_data);

      $wp_filetype = wp_check_filetype($fileName, null);
      $attachment = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name($fileName),
        'post_content' => '',
        'post_status' => 'inherit'
      );


      require_once(ABSPATH . 'wp-admin/includes/image.php');


      $term = wp_insert_term(
        'Preview', // the term
        DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY, // the taxonomy
        array(
          'description' => 'Preview Category',
          'slug' => DZSWTL_POST_STATUS_PREVIEW,
          'parent' => 0
        )
      );


      // Create post object
      $my_post = array(
        'post_title' => "Preview Post 1",
        'post_content' => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
        'post_type' => 'product',
        'post_status' => DZSWTL_POST_STATUS_PREVIEW,
        'post_name' => 'preview-post-1',
        'post_author' => 1,
      );

// Insert the post into the database
      $post_id = wp_insert_post($my_post);


      wp_set_post_terms($post_id, array($term['term_id']), DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY);
      update_post_meta($post_id, '_price', '10');


      $attach_id = wp_insert_attachment($attachment, $file, $post_id);


      $attach_data = wp_generate_attachment_metadata($attach_id, $file);
      $res1 = wp_update_attachment_metadata($attach_id, $attach_data);
      $res2 = set_post_thumbnail($post_id, $attach_id);


      // Create post object
      $my_post = array(
        'post_title' => "Preview Post 2",
        'post_content' => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.',
        'post_type' => 'product',
        'post_status' => DZSWTL_POST_STATUS_PREVIEW,
        'post_name' => 'preview-post-2',
        'post_author' => 1,

      );

// Insert the post into the database
      $post_id = wp_insert_post($my_post);


      wp_set_post_terms($post_id, array($term['term_id']), DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY);
      update_post_meta($post_id, '_price', '15');


      $attach_data = wp_generate_attachment_metadata($attach_id, $file);
      $res1 = wp_update_attachment_metadata($attach_id, $attach_data);
      $res2 = set_post_thumbnail($post_id, $attach_id);
    }


    $arr_data = array();

    if ($post->post_content) {
      parse_str($post->post_content, $arr_data);
    }
    ?>


    <br>
    <br>
    <div id="listbuilder-con" class="list-builder-con">

      <div class="dzs-row" style="align-items: baseline">
        <div class="dzs-col-md-3">

          <div class="admin-builder-block">
            <div class="admin-builder-head">
              <h3 class="admin-builder-head--title"><i class="dzs-round-icon-con"><i
                    class="dashicons dashicons-align-pull-left"></i></i>
                <span class="the-label"><?php echo esc_html__("Outline", DZSWTL_ID); ?></span></h3>
            </div>

            <div class="admin-builder-content">
              <div class="builder-layers-con">
                <div class="dd" id="nestable3" style="width: 100%; max-width: none; margin: 0 auto;">
                  <ol class="dd-list builder-layers">

                    <?php


                    if ($arr_data) {


                      if (isset($arr_data)) {
                        $bars = $arr_data['bars'];
                        foreach ($bars as $lab_bar => $val_bar) {

                          if (is_numeric($lab_bar)) {



                            echo dzswtl_generate_layer_item($val_bar);
                          }
                        }
                      }
                    }


                    ?>

                  </ol>
                </div>
              </div>

              <div class="add-builder-elements-con">
                <span class="add-builder-btn add-element"><i
                    class="dashicons dashicons-plus-alt fa"></i> <?php echo __("Add Element");; ?></span> &nbsp; &nbsp;
                <span
                  class="add-builder-btn add-container"><i
                    class="dashicons dashicons-marker fa"></i> <?php echo __("Add Container");; ?></span>
              </div>
            </div>
          </div>
        </div>
        <div class="dzs-col-md-9">

          <div class="admin-builder-block">
            <div class="admin-builder-head">
              <h3 class="admin-builder-head--title"><i class="dzs-round-icon-con" style="background-color: #0391CE"><i class="fa dashicons dashicons-visibility"></i></i> <span
                  class="the-label">Preview</span></h3>
            </div>
            <div class="admin-builder-content">
              <div class="builder-demo-con">
              </div>

              <div class="wheel-loader">
                <div class="wheel-loader--wrap">
                  <div class="bar1"></div>
                  <div class="bar2"></div>
                  <div class="bar3"></div>
                  <div class="bar4"></div>
                  <div class="bar5"></div>
                  <div class="bar6"></div>
                  <div class="bar7"></div>
                  <div class="bar8"></div>
                  <div class="bar7"></div>
                  <div class="bar8"></div>
                  <div class="bar9"></div>
                  <div class="bar10"></div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <br>
      <br>
      <br>
      <br>
      <div class="dzs-row dzs-row-for-inline">
        <?php
        $mainsettings = array(
          'position_type' => 'relative',
          'pagination_method' => 'scroll',
          'index' => '0',
          'width' => '100%',
          'height' => 'auto',
          'animation_time' => '2000',
          'maxperc' => '100',
          'margin_top' => '0',
          'margin_right' => '0',
          'margin_bottom' => '0',
          'margin_left' => '0',
          'color' => '',
          'background_color' => '#285e8e',
          'type' => 'rect',
          'initon' => 'scroll',
          'maxnr' => '100',
          'arg4_label' => __("Background Color"),
          'arg5_label' => __("Height"),
          'arg6_label' => __("Animation Time"),
          'arg7_label' => '',
          'arg8_label' => '',
          'arg9_label' => '',
        );



        if (isset($arr_data['bars']['mainsettings']) && isset($arr_data['bars']['mainsettings'])) {

          $mainsettings = array_merge($mainsettings, $arr_data['bars']['mainsettings']);
        }

        $config_layoutBuilderSettings = include(DZSWTL_PATH . 'configs/config-layout-builder--settings.php');
        ?>


        <div class="dzs-inline-part-3">

          <h3 class="listbuilder--title">
            <i  class="dashicons dashicons-admin-generic"></i>&nbsp;&nbsp;<?php echo esc_html__("Settings", DZSWTL_ID); ?>
          </h3>
          <div class="tab-content">

            <div class="dzs-row">
              <div class="dzs-col-md-12">
                <?php
                echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_layoutBuilderSettings, 'general', $mainsettings, array(
                  'labelPrefix' => 'bars[mainsettings][',
                  'labelSuffix' => ']',
                  'formsExtraClasses' => ' builder-field',
                ));
                ?>
              </div>

            </div>
            <div class="clear"></div>


          </div>


        </div>


        <div class="dzs-inline-part-3">
          <h3 class="listbuilder--title">
            <i  class="dashicons dashicons-admin-customizer"></i>&nbsp;&nbsp;<?php echo esc_html__("Appearance", DZSWTL_ID); ?>
          </h3>
          <div class="tab-content">


            <div class="dzs-row">
              <div class="dzs-col-md-12">

                <?php


                echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_layoutBuilderSettings, 'layout-appearance', $mainsettings, array(
                  'labelPrefix' => 'bars[mainsettings][',
                  'labelSuffix' => ']',
                  'formsExtraClasses' => 'builder-field',
                ));
                ?>
                <?php

                ?>


                <?php
                $lab = 'extra_css';
                $val = '';
                if (isset($mainsettings[$lab])) {
                  $val = $mainsettings[$lab];
                }
                ?>
                <div class="setting">
                  <h4 class="setting-label"><?php echo esc_html__("Extra styling", DZSWTL_ID); ?></h4>

                  <?php
                  echo DZSHelpers::generate_input_textarea('bars[mainsettings][' . $lab . ']', array(
                    'class' => ' builder-field  ',
                    'seekval' => $val,
                  ));
                  ?>
                  <div
                    class='sidenote'><?php echo sprintf(esc_html__('input %s which will target this config in the styling - using this selector in your code will target the css for this configuration', DZSWTL_ID), '<strong>#selector#</strong>'); ?></div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="dzs-inline-part-3">
          <h3 class="listbuilder--title">
            <i class="dashicons dashicons-block-default"></i>&nbsp;&nbsp;<?php echo esc_html__("Layout", DZSWTL_ID); ?>
          </h3>
          <div class="tab-content">
            <?php


            echo DZSWooTableHelper::generateOptionsFromConfigForMainOptions($config_layoutBuilderSettings, 'layout-layout', $mainsettings, array(
              'labelPrefix' => 'bars[mainsettings][',
              'labelSuffix' => ']',
              'formsExtraClasses' => 'builder-field',
            ));

            $label = 'table_responsive_priority';
            $val = '';
            if(isset($mainsettings[$label])){
              $val = $mainsettings[$label];
            }


            ?>
            <div class="setting  check-label check-parent3 ">
              <h4 class="setting-label"><?php echo esc_html__("Table responsive column", DZSWTL_ID); ?></h4>
              <input type="hidden" name="bars[mainsettings][<?= $label ?>]" class=" builder-field dzs-dependency-field      " value='<?=$val?>' data-label="<?= $label ?>">
              <ol class="builder-layer--priority-blocks">

              </ol>
              <div  class='sidenote'><?php echo (esc_html__('set the responsive columns priority', DZSWTL_ID)); ?> ( <?php echo (esc_html__('higher is better', DZSWTL_ID)); ?> )</div>
            </div>
          </div>
        </div>


        <br>
      </div>

      <div class="">
        <h4><?php echo esc_html__("Shortcode", DZSWTL_ID) ?>:</h4>
        <pre>[dzs_woo_table layout="<?php echo $post->post_name; ?>" show_filtered_by="on" posts_per_page="6"]</pre>
      </div>

    </div>

    <h2 class="hndle ui-sortable-handle"><span><?php esc_html__("Publish", DZSWTL_ID) ?></span></h2>


    <br>
    <br>
    <br>
    <br>
    <br>
    <br>
    <br>
    <br>
    <br>
    </div>

    <?php

  } else {


    // -- else we can import demos

    ?>
    <div class="dzswtl-import-layout-con">
      <h2><?= esc_html__("One-click import", DZSWTL_ID) ?></h2>
      <div class="dzs-row" style="max-width: 95%;">
        <?php


        $foutLayouts = '';
        $sampleLayouts = include_once(DZSWTL_PATH . 'configs/config-sample-layouts.php');
        $indexLayouts = 0;
        foreach ($sampleLayouts as $key => $sampleLayout) {
          $indexLayouts++;
          $foutLayouts .= DZSWooTableHelper::generate_str_dzswtl_import_layout($dzswtl->base_url, $key, $sampleLayout['title']);
          if ($indexLayouts % 3 === 0) {

            $foutLayouts .= '</div>';
            $foutLayouts .= '<div class="dzs-row" style="max-width: 95%;">';
          }
        }

        echo $foutLayouts;

        ?>
      </div>
    </div>
    </div>
    <div class="feedbacker"><?php esc_html__("Loading", DZSWTL_ID) ?>...</div><?php
  }


}

function dzswtl_generateConfigItemToBuilder($configItem, $targetCategory, $margs) {
  if ($configItem['category'] == $targetCategory) {

    $struct_item = '';
    $optionName = $configItem['name'];

    $completeOptionName = 'bars[' . $margs['index'] . '][' . $optionName . ']';

    $val = $configItem['default'];


    if (isset($margs[$optionName])) {
      $val = $margs[$optionName];
    }

    $struct_item .= '<div class="setting check-label check-parent1" ';

    if (isset($configItem['dependency']) && $configItem['dependency']) {
      $struct_item .= 'data-dependency=\'' . json_encode($configItem['dependency']) . '\'';
    }

    $struct_item .= '>';

    if(isset($configItem['title'])){

      $struct_item .= '<div class="setting-label">' . $configItem['title'] . '</div>';
    }


    $args = array(

      'class' => ' builder-field ',
      'seekval' => $val,
      'extraattr' => ' data-label="' . $optionName . '"',
    );

    if (isset($configItem['inputExtraClasses']) && $configItem['inputExtraClasses']) {

      $args['class'] .= ' ' . $configItem['inputExtraClasses'];
    }

    if ($configItem['type'] == 'select') {
      $args['class'] .= '  dzs-style-me skin-beige';
      $args['options'] = $configItem['choices'];

      $struct_item .= DZSHelpers::generate_select($completeOptionName, $args);
    }

    if ($configItem['type'] == 'input' || $configItem['type'] == 'textarea' || $configItem['type'] == 'hidden') {
      $args['class'] .= ' text-input';

      if ($configItem['type'] == 'input' || $configItem['type'] == 'hidden') {
        if($configItem['type'] == 'hidden'){

          $args['input_type'] = 'hidden';
        }

        $struct_item .= DZSHelpers::generate_input_text($completeOptionName, $args);
      }
      if ($configItem['type'] == 'textarea') {

        $struct_item .= DZSHelpers::generate_input_textarea($completeOptionName, $args);
      }
    }

    if (isset($configItem['sidenote']) && $configItem['sidenote']) {

      $struct_item .= '<div class="sidenote">' . $configItem['sidenote'] . '</div>';
    }
    $struct_item .= '</div>';

    return $struct_item;
  }

  return '';

}