<?php

function dzswtl_woo_getLayoutDataObject($layout) {

  $layout_data = null;

  if (is_array($layout)) {
    $layout_data = $layout;
  } else {
    $layout_post = dzs_wp_getPostBySlug($layout, DZSWTL_POST_TYPE);

    if ($layout_post) {
      parse_str($layout_post->post_content, $layout_data);
    }
  }

  return $layout_data;
}

/**
 * @param array $getFiltersQuerySource mutates
 * @param array $shopAtts mutates
 */
function dzswtl_query_sanitizeInitialFeedArray(&$getFiltersQuerySource, &$shopAtts){

  global $dzswtl;




  if ($shopAtts['recalculate_attribute_data'] === 'default') {
    $shopAtts['recalculate_attribute_data'] = $dzswtl->db_mainoptions['filter_check_availability_recalculate_count'];
  }

  if (!$dzswtl->isGetAlreadyConsumed){



    if (isset($getFiltersQuerySource['table_paged'])) {
      if (isset($shortcodeAtts['paged']) == false || $shortcodeAtts['paged'] == 'default') {
        $shopAtts['paged'] = $getFiltersQuerySource['table_paged'];
      }
    }

    if (isset($getFiltersQuerySource['price'])) {
      if (isset($shortcodeAtts['price']) == false || $shortcodeAtts['price'] == '') {
        $shopAtts['price'] = $getFiltersQuerySource['price'];
      }
    }

    if (isset($getFiltersQuerySource['order'])) {
      if ($shortcodeAtts['order'] == 'default') {
        $shopAtts['order'] = $getFiltersQuerySource['order'];
      }
    }

    if (isset($getFiltersQuerySource['orderby'])) {
      if ($shortcodeAtts['orderby'] == 'default') {
        $shopAtts['orderby'] = $getFiltersQuerySource['orderby'];
      }
    }
    if (isset($getFiltersQuerySource['search'])) {
      if ($shopAtts['search'] == 'default') {
        $shopAtts['search'] = urldecode($getFiltersQuerySource['search']);
      }
    }
    if (isset($getFiltersQuerySource['the_search'])) {
      if ($shopAtts['search'] == 'default') {
        $shopAtts['search'] = urldecode($getFiltersQuerySource['the_search']);
      }
    }

    if((isset($getFiltersQuerySource[DZSWTL_WOOCOMMERCE_PRODUCTS_TAG]) && $getFiltersQuerySource[DZSWTL_WOOCOMMERCE_PRODUCTS_TAG])) {
      $getFiltersQuerySource[DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION.DZSWTL_WOOCOMMERCE_PRODUCTS_TAG] = $getFiltersQuerySource[DZSWTL_WOOCOMMERCE_PRODUCTS_TAG];
    }
  }

}


/**
 * @param $shortcodeAtts
 * @param $shopAtts
 * @param $meta_query
 * @param $filterChecks
 * @param array $getFiltersQuerySource - can be GET array if accessed directly , or user set filters
 */
function dzswtl_woo_mainQueryInitialSanitation($shortcodeAtts, &$shopAtts, &$meta_query, &$filterChecks, $getFiltersQuerySource) {

  global $dzswtl, $post;


  // todo: are we sure ?
  if ($dzswtl->shop_index > 1) {
    $dzswtl->isGetAlreadyConsumed = true;
  }
  if ($shortcodeAtts['query_is_main_container_target'] === 'on') {
    $dzswtl->isGetAlreadyConsumed = false;
  }


  if ($post && $post->ID) {
    if (isset($_COOKIE['dzswtl_layout_' . $post->ID])) {
      $shopAtts['layout'] = $_COOKIE['dzswtl_layout_' . $post->ID];
    }
    if (isset($getFiltersQuerySource['layout'])) {
      $shopAtts['layout'] = $getFiltersQuerySource['layout'];
    }

    if (isset($_COOKIE['dzswtl_posts_per_page_' . $post->ID])) {
      $shopAtts['posts_per_page'] = $_COOKIE['dzswtl_posts_per_page_' . $post->ID];
    }
  }




  dzswtl_query_sanitizeInitialFeedArray($getFiltersQuerySource, $shopAtts);



  if ($shortcodeAtts['hard_meta_query']) {
    $shopAtts['hard_meta_query'] = str_replace('{{braceopen}}', '[', $shopAtts['hard_meta_query']);
    $shopAtts['hard_meta_query'] = str_replace('{{braceclose}}', ']', $shopAtts['hard_meta_query']);
    $shopAtts['hard_meta_query'] = str_replace('{{escape}}', '\\', $shopAtts['hard_meta_query']);
    $hardMetaObject = json_decode($shopAtts['hard_meta_query'], true);

    foreach ($hardMetaObject as $arrc) {
      array_push($meta_query, $arrc);
    }
  }


  if ($dzswtl->isGetAlreadyConsumed == false && isset($getFiltersQuerySource) && is_array($getFiltersQuerySource)) {
    foreach ($getFiltersQuerySource as $lab => $val) {
      if (strpos($lab, DZSWTL_QUERY_META_VALUE_ABBREVIATION)) {
        $shopAtts[$lab] = ($getFiltersQuerySource[$lab]);
      }
    }
  }


  // -- it might come from AJAX
  if ($shopAtts['return_only_items'] == 'on') {

    if (isset($_POST['caller_current_url']) && $_POST['caller_current_url']) {
      $shopAtts['caller_current_url'] = stripslashes($_POST['caller_current_url']);
    }
  }


  $filterChecks = $shopAtts; // -- all checks for product attributes


  if ($dzswtl->isGetAlreadyConsumed == false && isset($getFiltersQuerySource)) {




    $getDecoded = array();
    foreach ($getFiltersQuerySource as $getLab => $getVal) {
      if(is_string($getVal)){

        $getDecoded[$getLab] = urldecode($getVal);
      }
    }


    // -- margs are shortcode attributes .. hard set
    $filterChecks = array_merge($getDecoded, $shopAtts);

    foreach ($getDecoded as $getKey => $getVal){
      if(isset($shopAtts[$getKey]) && $shopAtts[$getKey]=='default' && $getVal){
        $shopAtts[$getKey] = $getVal;
      }
    }

    DZSWTLHelpers::sanitize_from_get_to_margs($shopAtts);
  }


  // -- margs default will overwrite $getFiltersQuerySource so let s overwrite again ..
  $lab = 'cat';
  if (isset($getFiltersQuerySource[$lab]) && $getFiltersQuerySource[$lab]) {
    if (isset($shopAtts[$lab]) == false || $shopAtts[$lab] == 'default' || $shopAtts[$lab] == '') {
      $shopAtts[$lab] = str_replace('%25252C', ',', $getFiltersQuerySource[$lab]);
      $shopAtts[$lab] = str_replace('%252C', ',', $getFiltersQuerySource[$lab]);
      $shopAtts[$lab] = str_replace('%2C', ',', $getFiltersQuerySource[$lab]);
    }
  }




  $lab = 'subcat';
  if ($dzswtl->isGetAlreadyConsumed == false && isset($getFiltersQuerySource[$lab]) && $getFiltersQuerySource[$lab]) {
    $filterChecks[$lab] = urldecode($getFiltersQuerySource[$lab]);
  }


  if (isset($shopAtts['sort_by']) == false || $shopAtts['sort_by'] == 'default') {
    $shopAtts['sort_by'] = '';
  }

  $shopAtts['orderby'] = ($shopAtts['orderby'] == 'default' && isset($shopAtts['default_orderby']) && $shopAtts['default_orderby']) ? $shopAtts['default_orderby'] : $shopAtts['orderby'];
  $shopAtts['order'] = ($shopAtts['order'] == '' && isset($shopAtts['default_order']) && $shopAtts['default_order']) ? $shopAtts['default_order'] : $shopAtts['order'];

  if (isset($shopAtts['paged']) == false || $shopAtts['paged'] == 'default') {
    $shopAtts['paged'] = '1';
  }
  if (isset($shopAtts['orderby']) == false || $shopAtts['orderby'] == 'default') {
    $shopAtts['orderby'] = 'menu_order';
  }
  if (isset($shopAtts['order']) == false || $shopAtts['order'] == 'default') {
    $shopAtts['order'] = '';
  }
  if (isset($shopAtts['search']) == false || $shopAtts['search'] == 'default') {

    $shopAtts['search'] = '';
  }

  if (isset($shopAtts['cat']) == false || $shopAtts['cat'] == 'default') {
    $shopAtts['cat'] = '';
  }



  $shopAtts['cat'] = str_replace('%25252C', ',', $shopAtts['cat']);
  $shopAtts['cat'] = str_replace('%252C', ',', $shopAtts['cat']);
  $shopAtts['cat'] = str_replace('%2C', ',', $shopAtts['cat']);




  // -- all checks include pa
  foreach ($filterChecks as $lab => $val) {


    // -- destroy wrong vals
    if (strpos($lab, DZSWTL_QUERY_META_VALUE_PA_ABBREVIATION . DZSWTL_QUERY_META_VALUE_PA_ABBREVIATION) === 0) {
      // -- obviously wrong


      $wrong_lab = $lab;
      $lab = str_replace(DZSWTL_QUERY_META_VALUE_PA_ABBREVIATION . DZSWTL_QUERY_META_VALUE_PA_ABBREVIATION, DZSWTL_QUERY_META_VALUE_PA_ABBREVIATION, $lab);

      $shopAtts[$lab] = $val;
      $filterChecks[$lab] = $val;

      // -- delete wrong labs
      unset($shopAtts[$wrong_lab]);
      unset($filterChecks[$wrong_lab]);

    }
  }


  if (isset($shortcodeAtts['ids']) && $shortcodeAtts['ids']) {
    // -- we have ids , we later process
    $shopAtts['handpickedIds'] = explode(',', $shopAtts['ids']);
  }
}


function dzswtl_query_productAttributeMutateFilterByAndPa($possibleFilter, $possibleFilterKey, $shopAtts, &$productAttsForTaxQueryForQueryArgs) {


  $keyProductAttributeSanitized = str_replace(DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION, '', $possibleFilterKey);

  if ($shopAtts['product_attributes'] == 'default') {


    // -- if values has wtn-wtn then clearly it has nothing to do in filtering, since we filter by interval
    if (strpos($possibleFilter, DZSWTL_QUERY_WITHIN_ABBREVIATION) === false) {

      if (is_array($productAttsForTaxQueryForQueryArgs)) {
        $productAttsForTaxQueryForQueryArgs[$possibleFilterKey] = $possibleFilter;
      }
    }
  }


}

function dzswtl_query_metaValueMutateShopAttsAndFilterChecks($nominatedFilterKey, $nominatedFilterValue, &$shopAtts, &$filterChecks) {

  if (strpos($nominatedFilterKey, DZSWTL_QUERY_MINIMUM_ABBREVIATION) !== false) {
    // -- woomin


    $nominatedFilterKey = str_replace(DZSWTL_QUERY_MINIMUM_ABBREVIATION, '', $nominatedFilterKey);


    if (isset($temp_ranges_arr[$nominatedFilterKey]) && isset($temp_ranges_arr[$nominatedFilterKey]['max'])) {

      $shopAtts[$nominatedFilterKey] = $nominatedFilterValue . DZSWTL_QUERY_WITHIN_ABBREVIATION . $temp_ranges_arr[$nominatedFilterKey]['max'];
    } else {
      $temp_ranges_arr[$nominatedFilterKey] = array(
        'min' => $nominatedFilterValue,
        'max' => '',
      );


      $shopAtts[$nominatedFilterKey] = $nominatedFilterValue . DZSWTL_QUERY_WITHIN_ABBREVIATION . 'infinite';
    }
    unset($filterChecks[$nominatedFilterKey]);


  } elseif (strpos($nominatedFilterKey, DZSWTL_QUERY_MAXIMUM_ABBREVIATION) !== false) {
    // -- woomax


    $nominatedFilterKey = str_replace(DZSWTL_QUERY_MAXIMUM_ABBREVIATION, '', $nominatedFilterKey);

    if (isset($temp_ranges_arr[$nominatedFilterKey]) && isset($temp_ranges_arr[$nominatedFilterKey]['max'])) {

      $shopAtts[$nominatedFilterKey] = $temp_ranges_arr[$nominatedFilterKey]['min'] . DZSWTL_QUERY_WITHIN_ABBREVIATION . $filterChecks[$nominatedFilterKey];
    } else {
      $temp_ranges_arr[$nominatedFilterKey] = array(
        'max' => $nominatedFilterValue,
        'min' => '',
      );
      $shopAtts[$nominatedFilterKey] = '0' . DZSWTL_QUERY_WITHIN_ABBREVIATION . $nominatedFilterValue;
    }

    unset($filterChecks[$nominatedFilterKey]);
  } else {

    // -- final else
    $shopAtts[$nominatedFilterKey] = $nominatedFilterValue;
  }
}

/**
 *
 * @param $productAttsForTaxQueryForQueryArgs array mutates
 */
function dzswtl_query_sanitizeProductAtts(&$productAttsForTaxQueryForQueryArgs) {

  foreach ($productAttsForTaxQueryForQueryArgs as $nominatedFilterKey => $nominatedFilterValue) {

    $newExplodedTerms = array();

    $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey] = htmlspecialchars($productAttsForTaxQueryForQueryArgs[$nominatedFilterKey], ENT_QUOTES);
    $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey] = str_replace('%25252C', ',', $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey]);
    $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey] = str_replace('%252C', ',', $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey]);
    $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey] = str_replace('%2C', ',', $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey]);


    // -- start
    if ($productAttsForTaxQueryForQueryArgs[$nominatedFilterKey]) {
      $newExplodedTerms = explode(',', $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey]);
      $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey] = $newExplodedTerms;
    } else {
      // -- does not do anything
      unset($productAttsForTaxQueryForQueryArgs[$nominatedFilterKey]);
    }

    // -- let us try to turn to ids
    if (is_array($newExplodedTerms)) {
      foreach ($newExplodedTerms as $lab2 => $val2) {
        $term = get_term_by('slug', $val2, $nominatedFilterKey);
        if ($term && isset($term->term_id)) {
          $productAttsForTaxQueryForQueryArgs[$nominatedFilterKey][$lab2] = $term->term_id;
        }
      }
    }
  }


}

function dzswtl_query_addProductAttsToTaxQuery($productAttsForTaxQueryForQueryArgs, &$taxQueryForQueryArgs) {

  if (count($productAttsForTaxQueryForQueryArgs) > 0) {
    foreach ($productAttsForTaxQueryForQueryArgs as $nominatedFilterKey => $nominatedFilterValue) {
      // -- taxonomy filtering..
      // -- if values has wtn-wtn then clearly it has nothing to do in filtering, since we filter by interval
      array_push($taxQueryForQueryArgs, array(
        array(
          'taxonomy' => $nominatedFilterKey,
          'field' => 'id',
          'terms' => $nominatedFilterValue,
        )
      ));
    }
  }
}


/**
 * @param array $getFiltersQuerySource
 * @return array
 */
function dzswtl_filters_getFilteredByList($getFiltersQuerySource) {
  $filterByList = array();


  foreach ($getFiltersQuerySource as $getKey => $getVal) {

    $EXCLUDED_KEYS = array('add-to-cart', 'table_paged');
    if(in_array($getKey, $EXCLUDED_KEYS)){
      continue;

    }

    $filterKey = $getKey;
    $fullLabel = $getKey;
    if ($getKey === 'cat') {
      $fullLabel = esc_html__('Category', DZSWTL_ID);
    }


    // -- search

    $searchKey = '';
    $searchVal = '';

    if ($getKey === 's' || $getKey === 'search' || $getKey === 'the_search') {
      $searchKey = $getKey;
    }

    if ($searchKey) {
      $fullLabel = esc_html__('Search', DZSWTL_ID);
      $filterKey = 'the_search';
    }

    // -- taxonomy
    $getTaxonomySlug = '';
    if (strpos($getKey, DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION) === 0) {
      $getTaxonomySlug = str_replace(DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION, '', $getKey);
    }
    if (strpos($getKey, DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) === 0) {
      $getTaxonomySlug = $getKey;
    }


    if($getTaxonomySlug){
      $tax = get_taxonomy(str_replace(DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION, '', $getKey));

      if ($tax && isset($tax->label)) {
        $fullLabel = $tax->label;
      }
    }

    $filterByList[$getKey] = array(
      'lab_full' => $filterKey,
      'label' => $fullLabel,
      'value' => $getVal,
    );
  }

  // -- remove sorting
  unset($filterByList['orderby']);


  return $filterByList;
}

/**
 * @param $shopAtts
 * @param $layoutData
 * @param $nominatedFilters
 * @param $queryArgs
 * @param array $filterByList - mutates
 * @param $taxQueryForQueryArgs
 */
function dzswtl_query_searchAdjust(&$shopAtts, $layoutData, &$nominatedFilters, &$queryArgs) {
// todo: we do not need $nominatedFilters , we need filters on the page


  // -- search
  if (isset($layoutData['bars']['mainsettings']['integrate_search_in_filters']) && $layoutData['bars']['mainsettings']['integrate_search_in_filters'] == 'on') {
    if (isset($_GET['s']) && $_GET['s']) {
      $shopAtts['search'] = $_GET['s'];
    }


    // todo: $nominatedFilters

    $searchQueryString = $shopAtts['search'];
    $searchQueryStringOriginal = $shopAtts['search'];
    $actualSearchForQuery = $shopAtts['search'];


    $foundFiltersOnPage = array();

    $postContent = null;

    global $post;
    if ($post) {
      $postContent = $post->post_content;
    }

    // -- it might come from AJAX
    if (isset($_POST['caller_post_content']) && $_POST['caller_post_content']) {
      $postContent = stripslashes($_POST['caller_post_content']);
    }


    if ($postContent) {


      preg_match_all('/\[dzs_woo_filter.*?feed_from="(.*?)".*?\]/', $postContent, $filtersOnPage);

      foreach ($filtersOnPage[0] as $key => $wholeFilter) {
        $feedFrom = ($filtersOnPage[1][$key]);

        $regexSearchName = 'custom_attr_name';

        if ($feedFrom === 'custom-taxonomy') {
          $regexSearchName = 'custom_taxonomy_name';
        }

        if ($feedFrom === 'custom-attribute' || $feedFrom === 'custom-taxonomy') {

          preg_match_all('/\[dzs_woo_filter.*?' . $regexSearchName . '="(.*?)".*?\]/', $wholeFilter, $matchFiltersCustomName);


          array_push($foundFiltersOnPage, $matchFiltersCustomName[1][0]);
        }
      }
    }


    foreach ($foundFiltersOnPage as $nominatedFilterKey => $nominatedFilterValue) {
      if (strpos($nominatedFilterValue, DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) === 0) {

        $paDetails = DZSWTLHelpers::woocommerceGetDetailsForProductAttribute($nominatedFilterValue);
        $termsProcessed = $paDetails['terms_processed'];
        foreach ($termsProcessed as $termProc) {
          $labelToCompare = $termProc['label'];

          if (strpos(strtolower($actualSearchForQuery), strtolower($labelToCompare)) !== false) {
            $actualSearchForQuery = str_ireplace(' ' . $labelToCompare, '', $actualSearchForQuery);
            $actualSearchForQuery = str_ireplace($labelToCompare . ' ', '', $actualSearchForQuery);
            $actualSearchForQuery = str_ireplace($labelToCompare, '', $actualSearchForQuery);

            $nominatedFilters[$nominatedFilterValue] = $termProc['value'];

            $shopAtts['actual_search_forceUpdateFilters'][$nominatedFilterValue] = $termProc['value'];
            // todo: signal to
          }
        }
      }
    }

    // -- we need this for ajax search
    if ($actualSearchForQuery !== $searchQueryStringOriginal) {
      $shopAtts['actual_search_for_ajax'] = $actualSearchForQuery;
    }

  }

  if ($shopAtts['search']) {
    $queryArgs['s'] = $shopAtts['search'];
  }
  if ($shopAtts['actual_search_for_ajax'] !== 'default') {
    $queryArgs['s'] = $shopAtts['actual_search_for_ajax'];
  }

  // todo: maybe do some kind of search on tags


}


/**
 * only if return_only_items is on
 * @param $shopAtts
 * @param $visualAtts
 * @param $iout
 * @param $dzswtl
 * @param $productIdsThatFitQuery
 * @param $queryArgs
 * @param $originalQuery
 * @param null $countAllNumber
 * @param array $ajaxAtts
 * @param string $paginationString
 * @return false|string
 */
function dzswtl_main_prepareAjaxResponse(&$shopAtts, $visualAtts, $iout, $dzswtl, $productIdsThatFitQuery, $originalQuery, $countAllNumber = null, $ajaxAtts = array(), $paginationString = '') {


  foreach ($shopAtts as $nominatedFilterKey => $nominatedFilterValue) {
    // -- filter returned history pushState vars
    if ($nominatedFilterValue == DZSWTL_QUERY_WITHIN_ABBREVIATION || strpos($nominatedFilterKey, DZSWTL_QUERY_MINIMUM_ABBREVIATION) !== false || strpos($nominatedFilterKey, DZSWTL_QUERY_MAXIMUM_ABBREVIATION) !== false) {
      unset($shopAtts[$nominatedFilterKey]);
    }
  }

  $arrOutputForAjax = array(
    'paged' => $shopAtts['paged'],
    'max_pages' => $visualAtts['max_num_pages'],
    'margs' => json_encode($shopAtts),
    'max_num_pages' => $visualAtts['max_num_pages'],
    'paginationString' => $paginationString,
    'itemsOutput' => $iout,
    'footerExtraHtml' => $dzswtl->footer_extra_html,
  );

  if(isset($shopAtts['caller_event']) && $shopAtts['caller_event']){
    $arrOutputForAjax['caller_event'] = $shopAtts['caller_event'];
  }

  if ($dzswtl->db_mainoptions['filter_calculate_all_products_count'] == 'on') {
    if ($countAllNumber !== null) {
      $arrOutputForAjax['count-all-number'] = $countAllNumber;
    }
  }


  if (isset($shopAtts['ids']) && $shopAtts['ids']) {

  }


  if ($shopAtts['recalculate_attribute_data'] === 'on') {
    $arrOutputForAjax[DZSWTL_AJAX_CALCULATE_FILTER_COUNT] = ($productIdsThatFitQuery);
  }


  if ($dzswtl->db_mainoptions['filter_check_availability_recalculate_count_from_all_pages'] == 'on') {

    if ($dzswtl->shop_index == 1) {


      $results = DZSWTLFilters::getCountAllQueryResults($originalQuery);

      $recalculate_filters_all_ids = array();
      foreach ($results as $po) {
        array_push($recalculate_filters_all_ids, $po->ID);
      }
    }


  }

  if (isset($shopAtts['sort_by']) && $shopAtts['sort_by'] && count($shopAtts['sort_by'])) {
    $arrOutputForAjax['userSet_sort_by'] = $shopAtts['sort_by'];
  }

  if (isset($shopAtts['actual_search_forceUpdateFilters']) && $shopAtts['actual_search_forceUpdateFilters'] && count($shopAtts['actual_search_forceUpdateFilters'])) {
    $arrOutputForAjax['actual_search_forceUpdateFilters'] = json_encode($shopAtts['actual_search_forceUpdateFilters']);
  }

  // -- if we return only items
  // -- we send the jsooooon
  $arrOutputForAjax['itemsOutput'] = mb_convert_encoding($arrOutputForAjax['itemsOutput'], 'UTF-8', 'UTF-8');
  $arrOutputForAjax = array_merge($arrOutputForAjax, $ajaxAtts);
  $jsonOutput = json_encode($arrOutputForAjax);

  if ($jsonOutput !== FALSE) {
    return json_encode($arrOutputForAjax);
  } else {
    wp_send_json_error(array(
      'json_last_error_msg' => json_last_error_msg(),
      'json_last_error' => json_last_error(),
    ));
  }
}


/**
 * @param $shortcodeAtts
 * @param $shopAtts
 * @return array
 */
function dzswtl_query_buildInitialWpQuery($shortcodeAtts, $shopAtts) {

  $queryArgs = array(
    'post_type' => $shortcodeAtts['post_type'],
    'post_status' => $shopAtts['post_status'],
    'posts_per_page' => $shopAtts['posts_per_page'],
    's_meta_keys' => array('short_desc', 'post_title', 'post_content'),
    'orderby' => 'default',
    'order' => 'default',
  );

  $queryArgs['paged'] = $shopAtts['paged'];

  if (isset($shopAtts['ids']) && $shopAtts['ids']) {
    $queryArgs['post__in'] = explode(',', $shopAtts['ids']);
  }


  return $queryArgs;
}


/**
 * @param $shopAtts
 * @param $metaQueryForQueryArgs array mutates
 */
function dzswtl_query_addRatingToMetaQuery($shopAtts, &$metaQueryForQueryArgs) {


  $arrRatingRange = array(4.5, 5);

  switch ($shopAtts['rating']) {
    case '1':
      $arrRatingRange = array(0.1, 1.49);
      break;
    case '2':
      $arrRatingRange = array(1.5, 2.49);
      break;
    case '3':
      $arrRatingRange = array(2.5, 3.49);
      break;
    case '4':
      $arrRatingRange = array(3.5, 4.49);
      break;

    default:
      break;
  }
  array_push($metaQueryForQueryArgs, array(
    'key' => '_wc_average_rating',
    'value' => $arrRatingRange,
    'type' => 'numeric',
    'compare' => 'BETWEEN'
  ));


}


/**
 * @param array $shopAtts
 * @param $queryArgs array mutates
 */
function dzswtl_query_orderByAdjustQuery($shopAtts, &$queryArgs) {
  if($shopAtts['sort_by']){
    preg_match_all('/(.*)?{(.*?)}/', $shopAtts['sort_by'], $output_array);

    if(isset($output_array[1][0])){
      $shopAtts['orderby'] = $output_array[1][0];
    }
    if(isset($output_array[2][0])){
      $shopAtts['order'] = $output_array[2][0];
    }
  }

  if ($shopAtts['orderby'] == 'alphabetical') {

    $queryArgs['orderby'] = 'title';
  }
  if ($shopAtts['orderby'] == 'price') {
    $queryArgs['orderby'] = 'meta_value_num';
    $queryArgs['meta_key'] = '_price';
  }
  if (strpos($shopAtts['orderby'], DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) === 0) {
    $queryArgs['orderby'] = 'meta_value_num';
    $queryArgs['meta_key'] = DZSWTL_DB_TAX_TO_META_ABBREVIATION . $shopAtts['orderby'];
  }
  if ($shopAtts['orderby'] == 'zoomsounds_plays') {
    $queryArgs['orderby'] = 'meta_value_num';
    $queryArgs['meta_key'] = '_dzsap_views';
  }
  if ($shopAtts['orderby'] == 'zoomsounds_likes') {
    $queryArgs['orderby'] = 'meta_value_num';
    $queryArgs['meta_key'] = '_dzsap_likes';
  }


  if ($shopAtts['orderby'] == 'ratings_score') {
    $queryArgs['orderby'] = 'meta_value_num';

    $key = '_dzsap_rate_index';
    $queryArgs['meta_query'] = array(
      'relation' => 'OR',
      array(
        'key' => $key,
        'compare' => 'EXISTS',
      ),
      array(
        'key' => $key,
        'compare' => 'NOT EXISTS'
      )
    );
    $queryArgs['meta_type'] = 'NUMERIC';
    $queryArgs['order'] = 'DESC';

  }

  if($queryArgs['orderby']=='default'){

    if ($shopAtts['orderby'] && $shopAtts['orderby'] != 'default') {
      $queryArgs['orderby'] = $shopAtts['orderby'];
    }
  }

  if($queryArgs['order']=='default') {
    if ($shopAtts['order']) {
      $queryArgs['order'] = $shopAtts['order'];
    }
  }
  $queryArgs['order'] = strtoupper($queryArgs['order']);
}

/**
 * this is for META query
 * @param $shopAtts
 * @param $metaQueryForQueryArgs
 */
function dzswtl_query_addRangesToMetaQuery($shopAtts, &$metaQueryForQueryArgs) {
  foreach ($shopAtts as $nominatedFilterKey => $nominatedFilterValue) {
    if (strpos($nominatedFilterKey, DZSWTL_QUERY_META_VALUE_ABBREVIATION) === 0) {
      $meta_value_name = str_replace(DZSWTL_QUERY_META_VALUE_ABBREVIATION, '', $nominatedFilterKey);
      if (strpos($nominatedFilterValue, DZSWTL_QUERY_WITHIN_ABBREVIATION) !== false) {

        // -- range
        $arrPriceRange = explode(DZSWTL_QUERY_WITHIN_ABBREVIATION, $nominatedFilterValue);
        if (is_array($arrPriceRange) && count($arrPriceRange) > 1) {

          // -- meta value between
          if ($arrPriceRange[0] || $arrPriceRange[1]) {
            if ($arrPriceRange[0] === '') {
              $arrPriceRange[0] = '0';
            }
            if ($arrPriceRange[1] == '' || $arrPriceRange[1] == 'infinite') {
              $arrPriceRange[1] = '100000000000';
            }
            array_push($metaQueryForQueryArgs, array(
              'key' => $meta_value_name,
              'value' => array($arrPriceRange[0], $arrPriceRange[1]),
              'type' => 'numeric',
              'compare' => 'BETWEEN'
            ));
          }
        }
      } else {
        if (strpos($meta_value_name, DZSWTL_QUERY_MINIMUM_ABBREVIATION) !== false && strpos($meta_value_name, DZSWTL_QUERY_MAXIMUM_ABBREVIATION) !== false) {

          $arrPriceRange = explode(',', $nominatedFilterValue);


          if (isset($arrPriceRange[0]) && $arrPriceRange[0] == '') {

          } else {
            array_push($metaQueryForQueryArgs, array(
                'key' => $meta_value_name,
                'value' => $arrPriceRange,
                'compare' => 'IN'
              )
            );
          }
        }
      }
    }
  }

}

/**
 * @param $shopAtts
 * @param $metaQueryForQueryArgs array mutates
 */
function dzswtl_query_addPriceToMetaQuery($shopAtts, &$metaQueryForQueryArgs) {


  $price_range = explode(DZSWTL_QUERY_WITHIN_ABBREVIATION, $shopAtts['price']);


  if (is_array($price_range) && count($price_range) > 1) {

    array_push($metaQueryForQueryArgs, array(
      'key' => '_price',
      'value' => array($price_range[0], $price_range[1]),
      'type' => 'numeric',
      'compare' => 'BETWEEN'
    ));
  }


}

function dzswtl_query_addFeatured($queryArgs, &$taxQueryForQueryArgs) {


  if (is_array($taxQueryForQueryArgs)) {
    if ($queryArgs['post_type'] == 'product') {
      array_push($taxQueryForQueryArgs,
        array(
          'taxonomy' => 'product_visibility',
          'field' => 'name',
          'terms' => 'exclude-from-catalog',
          'operator' => 'NOT IN',
        )
      );
    }
  }
}
function dzswtl_query_addFeaturedToTaxQuery(&$taxQueryForQueryArgs) {

  include_once DZSWTL_PATH . 'inc/php/queries/query-special-feed-types.php';
  dzswtl_woo_get_featured_products_addTaxQuery($taxQueryForQueryArgs);

}
function dzswtl_query_addProductVisiblityToTaxQuery($queryArgs, &$taxQueryForQueryArgs) {


  if (is_array($taxQueryForQueryArgs)) {
    if ($queryArgs['post_type'] == 'product') {
      array_push($taxQueryForQueryArgs,
        array(
          'taxonomy' => 'product_visibility',
          'field' => 'name',
          'terms' => 'exclude-from-catalog',
          'operator' => 'NOT IN',
        )
      );
    }
  }
}

/**
 * @param $TAXONOMY_CATEGORY string
 * @param $shopAtts array mutates
 * @param $taxQueryForQueryArgs array mutates
 */
function dzswtl_query_categoryMutateToShopAtts($TAXONOMY_CATEGORY, &$shopAtts, &$taxQueryForQueryArgs) {


  $catIds = array();
  /** can be slug or whatever @array $catIdentifiers */
  $catIdentifiers = array();

  if (isset($shopAtts['cat']) && $shopAtts['cat']) {
    $catIdentifiers = explode(',', $shopAtts['cat']);
  }


  foreach ($catIdentifiers as $nominatedFilterKey => $nominatedFilterValue) {
    $catIds[$nominatedFilterKey] = DZSWTLHelpers::sanitize_term_slug_to_id($nominatedFilterValue, DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY);
  }
  $catIds = array_values($catIds);
  // -- here we already took data from $_GET
  if ($shopAtts['cat']) {

    // -- subcat overwrites
    if (isset($shopAtts['subcat']) && $shopAtts['subcat']) {
      // -- subcat will overwrite cat
      $shopAtts['subcat_slug'] = $shopAtts['subcat'];
      $shopAtts['subcat'] = DZSWTLHelpers::sanitize_term_slug_to_id($shopAtts['subcat'], $TAXONOMY_CATEGORY);

      $catIds = array($shopAtts['subcat']);
    }


    if (is_array($taxQueryForQueryArgs)) {
      $aux = array(
        'taxonomy' => $TAXONOMY_CATEGORY,
        'field' => 'id',
        'terms' => $catIds,
      );

      array_push($taxQueryForQueryArgs, $aux);
    }

  }


}

function dzswtl_query_customTaxonomyMutateFilterByAndShopAtts($nominatedFilterKey, $nominatedFilterValue, &$taxQueryForQueryArgs) {


  // -- if it is custom tax

  $lab_sanitized = str_replace(DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION, '', $nominatedFilterKey);

  $taxonomyName = $lab_sanitized;

  $term_slug = $nominatedFilterValue;
  $term_id = null;


  $term_slug = explode(',', $term_slug);


  foreach ($term_slug as $lab2 => $val2) {
    $term = get_term_by('slug', $val2, $taxonomyName);

    if ($term && isset($term->term_id)) {
      $term_id = $term->term_id;
    }
  }


  if ($nominatedFilterValue) {
    $aux = array(
      'taxonomy' => $lab_sanitized,
      'field' => 'id',
      'terms' => $term_id,
    );

    array_push($taxQueryForQueryArgs, $aux);
  }


}
