<?php


function dzswtl_generate_style_prop($styleArgs, $keyInLayout, $default_margs, $args = array()) {


  $functionOptions = array(
    'sanitize_to_css_size' => false,
  );

  $functionOptions = array_merge($functionOptions, $args);


  if (isset($styleArgs[$keyInLayout]) && $styleArgs[$keyInLayout] !== '' && (isset($default_margs[$keyInLayout]) == false || $styleArgs[$keyInLayout] != $default_margs[$keyInLayout])) {


    $keyInCss = $keyInLayout;

    if ($keyInLayout == 'background_color'
      || $keyInLayout == 'max_width'
      || $keyInLayout == 'min_width'
      || $keyInLayout == 'margin_top'
      || $keyInLayout == 'font_size'
      || $keyInLayout == 'font_weight'
      || strpos($keyInLayout, 'padding_') === 0
      || strpos($keyInLayout, 'margin_') === 0
    ) {
      $keyInCss = str_replace('_', '-', $keyInLayout);
    }

    if ($keyInLayout == 'position_type') {
      $keyInCss = 'position';
    }

    if ($keyInLayout == 'flex_stretch') {
      $keyInCss = 'flex';
    }


    $css_val = ($styleArgs[$keyInLayout]);

    if (strpos($css_val, '{{get_from_meta-') === 0) {
      $css_val = DZSWTLHelpers::sanitize_dzswtl_replaceGetFromMeta($css_val, $styleArgs['po_id']);
    }
    // -- end get_from_meta


    if ($functionOptions['sanitize_to_css_size']) {
      $css_val = dzs_sanitize_to_css_size($css_val);
    }

    if ($keyInLayout == 'flex_mode') {
      if ($styleArgs[$keyInLayout] == 'flex') {
        $keyInCss = 'display';
      }
    }
    if ($keyInLayout == 'display_type') {
      if ($styleArgs[$keyInLayout] == 'inline-block') {
        $keyInCss = 'display';
      }
    }


    return $keyInCss . ': ' . $css_val . '; ';
  }

  return '';


}


function dzswtl_generate_content_for_style_tag($pargs = array(), $pargs_for_parent = array()) {

  global $dzswtl;

  $margs = array_merge($dzswtl->generate_layout_item_default_margs, $pargs);


  $default_margs = $dzswtl->generate_layout_item_default_margs;


  if ($margs['width'] == 'default') {

    if ($margs['type'] == 'circ') {
      $margs['width'] = '100%';
    }
    if ($margs['type'] == 'rect') {
      $margs['width'] = '{{perc}}';
    }
  }
  if ($margs['width'] == 'default') {
    $margs['width'] = 'auto';
  }
  if ($margs['height'] == 'default') {
    if ($margs['type'] == 'container') {
      $margs['height'] = 'auto';
    }
    if ($margs['type'] == 'rect') {
      $margs['height'] = '40';
    }
  }



  $fout = '';


  $lab = 'width';



  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
    'sanitize_to_css_size' => true,
  ));


  $lab = 'max_width';
  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
    'sanitize_to_css_size' => true,
  ));


  $lab = 'min_width';
  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
    'sanitize_to_css_size' => true,
  ));


//  $lab = 'flex_stretch';
//  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
//    'sanitize_to_css_size' => false,
//  ));


  $lab = 'position_type';


  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
    'sanitize_to_css_size' => false,
  ));


  $lab = 'margin_left';

  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
    'sanitize_to_css_size' => true,
  ));


  $lab = 'margin_right';

  $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
    'sanitize_to_css_size' => true,
  ));

  // -- we need no height for header_item and other args
  if (!(isset($pargs_for_parent['call_from']) && $pargs_for_parent['call_from'] == 'header_item')) {

    // -- not header item

    $lab = 'height';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'color';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => false,
    ));


    $lab = 'background_color';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => false,
    ));


    $lab = 'left';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));

    $lab = 'right';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'bottom';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'top';


    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'margin_top';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'margin_bottom';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'padding_top';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'padding_bottom';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'padding_left';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'padding_right';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));


    $lab = 'font_size';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => true,
    ));

    $lab = 'font_weight';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => false,
    ));


    $lab = 'flex_mode';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => false,
    ));
    $lab = 'display_type';

    $fout .= dzswtl_generate_style_prop($margs, $lab, $default_margs, array(
      'sanitize_to_css_size' => false,
    ));

  }




  return $fout;


}
