<?php
include_once DZSWTL_PATH . 'inc/php/view-functions/extra-html--functions.php';

/**
 * @property string $link Person type
 * @property string $tag Person name
 * @property string $class Person name
 * @property string $extraattr Person name
 * @property boolean $is_download_link Person age
 */
class DzswtlInnerConf extends stdClass {
  public $link = '';
  public $tag = 'span';
  public $class = '';
  public $extraattr = '';
  public $is_download_link = false;
}

/**
 * get the download button link, tag class
 * <code>
 * $link
 * $tag
 * $class
 * $extraattr
 * $is_download_link
 * </code>
 * @param $margs
 * @param $ld
 * @param WP_Post $postObject
 * @return DzswtlInnerConf
 */
function dzswtl_generate_layer_button__configuration($margs, $ld, $postObject, $product = null) {
  global $dzswtl;
  $buttonLink = '';
  $tag = 'div';
  $buttonClass = 'dzswtl--inner-tag inner-tag';
  $extraattr = ' ';


  $foutObj = new DzswtlInnerConf();
  $postId = $postObject->ID;

  $is_download_link = false;


  if ($product) {



    if (isset($ld['button_functionality']) == false || (isset($ld['button_functionality']) && ($ld['button_functionality'] == 'default' || $ld['button_functionality'] == ''))) {
      if (isset($ld['button_type']) && $ld['button_type'] == 'add-to-cart') {
        $ld['button_functionality'] = 'link';
      } else {
        $ld['button_functionality'] = 'direct_link';
      }

    }

    // -- settled button_functionality
    $buttonClass .= ' button-functionality-' . $ld['button_functionality'];

    if (isset($ld['button_type']) && $ld['button_type'] == 'wishlist') {

      $buttonClass .= ' dzswtl-wishlist-but';
      $extraattr .= ' data-post_id="' . ($postObject->ID) . '"';

      if (DZSWTLHelpers::productIsInWishlist($postObject)) {
        $buttonClass .= ' product-is-in-wishlist wishlist-activated';
      }
    }

    if (isset($ld['button_type']) && $ld['button_type'] == 'more-btn') {

      $buttonClass .= ' dzswtl-more-btn';
      $extraattr .= ' data-post_id="' . ($postObject->ID) . '"';
    }



    $buttonLink = DZSWTLHelpers::computeLayoutButtonLink($ld, $product, $margs, $postObject);

    if (isset($ld['button_functionality']) && $ld['button_functionality'] == 'purchase_lightbox') {
      $buttonClass .= ' ultibox-item-delegated';
      $extraattr .= '  data-source="#purchase-lightbox-' . $postObject->ID . '" data-box-bg="#FFFFFF"  data-inline-move="on"';
    }

    // -- free download
    if (DZSWTLHelpers::productIsDownloadable($postObject, true)) {
      $downloads = $product->get_downloads();
      foreach ($downloads as $key => $each_download) {
        $is_download_link = true;
      }

      if ($ld['button_type'] == 'add-to-cart' && $dzswtl->db_mainoptions['add_to_cart__check_if_download_is_already_made'] == 'on') {

        if (DZSWTLHelpers::view_isProductDownloaded($postId)) {
          $buttonClass .= ' product-was-previously-downloaded';
        }
      }
    }


  }


  if ($buttonLink) {
    $tag = 'a';
  } else {
    $tag = 'span';
  }


  $foutObj->class .= ' dzswtl-button';
  if ($ld['button_style'] == 'default') {
    $foutObj->class .= ' button'; // -- try to apply default styling
  }


  $foutObj->link = $buttonLink;
  $foutObj->tag = $tag;
  $foutObj->class = $buttonClass;
  $foutObj->extraattr = $extraattr;
  $foutObj->is_download_link = $is_download_link;


  if (DZSWTLHelpers::checkIfItShouldInvalidateAnchorUpperOfForm($ld)) {
    $foutObj->tag = 'span';
  }

  return $foutObj;

}


/**
 * @param array $ld
 * @param WC_Product $product
 * @param WP_Post $postObject
 * @param $_pf
 * @param $layerButtonAttrs
 * @return string
 */
function dzswtl_generate_layer_button__innerContent($ld, $product, $postObject, $_pf, $layerButtonAttrs) {

  $buttonInnerText = '';


  if (isset($ld['button_type']) && $ld['button_type'] == 'add-to-cart') {

    $addToCartButtonLabel = '';
    if (isset($ld['button_type']) && $ld['button_type'] == 'add-to-cart') {
      $addToCartButtonLabel = DZSWooTableHelper::getAddToCartText($product, $layerButtonAttrs, $ld);

    }


    if ($product && isset($ld['button_style'])) {

      // -- dzs-button
      if ($ld['button_style'] === 'dzs-button') {
        $buttonClasses = 'dzs-button color-normal-highlight color-over-dark      btn-padding-big';


        if (isset($ld['button_style_dzs_button_fullwidth']) && $ld['button_style_dzs_button_fullwidth'] == 'on') {
          $buttonClasses .= ' fullwidth';
        }
        if (isset($ld['button_style_dzs_button_rounded_corners']) && $ld['button_style_dzs_button_rounded_corners'] == 'on') {
          $buttonClasses .= ' btn-style-default';
        }
      }


      // -- dzs-button
      if ($ld['button_style'] === 'dzs-button') {
        $buttonInnerText .= '<span class="' . $buttonClasses . '" >';
        $buttonInnerText .= '<span class="the-text " >';
        $buttonInnerText .= $addToCartButtonLabel;
        $buttonInnerText .= '</span>';
        $buttonInnerText .= '</span>';
      }

      // -- cosco
      if ($ld['button_style'] == 'cosco') {
        $buttonInnerText .= '<span class="dzs-button color-normal-highlight color-over-dark  btn-style-default    btn-padding-big" >';
        $buttonInnerText .= '<span class="over-bg " >';
        $buttonInnerText .= '</span>';
        $buttonInnerText .= '<span class="the-icon " >';
        $buttonInnerText .= '<i class="svg-icon fa fa-shopping-cart"></i>';
        $buttonInnerText .= '</span>';
        $buttonInnerText .= '<span class="the-text " >';
        $buttonInnerText .= $addToCartButtonLabel;
        $buttonInnerText .= '</span>';
        $buttonInnerText .= '</span>';
      }


      // -- gamma
      if ($ld['button_style'] == 'gamma') {
        $buttonInnerText .= '<span class="add-to-cart-btn button-style--gamma" >';
        $buttonInnerText .= '<span class="the-actual-text">';
        $buttonInnerText .= $addToCartButtonLabel;
        $buttonInnerText .= '</span>';
        $buttonInnerText .= '</span>';
      }

    }


    if ($product && $ld['button_style'] == 'default') {
      if ($product->is_type('simple')) {
        if (!DZSWTLHelpers::woocommerceProductIsOutOfStock($product)) {
          $buttonInnerText .= '<form class="add-to-cart-form for-product-type-simple" action="" class="cart" method="get" enctype="multipart/form-data">';
//                            $iout .= woocommerce_quantity_input( array(), $product, false );
          $buttonInnerText .= '<input type="hidden" name="add-to-cart" value="' . $postObject->ID . '"/>';
          $buttonInnerText .= '<button class="add-to-cart-btn dzswtl-button alt">' . $addToCartButtonLabel . '</button>';
          $buttonInnerText .= '</form>';
        }
      } else {

        $buttonInnerText .= '<span class="add-to-cart-btn button-style--default" >';
        $buttonInnerText .= '<span class="the-actual-text">';
        $buttonInnerText .= $addToCartButtonLabel;
        $buttonInnerText .= '</span>';
        $buttonInnerText .= '</span>';
      }
    }


    if (isset($ld['button_style']) && $ld['button_style'] == 'just-icon') {

    }


    // -- just icon
    if (isset($ld['button_style']) && $ld['button_style'] == 'just-icon') {

      $icon_class = 'fa fa-shopping-cart';


      $price = null;
      if ($product) {

        $price = $product->get_price();
      }

      if (DZSWTLHelpers::productIsDownloadable($postObject, true)) {
        $downloads = $product->get_downloads();


        foreach ($downloads as $key => $each_download) {
          $icon_class = 'fa fa-download';
        }
      }

      $buttonInnerText .= '<i class="' . $icon_class . '"></i>';

    }
  } else {
    // -- not add to cart

  }


  if ($ld['button_type'] == 'wishlist') {
    $icon_class = 'svg-icon  fa fa-star-o';


    if (isset($ld['button_style']) && $ld['button_style'] == 'just-icon') {
      $icon_class = 'fa fa-star';

      if (DZSWTLHelpers::productIsInWishlist($postObject)) {
        $icon_class = str_replace('fa-star-o', 'fa-star', $icon_class);
      }


      $buttonInnerText .= '<i class="' . $icon_class . '"></i>';

    }
  }

  if ($ld['button_type'] == 'custom') {

    $customHtmlContent = $ld['button_custom_text'];

    $customHtmlContent = DZSWTLHelpers::sanitizeExtraHtml($customHtmlContent, $_pf, $postObject);

    $buttonInnerText .= do_shortcode($customHtmlContent);
  }

  if ($ld['button_type'] == 'more-btn') {

    $icon_class = 'svg-icon  fa fa-bars';

    $buttonInnerText .= '<div class="dzstooltip-con hover-on-tooltip-con-too">';
    $buttonInnerText .= '<i class="' . $icon_class . '"></i>';
    $buttonInnerText .= '<span class="dzstooltip  arrow-top talign-end style-rounded color-dark-light">';
    $buttonInnerText .= '<span class="dzstooltip--inner">';
    $buttonInnerText .= '<ul class="dzswtl-more-btn--options">';
    $buttonInnerText .= '<li class="dzswtl-more-btn--option dzswtl-wishlist-but';

    if (DZSWTLHelpers::productIsInWishlist($postObject)) {
      $buttonInnerText .= ' product-is-in-wishlist wishlist-activated';
    }

    $buttonInnerText .= '"';

    $buttonInnerText .= '" data-post_id="' . $postObject->ID . '"';
    $buttonInnerText .= '>';

    $buttonInnerText .= '<span class="for-wishlist-not-activated dzs-icon-label-con">';
    $buttonInnerText .= '<i class="dzswtl-more-btn--option--icon fa fa-heart"></i>';
    $buttonInnerText .= '<span class="dzswtl-more-btn--option--label  ">';
    $buttonInnerText .= esc_html__('Like', DZSWTL_ID);
    $buttonInnerText .= '</span>';
    $buttonInnerText .= '</span>';
    $buttonInnerText .= '<span class="for-wishlist-activated dzs-icon-label-con">';
    $buttonInnerText .= '<i class="dzswtl-more-btn--option--icon fa fa-heart-o"></i>';
    $buttonInnerText .= '<span class="dzswtl-more-btn--option--label  ">';
    $buttonInnerText .= esc_html__('Liked', DZSWTL_ID);
    $buttonInnerText .= '</span>';
    $buttonInnerText .= '</span>';

    // -- start share

    $buttonInnerText .= '<li class="dzswtl-more-btn--option dzs-icon-label-con dzsap-multisharer-but"  data-post_id="' . $postObject->ID . '" data-post-url="' . get_permalink($postObject->ID) . '">';
    $buttonInnerText .= '<i class="dzswtl-more-btn--option--icon fa fa-share"></i>';
    $buttonInnerText .= '<span class="dzswtl-more-btn--option--label">';
    $buttonInnerText .= esc_html__('Share', DZSWTL_ID);
    $buttonInnerText .= '</span>';

    // -- start similar

    $terms = get_the_terms($postObject->ID, DZSWTL_WOOCOMMERCE_PRODUCTS_TAG);


    if(is_array($terms) && count($terms)){

      $term = $terms[0];

      $buttonInnerText .= '<li class="  "  >';
      $buttonInnerText .= '<a class="  dzs-woo-ajax  dzs-icon-label-con " href="';


      $buttonInnerText.=get_permalink($postObject->ID);

      $buttonInnerText.='">';

      $buttonInnerText .= '<i class="dzswtl-more-btn--option--icon fa fa-search"></i>';
      $buttonInnerText .= '<span class="dzswtl-more-btn--option--label">';
      $buttonInnerText .= esc_html__('Similar', DZSWTL_ID);
      $buttonInnerText .= '</span>';
      $buttonInnerText .= '</a>';
    }

    $buttonInnerText .= '</ul>';
    $buttonInnerText .= '</span>';
    $buttonInnerText .= '</span>';
    $buttonInnerText .= '</div>';

    global $dzswtl;
    $dzswtl->isEnableMultisharer = true;
  }

  return $buttonInnerText;

}

function dzswtl_generate_layer_button($margs, &$ld, $postObject) {
  global $dzswtl;

  $foutButton = '';


  $foutButton .= '<div class="dzswtl-table-item-button ';
  $foutButton .= ' dzswtl-table-item-button--style-' . $ld['button_style'];

  $foutButton .= '" style="';

  if (isset($ld['font_size']) && $ld['font_size']) {
    $foutButton .= ' font-size: ' . 'inherit' . ';';
  }


  $foutButton .= '" >';


  $inner_con_markup = '';
  $buttonInnerText = '';
  $inner_con_markup_end = '';


  $_pf = null;
  $product = null;
  if (class_exists('WC_Product_Factory')) {
    $_pf = new WC_Product_Factory();
    $product = $_pf->get_product($postObject->ID);
  }


  $layerButtonAttrs = dzswtl_generate_layer_button__configuration($margs, $ld, $postObject, $product);




  // -- try to settle inner markup


  // -- leaving span since button_style DEFAULT summons a FORM


  // -- button styles
  if ($product && isset($ld['button_style'])) {


  }
  // -- button styles END


  // -----------------
  // -- default


  $buttonInnerText = dzswtl_generate_layer_button__innerContent($ld, $product, $postObject, $_pf, $layerButtonAttrs);
  // -----------------
  // -- just icon


  if (isset($ld['button_functionality']) && $ld['button_functionality'] == 'none') {
    $ld['button_functionality'] = 'link';
  }

  if (isset($ld['button_functionality']) && $ld['button_functionality'] == 'purchase_lightbox') {


    wp_enqueue_script('ultibox', $dzswtl->base_url . 'libs/ultibox/ultibox.js');
    wp_enqueue_style('ultibox', $dzswtl->base_url . 'libs/ultibox/ultibox.css');
    wp_enqueue_script('contentscroller', $dzswtl->base_url . 'libs/contentscroller/contentscroller.js');
    wp_enqueue_style('contentscroller', $dzswtl->base_url . 'libs/contentscroller/contentscroller.css');


    $im_arrs = DZSWTLHelpers::get_product_images($postObject->ID, 450);



    $th_arrs = DZSWTLHelpers::get_product_images($postObject->ID, 150);



    if(function_exists('wc_get_product')){

      $product = wc_get_product($postObject->ID);


      $price = $product->get_price();
      ?>
      <?php


      $dzswtl->footer_extra_html .= DZSWooTableHelper::get_purchase_lightbox_html($postObject, $im_arrs, $th_arrs, $product, $price);
    }
  }


  // -- generate the actual markup
  $inner_con_markup = '<' . $layerButtonAttrs->tag . ' class="' . $layerButtonAttrs->class . '" ' . $layerButtonAttrs->extraattr . '';


  if (isset($layerButtonAttrs->link) && $layerButtonAttrs->link) {
    $inner_con_markup .= ' href="' . $layerButtonAttrs->link . '"';
  }
  $inner_con_markup .= '>';


  if ($inner_con_markup) {
    $foutButton .= $inner_con_markup;
  }


  if ($buttonInnerText) {
    $foutButton .= $buttonInnerText;
  }


  $inner_con_markup_end = '</' . $layerButtonAttrs->tag . '>';
  if ($inner_con_markup_end) {
    $foutButton .= $inner_con_markup_end;
  }


  if (isset($ld['extra_html']) && $ld['extra_html']) {

    $extra_html = $ld['extra_html'];
    $extra_html = DZSWTLHelpers::sanitizeExtraHtml($extra_html, $_pf, $postObject);
    $foutButton .= do_shortcode($extra_html);
  }


  $foutButton .= '</div><!--end -->';


  if (isset($ld['button_type']) && $ld['button_type'] == 'add-to-cart') {

  }


  return $foutButton;

}


