<?php
include(DZSWTL_PATH . 'inc/php/view-buttons.php');
include(DZSWTL_PATH . 'inc/php/layout-functions.php');


function dzswtl_parse_item_for_wootable($po, $shopAtts, $ind_nr, $is_zfolio, $layout_mode, $TAXONOMY_CATEGORY, $layout_data) {

  global $dzswtl;

  $iout = '';
  $old_price = '';
  $price_html = '';


  $price = get_post_meta($po->ID, '_regular_price', true);
  $sale = get_post_meta($po->ID, '_sale_price', true);


  if (get_post_meta($po->ID, '_price', true)) {
    $price = get_post_meta($po->ID, '_price', true);
    $old_price = get_post_meta($po->ID, '_regular_price', true);
  }

  $product = null;
  if (function_exists('wc_get_product')) {

    $product = wc_get_product($po->ID);

    if ($product) {

      $price_html = $product->get_price_html();
      if ($shopAtts['recalculate_attribute_data'] == 'on') {
      }

    }
  }


  // -- content


  // -- inside pos
  $iout .= '<div class="dzswtl--item-instance '; // start wootable row

  if ($is_zfolio) {
    $iout .= ' zfolio-item';
  }


  if ($layout_mode == 'grid') {
    $iout .= ' dzs-layout-item';
  }

  if (isset($layout_data['bars']['mainsettings']['item_align']) && $layout_data['bars']['mainsettings']['item_align']) {
    $iout .= ' item-align-' . $layout_data['bars']['mainsettings']['item_align'];
  }

  $stockAvailability = null;
  $isOutOfStock = false;


  if ($product) {
    $stockAvailability = $product->get_availability();
    if ($product->is_featured()) {
      $iout .= ' product-is-featured';
    }
  }

  if ($stockAvailability && isset($stockAvailability['availability']) && $stockAvailability['availability'] == 'Out of stock') {
    $isOutOfStock = true;
    $iout .= ' out-of-stock';
  }

  $iout .= '"';

  $iout .= ' data-post-id="' . $po->ID . '"';
  $iout .= ' style="';

  if (isset($layout_data['bars']['mainsettings']['item_text_align']) && $layout_data['bars']['mainsettings']['item_text_align']) {
    $iout .= ' text-align: ' . $layout_data['bars']['mainsettings']['item_text_align'];
  }

  $iout .= '"';
  if ($shopAtts['return_only_items'] == 'on') {

    $iout .= ' data-layout="' . $shopAtts['layout'] . '"';
  }


  $iout .= '>';


  $iout .= '<div class="table-item--inner  ';


  if (isset($layout_data['bars']['mainsettings']['layout_mode_list_wrap']) && $layout_data['bars']['mainsettings']['layout_mode_list_wrap'] == 'on') {

    $iout .= ' table-item--inner--list-wrap';
  }

  $iout .= '">';


  if (isset($layout_data['bars']) && is_array($layout_data['bars'])) {

    $args = array_merge(array(), $shopAtts);

    $args['ind_nr'] = $ind_nr;
    $args['layout_mode'] = $layout_mode;
    $args['price_html'] = '';
    $args['sale'] = $sale;

    if ($price_html) {
      $args['price_html'] = $price_html;
    }


    $currency = 'usd';
    if (function_exists('get_woocommerce_currency_symbol')) {
      $currency = get_woocommerce_currency_symbol();
    }

    $args['product'] = null;
    $args['taxonomy'] = $TAXONOMY_CATEGORY;
    $args['price'] = $price;
    $args['old_price'] = $old_price;
    $args['currency'] = $currency;
    if ($product) {
      $args['product'] = $product;
    }
    $args['is_out_of_stock'] = $isOutOfStock;


    $priority_blocks = null;

    if (isset($layout_data['priority_blocks']) && is_array($layout_data['priority_blocks']) && count($layout_data['priority_blocks'])) {
      $priority_blocks = $layout_data['priority_blocks'];
    }

    // -- generate the layout data
    $iout .= dzswtl_parse_item__generateLayerItemFromLayoutData($layout_data['bars'], $args, $po, $priority_blocks);

  }


  $iout .= '</div><!-- end .table-item--inner -->';
  $iout .= '</div><!-- end .dzswtl--item-instance -->';


  return $iout;
}


// --
/**
 * generate front end layer item
 * @param $layoutData
 * @param $layerItemBuildFnAtts
 * @param WP_Post $po
 * @param null $priority_blocks
 * @return mixed|string|string[]
 */
function dzswtl_parse_item__generateLayerItemFromLayoutData($layoutData, $layerItemBuildFnAtts, $po, $priority_blocks = null) {

  global $dzswtl;

  // -- generate front end layer item


  $layerOutput = '';




  // -- parse each item
  foreach ($layoutData as $lab => $layoutDataItem) {

    if ($lab === 'mainsettings' || is_numeric($lab) == false) {
      continue;
    }



    if (is_array($layoutDataItem)) {
      $layoutDataItem = array_merge($dzswtl->generate_layout_item_default_margs, $layoutDataItem);
    } else {
      $layoutDataItem = array_merge(array(), $dzswtl->generate_layout_item_default_margs);
    }

    $layoutDataItem['added_extra_html'] = '';

    $priorityIndex = null;
    $priorityIsAutoHide = null;
    if (isset($layoutDataItem['guid']) && $layoutDataItem['guid']) {
      foreach ($priority_blocks as $index => $priority_block) {
        if ($priority_block['guid'] == $layoutDataItem['guid']) {
          $priorityIndex = $index;
          if (isset($priority_block['allow_hide'])) {

            $priorityIsAutoHide = $priority_block['allow_hide'];
          }
        }
      }
    }



    $stringForFeedCustomAttribute = '';
    $attr_data_str = '';
    $valueFromProductMeta = '';


    if ($layoutDataItem['type'] == 'container') {
      $layoutDataItem['feed_from'] = 'none';
      $layoutDataItem['po_id'] = $po->ID;
      $layerOutput .= '<div class="  ';
      if (!isset($layoutDataItem['extra_classes'])) {
        $layoutDataItem['extra_classes'] = '';
      }
      $layoutDataItem['extra_classes'] .= ' dzs-woo-table-container';

      $layerOutput .= dzswtl_view_layout_generateClassesForItem($layerItemBuildFnAtts, $layoutDataItem, $stringForFeedCustomAttribute, $valueFromProductMeta);
      $layerOutput .= '" ';
      $layerOutput .= DZSWTLHelpers::parseItem_generatePriorityOrders($priorityIndex, $priorityIsAutoHide, $priority_blocks);
      $layerOutput .= ' style="' . dzswtl_generate_content_for_style_tag($layoutDataItem) . '" >';
      $layerOutput .= dzswtl_parse_item__generateLayerItemFromLayoutData($layoutDataItem, $layerItemBuildFnAtts, $po, $priority_blocks);
      $layerOutput .= '</div>';

      continue;

    }
    // -- end CONTAINER code


    $isInsideAnchor = false;
    $isLayoutDataItemAnchor = false;

    $layoutDataItemAnchorHref = '';


    $table_content_item_tag = 'div';
    $table_content_item_tag_extraattr = '';


    if (isset($layoutDataItem['link_to']) && $layoutDataItem['link_to'] == 'item') {


      $link = get_permalink($po->ID);

      if (get_post_meta($po->ID, 'dzswtl_replace_item_link', true)) {
        $link = get_post_meta($po->ID, 'dzswtl_replace_item_link', true);
      }
      if ($layoutDataItem['feed_from'] != 'title3') {


        $isLayoutDataItemAnchor = true;
        $layoutDataItemAnchorHref = $link;

      }

      $isInsideAnchor = true;
    }


    if ($layoutDataItem['feed_from'] == 'custom-attribute') {


      $tax_name = $layoutDataItem['custom_attr_name'];


      // -- the value from woocommmerce product

      $productAttributes = (get_post_meta($po->ID, '_product_attributes', true));


      if (is_array($productAttributes)) {

        if (isset($productAttributes[$tax_name]) && $productAttributes[$tax_name] && isset($productAttributes[$tax_name]['value'])) {
          $valueFromProductMeta = $productAttributes[$tax_name]['value'];
        }
      }

      if (!$valueFromProductMeta) {

        if (isset($layoutDataItem['custom_attr_default_value']) && $layoutDataItem['custom_attr_default_value']) {
          $valueFromProductMeta = $layoutDataItem['custom_attr_default_value'];
        }
      }


      if ($tax_name == DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY || $tax_name == DZSWTL_WOOCOMMERCE_PRODUCTS_TAG || $tax_name == 'product_attributes') {

        $final_taxonomy_name = '' . $tax_name;
      } else {

        $final_taxonomy_name = $tax_name;
        if (strpos($tax_name, DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) !== 0) {

          $final_taxonomy_name = DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION . $tax_name;
        }
      }
      $productTerms = wc_get_product_terms($po->ID, $final_taxonomy_name);


      // -- custom attribute

      foreach ($productTerms as $te) {


        // -- put ,
        if (isset($layoutDataItem['attr_style']) && ($layoutDataItem['attr_style'] == 'cosco')) {

        } else {
          if ($stringForFeedCustomAttribute) {

            $stringForFeedCustomAttribute .= ', ';
          } else {
            $stringForFeedCustomAttribute = '';
          }
        }

        $tag = 'span';
        $link = '#';

        if (isset($layoutDataItem['attr_link_to']) && ($layoutDataItem['attr_link_to'] == 'filter')) {
          if ($isInsideAnchor == false) {
            $tag = 'a';
          }
        }

        if (isset($layoutDataItem['attr_link_to']) && ($layoutDataItem['attr_link_to'] == 'filter')) {
          $link_taxonomy_name = $final_taxonomy_name;

          // -- we need customtax_
          if (strpos(DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION, $link_taxonomy_name) === 0) {

          } else {
            $link_taxonomy_name = DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION . $link_taxonomy_name;
          }


          $link = add_query_arg(array(
            $link_taxonomy_name => $te->slug
          ), dzs_curr_url());
        }


        // -- start render
        $stringForFeedCustomAttribute .= '<' . $tag;
        $stringForFeedCustomAttribute .= ' href="' . $link . '"';
        $stringForFeedCustomAttribute .= ' class="custom-attr-label';
        if (isset($layoutDataItem['attr_link_to']) && ($layoutDataItem['attr_link_to'] == 'filter')) {
          $stringForFeedCustomAttribute .= ' dzs-woo-ajax';
        }

        if (isset($layoutDataItem['attr_style'])) {
          $stringForFeedCustomAttribute .= ' style-' . $layoutDataItem['attr_style'];
        }
        $stringForFeedCustomAttribute .= '"';


        $stringForFeedCustomAttribute .= '>';
        if (isset($te->name)) {
          $stringForFeedCustomAttribute .= $te->name;
        } else {

          $stringForFeedCustomAttribute .= $te;
        }
        $stringForFeedCustomAttribute .= '</' . $tag . '>';
        // -- end render custom attribute
      }

      $stringForFeedCustomAttribute = $stringForFeedCustomAttribute ? $stringForFeedCustomAttribute : $valueFromProductMeta;
    }


    /**
     * start generate html ( simple element )
     */
    $layerOutput .= '<' . $table_content_item_tag . ' ' . $table_content_item_tag_extraattr . ' class="';

    $layerOutput .= dzswtl_view_layout_generateClassesForItem($layerItemBuildFnAtts, $layoutDataItem, $stringForFeedCustomAttribute, $valueFromProductMeta);

    $layerOutput .= '"';


    if (isset($layoutDataItem['custom_attr_name']) && $layoutDataItem['custom_attr_name']) {
      $layoutDataItem['custom_attr_name'] = str_replace(DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION, '', $layoutDataItem['custom_attr_name']);
    }
    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'custom-attribute') {
      $layerOutput .= ' data-custom_attr_name="' . $layoutDataItem['custom_attr_name'] . '"';
    }

    $layerOutput .= DZSWTLHelpers::parseItem_generatePriorityOrders($priorityIndex, $priorityIsAutoHide, $priority_blocks);

    $layerOutput .= ' style="' . dzswtl_generate_content_for_style_tag($layoutDataItem) . '" data-header="' . $layoutDataItem['table_header_title'] . '';


    $layerOutput .= '">';

    if ($isLayoutDataItemAnchor) {
      $layerOutput .= '<a href="' . $layoutDataItemAnchorHref . '">';
    }

    // -- start it
    if (isset($layoutDataItem['extra_html_before']) && $layoutDataItem['extra_html_before']) {

      $extra_html_before = $layoutDataItem['extra_html_before'];

      $extra_html_before = DZSWTLHelpers::sanitizeExtraHtml($extra_html_before, null, $po);

      $layerOutput .= do_shortcode($extra_html_before);
    }


    $product = null;

    if ($layerItemBuildFnAtts['product']) {
      $product = $layerItemBuildFnAtts['product'];
    }


    $link = '';
    $link_class = '';


    if (isset($layoutDataItem['link_to']) && $layoutDataItem['link_to']) {


    } else {


      if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'title') {

        $layoutDataItem['link_to'] = 'item';

      }
    }


    if (isset($layoutDataItem['link_to']) && $layoutDataItem['link_to'] == 'item') {


      if ($isInsideAnchor == false) {
        $link = get_permalink($po->ID);
      }
    }
    if (isset($layoutDataItem['link_to']) && $layoutDataItem['link_to'] == 'none') {
      $link = '';
    }


    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'title') {

      $argsForZoomsounds = array_merge(array(), $layoutDataItem);


      foreach ($argsForZoomsounds as $lab => $val) {
        if ($lab !== 'color' && $lab !== 'font_weight') {

          unset($argsForZoomsounds[$lab]);
        }
      }

      $argsForZoomsounds['po_id'] = $po->ID;

      $tag = 'span';

      if ($link) {
        $tag = 'a';
      }


      $title = $po->post_title;

      if (isset($layoutDataItem['desc_count']) && $layoutDataItem['desc_count'] && is_numeric($layoutDataItem['desc_count'])) {


        $maxlen = $layoutDataItem['desc_count'];

        $isHtmlStrippingTags = false;
        $isHtmlTryingToCloseUnclosedTags = false;
        $isStrippingShortcodes = false;
        $cut_exceprt_too_if_excerpt_exists = 'off';
        if ($dzswtl->db_mainoptions['short_description_striptags'] == 'on') {
          $isHtmlStrippingTags = true;
        }
        if ($dzswtl->db_mainoptions['short_description_try_to_close_unclosed_tags'] == 'on') {
          $isHtmlTryingToCloseUnclosedTags = true;
        }
        if ($dzswtl->db_mainoptions['short_description_stripshortcodes'] == 'on') {
          $isStrippingShortcodes = true;
        }


        $title = dzs_get_excerpt(-1, array(
          'maxlen' => $maxlen,
          'content' => $title,
          'striptags' => $isHtmlStrippingTags,
          'stripshortcodes' => $isStrippingShortcodes,
          'forceexcerpt' => false,  // -- if set to true will ignore the manual post excerpt
          'try_to_close_unclosed_tags' => $isHtmlTryingToCloseUnclosedTags,  // -- this will try to close unclosed tags
          'readmore' => $dzswtl->db_mainoptions['short_description_readmore'],
          'readmore_markup' => $dzswtl->db_mainoptions['short_description_readmore_markup'],
          'call_from' => 'default',
        ));
      }


      $layerOutput .= '<' . $tag . ' class="title-feed-a ' . $link_class . '" href="' . $link . '" style="' . dzswtl_generate_content_for_style_tag($argsForZoomsounds) . '">';
      $layerOutput .= $title;
      $layerOutput .= '</' . $tag . '>';
    }


    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'author-name') {

      $url = dzs_curr_url();

      $url = dzs_add_query_arg($url, 'author', $po->post_author);
      $author = get_user_by('id', $po->post_author);



      if($author){

        $layerOutput .= '<a class="author-name" href="' . $url . '">';
        $layerOutput .= $author->data->user_nicename;
        $layerOutput .= '</a>';
      }
    }

    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'id') {
      $layerOutput .= $po->ID;
    }
    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'number') {
      $layerOutput .= (intval($layerItemBuildFnAtts['ind_nr']) + 1);
    }
    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'price') {


      $price_real_number = $layerItemBuildFnAtts['price'];

      $old_price = '';


      $price_before_decimal = $price_real_number;
      $price_after_decimal = '';
      if (strpos($price_real_number, '.') === false) {
        if (isset($layoutDataItem['feed_from_price_style']) && $layoutDataItem['feed_from_price_style'] == 'cosmo') {
          $price_real_number .= '.00';
        }
      }

      if (strpos($price_real_number, '.') !== false) {
        $arr = explode('.', $price_real_number);

        $price_before_decimal = $arr[0];
        $price_after_decimal = $arr[1];


      }


      if (isset($layoutDataItem['feed_from_price_style']) && $layoutDataItem['feed_from_price_style'] == 'default' || $layoutDataItem['feed_from_price_style'] == '') {
        if ($layerItemBuildFnAtts['price_html']) {
          $layerOutput .= $layerItemBuildFnAtts['price_html'];
        }
        if ($layerItemBuildFnAtts['sale']) {

        }
      }
      if (isset($layoutDataItem['feed_from_price_style']) && $layoutDataItem['feed_from_price_style'] == 'show-only-true') {


        if ($price_real_number) {

          $layerOutput .= '<span class="price-show-only-true">';
          $layerOutput .= '<span class="price-show-only-true--currency">';
          $layerOutput .= $layerItemBuildFnAtts['currency'];
          $layerOutput .= '</span>';
          $layerOutput .= '';
          $layerOutput .= '<span class="price-show-only-true--price">';

          $layerOutput .= $price_real_number;
          $layerOutput .= '</span>';
          $layerOutput .= '</span>';
        } else {

          if ($layerItemBuildFnAtts['price_html']) {
            $layerOutput .= $layerItemBuildFnAtts['price_html'];
          }
        }
      }
      if (isset($layoutDataItem['feed_from_price_style']) && $layoutDataItem['feed_from_price_style'] == 'cosmo') {

        $layerOutput .= '<span class="price-show-only-true">';
        $layerOutput .= '<span class="price-show-only-true--currency">';
        $layerOutput .= $layerItemBuildFnAtts['currency'];
        $layerOutput .= '</span>';
        $layerOutput .= '';
        $layerOutput .= '<span class="price-show-only-true--price">';

        $layerOutput .= '<span class="price-before-decimal">';
        $layerOutput .= $price_before_decimal;
        $layerOutput .= '</span>';

        if ($price_after_decimal) {

          $layerOutput .= '<span class="price-after-decimal">';
          $layerOutput .= '.' . $price_after_decimal;
          $layerOutput .= '</span>';
        }

        if ($layerItemBuildFnAtts['old_price'] && $layerItemBuildFnAtts['old_price'] != $layerItemBuildFnAtts['price']) {


          $old_price_real_number = $layerItemBuildFnAtts['old_price'];

          $old_price_before_decimal = $old_price_real_number;
          $old_price_after_decimal = '';
          if (strpos($old_price_real_number, '.') === false) {
            if ($layoutDataItem['feed_from_price_style'] == 'cosmo') {
              $old_price_real_number .= '.00';
            }
          }

          if (strpos($old_price_real_number, '.') !== false) {
            $arr = explode('.', $old_price_real_number);

            $old_price_before_decimal = $arr[0];
            $old_price_after_decimal = $arr[1];


          }


          $layerOutput .= '<span class="old-price-show-only-true--price">';
          $layerOutput .= '<span class="old-price-before-decimal">';
          $layerOutput .= $old_price_before_decimal;
          $layerOutput .= '</span>';

          if ($old_price_after_decimal) {

            $layerOutput .= '<span class="old-price-after-decimal">';
            $layerOutput .= '.' . $old_price_after_decimal;
            $layerOutput .= '</span>';
          }

          $layerOutput .= '</span>';
        }


        $layerOutput .= '</span>';
        $layerOutput .= '</span>';
      }


    }
    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'sale-percent') {


      if ($layerItemBuildFnAtts['old_price'] && $layerItemBuildFnAtts['sale']) {

        $layerItemBuildFnAtts['old_price'] = floatval($layerItemBuildFnAtts['old_price']);
        $layerItemBuildFnAtts['sale'] = floatval($layerItemBuildFnAtts['sale']);

        $perc_discount = (1 - $layerItemBuildFnAtts['sale'] / $layerItemBuildFnAtts['old_price']) * 100;

        $perc_discount = intval($perc_discount);


        $argsForZoomsounds = array_merge(array(), $layerItemBuildFnAtts);
        unset($argsForZoomsounds['product']);


        $layerOutput .= '<div class="perc-discount-bubble">';
        $layerOutput .= '<div class="perc-discount-number">-' . $perc_discount . '%';
        $layerOutput .= '</div>';
        $layerOutput .= '</div>';
      }


    }
    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'stock') {

      if ($product && $product->get_stock_quantity()) { // if manage stock is enabled
        if (number_format($product->get_stock_quantity(), 0, '', '') < 3) { // if stock is low
          $layerOutput .= '<div class="remaining">Only ' . number_format($product->get_stock_quantity(), 0, '', '') . ' left in stock!</div>';
        } else {
          $layerOutput .= '<div class="remaining">' . number_format($product->get_stock_quantity(), 0, '', '') . ' left in stock</div>';
        }
      }
    }
    if (isset($layoutDataItem['feed_from']) && $layoutDataItem['feed_from'] == 'custom-attribute') {


      $layerOutput .= do_shortcode($stringForFeedCustomAttribute);


    }


    if ($layoutDataItem['feed_from'] == 'custom-meta') {


      // -- custom meta

      $custom_meta_name = $layoutDataItem['custom_meta_name'];
      $meta = get_post_meta($po->ID, $custom_meta_name, true);


      if ($custom_meta_name == 'artistname') {
        // -- we also accept author name


        if (get_post_meta($po->ID, $custom_meta_name, true)) {
          $meta = get_post_meta($po->ID, $custom_meta_name, true);
        }

        if (get_post_meta($po->ID, 'dzsap_meta_replace_' . $custom_meta_name, true)) {
          $meta = get_post_meta($po->ID, 'dzsap_meta_replace_' . $custom_meta_name, true);
        }

        if (!($meta)) {

          $recent_author = get_user_by('ID', $po->post_author);


          if (isset($recent_author->display_name)) {

            $meta = $recent_author->display_name;
          }
        }
      }


      if ($meta) {

        $layerOutput .= '<div class="the-custom-meta">';


        if ($custom_meta_name == 'zoomsounds_length') {

          $layerOutput .= DZSWTLHelpers::format_to_time($meta);


        } else {
        }


        if ($meta) {
          $layerOutput .= $meta;

        }


        $layerOutput .= '</div>';
      }


    }

    if ($layoutDataItem['feed_from'] == 'categories') {

      // -- this is inside layer item
      $term_list = wp_get_post_terms($po->ID, $layerItemBuildFnAtts['taxonomy'], array("fields" => "all"));


      $ind = 0;
      foreach ($term_list as $tli) {


        if ($ind) {
          $layerOutput .= ', ';
        }


        $tag = 'span';


        if ($attr_data_str) {

          $attr_data_str .= ', ';
        } else {

          $attr_data_str = '';
        }


        $tag = 'span';
        $link = '#';


        if (isset($layoutDataItem['attr_link_to']) && ($layoutDataItem['attr_link_to'] == 'filter')) {


          if ($isInsideAnchor == false) {
            $tag = 'a';
          }
        }

        if (isset($layoutDataItem['attr_link_to']) && ($layoutDataItem['attr_link_to'] == 'filter')) {


          $link = get_term_link($tli->term_id, $layerItemBuildFnAtts['taxonomy']);
        }
        $attr_data_str .= '<' . $tag;


        if ($link) {

          $attr_data_str .= ' href="' . $link . '"';
        }
        $attr_data_str .= ' class="custom-attr-label';
        if (isset($layoutDataItem['attr_link_to']) && ($layoutDataItem['attr_link_to'] == 'filter')) {
          $attr_data_str .= ' dzs-woo-ajax';
        }

        if (isset($layoutDataItem['attr_style'])) {
          $attr_data_str .= ' style-' . $layoutDataItem['attr_style'];
        }
        $attr_data_str .= '"';


        $attr_data_str .= '>';


        $layerOutput .= $tli->name;
        $layerOutput .= '</' . $tag . '>';


        $ind++;


      }
    }

    if ($layoutDataItem['feed_from'] == 'short-description') {


      $maxlen = 400;


      if (isset($layoutDataItem['desc_count']) && $layoutDataItem['desc_count']) {
        $maxlen = $layoutDataItem['desc_count'];
      }


      $isHtmlStrippingTags = false;
      $isHtmlTryingToCloseUnclosedTags = false;
      $isStrippingShortcodes = false;
      $cut_exceprt_too_if_excerpt_exists = 'off';
      if ($dzswtl->db_mainoptions['short_description_striptags'] == 'on') {
        $isHtmlStrippingTags = true;
      }
      if ($dzswtl->db_mainoptions['short_description_try_to_close_unclosed_tags'] == 'on') {
        $isHtmlTryingToCloseUnclosedTags = true;
      }
      if ($dzswtl->db_mainoptions['short_description_stripshortcodes'] == 'on') {
        $isStrippingShortcodes = true;
      }
      if (isset($layoutDataItem['short_desc_cut_as_well']) && $layoutDataItem['short_desc_cut_as_well']) {
        $cut_exceprt_too_if_excerpt_exists = $layoutDataItem['short_desc_cut_as_well'];
      }


      $layerOutput .= '<section>';
      $postExcerpt = dzs_get_excerpt($po->ID, array(
          'maxlen' => $maxlen,
          'striptags' => $isHtmlStrippingTags,
          'stripshortcodes' => $isStrippingShortcodes,
          'forceexcerpt' => false,  // -- if set to true will ignore the manual post excerpt
          'try_to_close_unclosed_tags' => $isHtmlTryingToCloseUnclosedTags,  // -- this will try to close unclosed tags
          'readmore' => $dzswtl->db_mainoptions['short_description_readmore'],
          'readmore_markup' => $dzswtl->db_mainoptions['short_description_readmore_markup'],
          'cut_exceprt_too_if_excerpt_exists' => $cut_exceprt_too_if_excerpt_exists,
          'content' => '',
          'call_from' => 'default'
        )
      );

      $layerOutput .= $postExcerpt;
      $layerOutput .= '</section>';


    }
    if ($layoutDataItem['feed_from'] == 'full-description') {


      $layerOutput .= '<section>';
      $layerOutput .= do_shortcode($po->post_content);

      $layerOutput .= '</section>';

    }


    $im_width = 500;
    $im_height = 500;


    $im_size = 'full';
    if (isset($layoutDataItem['thumbnail_size']) && $layoutDataItem['thumbnail_size']) {


      if (strpos($layoutDataItem['thumbnail_size'], ',') !== false) {

        $szs = explode(',', $layoutDataItem['thumbnail_size']);


        $im_width = $szs[0];
        $im_height = $szs[1];

        $im_size = array($im_width, $im_height);
      } else {

        if (is_numeric($layoutDataItem['thumbnail_size'])) {

          $im_size = array($layoutDataItem['thumbnail_size']);
        } else {

          $im_size = $layoutDataItem['thumbnail_size'];
        }
      }
    }


    global $content_width;
    $content_width = 2000;


    $image = DZSWTLHelpers::get_thumbnail_src($po, $im_size);

    if ($layoutDataItem['feed_from'] == 'product-image') {


      if (isset($image[0])) {
        $layerOutput .= '<div class="fullwidth-image divimage lazyloading-transition-fade" data-img-src="' . $image . '" data-thumbnail-height="';

        if (isset($layoutDataItem['thumbnail_height']) && $layoutDataItem['thumbnail_height']) {
          $layerOutput .= $layoutDataItem['thumbnail_height'];
        }


        $layerOutput .= '" ';
        $layerOutput .= ' style="';


        if (isset($layoutDataItem['thumbnail_height']) && $layoutDataItem['thumbnail_height']) {
          $layerOutput .= 'padding-top: ' . (floatval($layoutDataItem['thumbnail_height']) * 100) . '%';
        }

        $layerOutput .= '"></div>';

      }


    }
    if ($layoutDataItem['feed_from'] == 'ratings') {
      // -- layer item ratings

      $average = '';

      if ($layerItemBuildFnAtts['post_type'] == 'product') {

        $_pf = new WC_Product_Factory();
        $product = $_pf->get_product($po->ID);
      }
      if ($layerItemBuildFnAtts['post_type'] == 'dzsap_items') {


        $average = get_post_meta($po->ID, '_dzsap_rate_index', true);

      }


      if ($product) {


        $average = $product->get_average_rating();


      }
      $perc = ((floatval($average) / 5) * 100);


      if ($layoutDataItem['feed_from_ratings_style'] == 'default') {


        $layerOutput .= '<div class="star-rating"><span style="width:' . (($average / 5) * 100) . '%"><strong itemprop="ratingValue" class="rating">' . $average . '</strong> ' . __('out of 5', 'woocommerce') . '</span></div>';
      }

      if ($layoutDataItem['feed_from_ratings_style'] == 'wootable-stars') {

        $layerOutput .= '<div class="star-rating-con">';

//					echo 'whyy?';
        $layerOutput .= '<span class="rating-bg"><span class="rating-inner">{{starssvg}}</span></span><span class="rating-prog" style="width: ' . $perc . '%;"><span class="rating-inner">{{starssvg}}</span></span>';
        $layerOutput .= '</div>';
      }


    }


    if ($layoutDataItem['feed_from'] == 'add-to-cart') {

      // -- deprecated
      $layoutDataItem['feed_from'] = 'button';
      $layoutDataItem['button_type'] = 'add-to-cart';

    }
    if ($layoutDataItem['feed_from'] == 'button') {


      $layerOutput .= dzswtl_generate_layer_button($layerItemBuildFnAtts, $layoutDataItem, $po);

    }


    if ($layoutDataItem['feed_from'] == 'acf') {


      if ($dzswtl->is_plugin_active('advanced-custom-fields/acf.php') || $dzswtl->is_plugin_active('advanced-custom-fields-pro/acf.php')) {

        $value = get_field($layoutDataItem['custom_acf_name'], $po->ID);
        if (is_array($value) && isset($value[0])) {
          $layerOutput .= '<a href="' . get_permalink($value[0]->ID) . '">' . $value[0]->post_title . '</a>';
        }
      }


    }
    if ($layoutDataItem['feed_from'] == DZSWTL_BUILDER_COL_TYPE_ZOOMSOUNDS_PLAYER) {
      // -- here we generate zoomsounds
      if (defined('DZSAP_VERSION')) {

        include_once(DZSWTL_PATH . 'inc/php/zoomsounds-integration/zoomsounds-functions.php');

        $layerOutput .= dzswtl_zoomsounds_generateLayerItemFromLayoutData($po, $layoutDataItem, $layoutData, $layerItemBuildFnAtts, $image, $dzswtl);
      }

    }


    if ($isLayoutDataItemAnchor) {
      $layerOutput .= '</a>';
    }
    $layerOutput .= '</' . $table_content_item_tag . '>';

  }

  $layerOutput = dzswtl_custom_transform($layoutData, $layerOutput);


  return $layerOutput;


}




