<?php

include_once DZSWTL_PATH . 'inc/php/view-functions/shortcode-parts/generate-pagination.php';
include_once DZSWTL_PATH . 'inc/php/view-functions/shortcode-parts/generate-pagination-con.php';


/**
 * [dzs_woo_table]
 * @param array $userInputShortcodeAtts - {return_only_items==="on"} returns only the items
 * @return false|string
 */
function dzswtl_shortcode_woo_table($userInputShortcodeAtts = array()) {

  // -- main shortcode
  include_once DZSWTL_PATH . 'inc/php/queries/mainQueryFunctions.php';
  include_once DZSWTL_PATH . 'inc/php/view-functions/generate-shortcode-options-functions.php';

  global $post, $dzswtl;
  $fout = '';


  /** shortcode as sent from the user  @array $shortcodeAtts */
  $defaultShortcodeAtts = array(
    'layout' => '', // -- slug
    'called_from' => 'default', // -- default -- default call
    'layout_mode' => 'default',
    'post_type' => 'product',
    'posts_per_page' => '3',

    'page_url' => '',
    'feed_from' => '', // -- normal or wishlist


    'pagination_prev_next' => 'off',
    'pagination_include_dots' => 'on',
    'pagination_range' => '2',
    'randomize' => 'off',
    'search' => 'default',

    'custom_attr_name' => '',
    'custom_meta_name' => '',
    'custom_meta_values' => '',
    'pagination_skin' => 'default',
    'pagination_method' => 'pages', // -- "pages" or "scroll"
    'pagination_custom_goto_page' => 'off',
    'per_row' => '', // -- just input 4,8,12 if you want per row selection


    'order' => 'default',
    'orderby' => 'default',
    'sort_by' => 'default', // -- set by user
    'product_attributes' => 'default',

    'ids' => '', // -- a list of ids
    'exclude_ids' => '', // -- a list of ids
    'hard_meta_query' => '', // -- a JSON , meta query will overwrite all

    'extra_classes' => '',
    'post_status' => 'publish', // publish, private or any
    'button_style' => 'default',
    'recalculate_attribute_data' => 'default', // -- recalculate attribute data to adjust filters
    'show_filtered_by' => 'off', // -- show filtered by container
    'get_preview_data' => 'off', // -- get the preview 2 items
    'return_only_items' => 'off', // -- return only items "on" for ajax

    'query_is_show_only_featured' => "off", // -- show only
    'query_is_main_container_target' => "off", // -- is it the main query target

  );

  // TODO: maybe place overwritable parameters that will be added in allcheck ( allcheck_cat ) then overwritten by $_GET then overwritten by margs

  // -- removed from default margs - cat,subcat,price,term_id,search,order,orderby,ids

  // -- if these will be set they will be hard set
  $shortcodeAtts = $defaultShortcodeAtts;
  if (is_array($userInputShortcodeAtts)) {
    $shortcodeAtts = array_merge($defaultShortcodeAtts, $userInputShortcodeAtts);
  }
  /** mixed date - shortcode + custom atts   @array $shopAtts */
  $shopAtts = array_merge($shortcodeAtts, array(
    'handpickedIds' => '',
    'actual_search_for_ajax' => 'default',  // -- mutates from search_adjust, if it is "default", then leave the original
    'actual_search_forceUpdateFilters' => array(),  // -- updates filters based on actual_search
  ));


  $hardCodedKeys = DZSWTLHelpers::generateHardCodedKeys($userInputShortcodeAtts, $dzswtl);

  /** vars specifically for ajax @var $ajaxAtts */
  $ajaxAtts = array();


  $layoutData = array();


  $fout = '';
  $productIdsThatFitQuery = array();


  $temp_ranges_arr = array();

  $paged = 1;


  $productAttsForTaxQueryForQueryArgs = array();
  $taxQueryForQueryArgs = array();
  /** used for FILTERED BY list @array $filterByList */
  $view_filteredByList = array(); // -- the filters
  $metaQueryForQueryArgs = array();
  $nominatedFilters = array();
  $extra_classes_main_container = ''; // -- extra classes for the .dzs-woo-table container


  $shopAtts['handpickedIds'] = null;
  $mainLayoutSettings = null;

  $TAXONOMY_CATEGORY = DZSWTL_WOOCOMMERCE_PRODUCTS_CATEGORY;
  if ($shortcodeAtts['post_type'] == 'dzsvideo') {
    $TAXONOMY_CATEGORY = 'dzsvideo_category';
  }
  if ($shortcodeAtts['post_type'] == 'dzsap_items') {
    $TAXONOMY_CATEGORY = 'dzsap_category';
  }

  $getFiltersQuerySource = array();
  if ($shortcodeAtts['return_only_items'] == 'off') {
    $getFiltersQuerySource = $_GET;

    foreach ($getFiltersQuerySource as $lab => $val) {
      if (strpos($lab, DZSWTL_QUERY_META_VALUE_ABBREVIATION)) {
        $getFiltersQuerySource[$lab] = urldecode($getFiltersQuerySource[$lab]);
      }
    }
    foreach ($getFiltersQuerySource as $lab => $val) {
      if (in_array($lab, DZSWTL_GET_INTERNAL_WP)) {
        unset($getFiltersQuerySource[$lab]);
      }
    }
  } else {
    if (isset($shortcodeAtts['userSetFilters']) && $shortcodeAtts['userSetFilters']) {
      $getFiltersQuerySource = $shortcodeAtts['userSetFilters'];

      if (is_array($shortcodeAtts['userSetFilters'])) {
        foreach ($shortcodeAtts['userSetFilters'] as $userSetFilterLab => $userSetFilterVal) {
          $shopAtts[$userSetFilterLab] = $userSetFilterVal;
        }
      }
    }
  }


  dzswtl_woo_mainQueryInitialSanitation($shortcodeAtts, $shopAtts, $metaQueryForQueryArgs, $nominatedFilters, $getFiltersQuerySource);
  $layoutData = dzswtl_woo_getLayoutDataObject($shopAtts['layout']);

  if (isset($layoutData['bars']) && isset($layoutData['bars']['mainsettings'])) {
    $mainLayoutSettings = $layoutData['bars']['mainsettings'];
  }


  $queryArgs = dzswtl_query_buildInitialWpQuery($shortcodeAtts, $shopAtts);


  dzswtl_query_searchAdjust($shopAtts, $layoutData, $nominatedFilters, $queryArgs);


  // -- all checks include pa
  foreach ($nominatedFilters as $nominatedFilterKey => $nominatedFilterValue) {
    // -- all checks
    if (strpos($nominatedFilterKey, DZSWTL_QUERY_PRODUCT_ATTRIBUTE_ABBREVIATION) === 0) {
      dzswtl_query_productAttributeMutateFilterByAndPa($nominatedFilterValue, $nominatedFilterKey, $shopAtts, $productAttsForTaxQueryForQueryArgs);
    }
    // -- if we have get meta value it is okay ;)
    if (strpos($nominatedFilterKey, DZSWTL_QUERY_META_VALUE_ABBREVIATION) === 0) {
      dzswtl_query_metaValueMutateShopAttsAndFilterChecks($nominatedFilterKey, $nominatedFilterValue, $shopAtts, $nominatedFilters);
    }
    if ($nominatedFilterKey == 'subcat') {
      $shopAtts[$nominatedFilterKey] = $nominatedFilterValue;
    }
    if (strpos($nominatedFilterKey, DZSWTL_QUERY_CUSTOM_TAX_ABBREVIATION) === 0) {
      dzswtl_query_customTaxonomyMutateFilterByAndShopAtts($nominatedFilterKey, $nominatedFilterValue, $taxQueryForQueryArgs);
    }
  }
  // -- end all checks


  $view_filteredByList = dzswtl_filters_getFilteredByList($getFiltersQuerySource);


  dzswtl_query_sanitizeProductAtts($productAttsForTaxQueryForQueryArgs);
  dzswtl_query_addProductAttsToTaxQuery($productAttsForTaxQueryForQueryArgs, $taxQueryForQueryArgs);
  dzswtl_query_categoryMutateToShopAtts($TAXONOMY_CATEGORY, $shopAtts, $taxQueryForQueryArgs);


  if ($dzswtl->db_mainoptions['filter_exclude_non_catalog_items'] == 'on') {
    dzswtl_query_addProductVisiblityToTaxQuery($queryArgs, $taxQueryForQueryArgs);
  }

  if ($shortcodeAtts['query_is_show_only_featured'] == 'on') {
    dzswtl_query_addFeaturedToTaxQuery($taxQueryForQueryArgs);
  }


  if (is_array($taxQueryForQueryArgs) && count($taxQueryForQueryArgs)) {
    if (!isset($taxQueryForQueryArgs['relation'])) {
      $taxQueryForQueryArgs['relation'] = 'AND';
    }
    $queryArgs['tax_query'] = $taxQueryForQueryArgs;
  }


  if (isset($shopAtts['rating']) && $shopAtts['rating']) {
    dzswtl_query_addRatingToMetaQuery($shopAtts, $metaQueryForQueryArgs);
  }
  if (isset($shopAtts['price']) && $shopAtts['price']) {
    dzswtl_query_addPriceToMetaQuery($shopAtts, $metaQueryForQueryArgs);
  }


  dzswtl_query_addRangesToMetaQuery($shopAtts, $metaQueryForQueryArgs);


  dzswtl_query_orderByAdjustQuery($shopAtts, $queryArgs);


  $isRemoveOutOfStockItems = false;

  if (!isset($mainLayoutSettings['query_remove_out_of_stock_options']) || $mainLayoutSettings['query_remove_out_of_stock_options'] === 'default') {

    if (class_exists('WC_Admin_Settings')) {
      $setting_hide_out_of_stock = WC_Admin_Settings::get_option('woocommerce_hide_out_of_stock_items', 'off');
      if ($setting_hide_out_of_stock == 'yes') {
        $isRemoveOutOfStockItems = true;

      }
    }
  } else {
    if ($mainLayoutSettings['query_remove_out_of_stock_options'] === 'on') {
      $isRemoveOutOfStockItems = true;
    }
  }

  if ($isRemoveOutOfStockItems) {
    if ($queryArgs['post_type'] == 'product') {
      $metaQueryForQueryArgs[] = array(
        'key' => '_stock_status',
        'value' => 'outofstock',
        'compare' => 'NOT IN'
      );
    }
  }

  // -- meta_query final
  if (is_array($metaQueryForQueryArgs) && count($metaQueryForQueryArgs)) {
    if (!isset($metaQueryForQueryArgs['relation'])) {
      $metaQueryForQueryArgs['relation'] = 'AND';
    }
    $queryArgs['meta_query'] = $metaQueryForQueryArgs;
  }


  if ($shopAtts['randomize'] == 'on') {
    $queryArgs['posts_per_page'] = '-1';
    $queryArgs['orderby'] = 'rand';
  }


  $shopQuery = null;
  $shopPosts = null;


  if (isset($shopAtts['type']) && $shopAtts['type']) {

    include_once DZSWTL_PATH . 'inc/php/queries/query-special-feed-types.php';

    if ($shopAtts['type'] == DZSWTL_SHOP_FEED_TYPE['WISHLIST']) {
      $shopAtts['handpickedIds'] = dzswtl_woo_wishlistSanitize();
    }
    if ($shopAtts['type'] == DZSWTL_SHOP_FEED_TYPE['DOWNLOADED']) {
      $shopAtts['handpickedIds'] = dzswtl_query_getDownloadedIds();
    }
    if ($shopAtts['type'] == DZSWTL_SHOP_FEED_TYPE['FEATURED']) {
      $shopAtts['handpickedIds'] = dzswtl_woo_get_featured_products($shopAtts);
    }
    $shopAtts['handpickedIds'] = explode(',', $shopAtts['handpickedIds']);
  }


  if ($shortcodeAtts['return_only_items'] !== 'on') {

  }


  if ($dzswtl->shop_index == 1 || $shortcodeAtts['query_is_main_container_target'] === 'on') {
    $dzswtl->args_curr_wootable = array_merge(array(), $shopAtts);
  }

  if ($shopAtts['get_preview_data'] == 'on') {
    $the_slug = 'preview-post-1';
    $the_slug2 = 'preview-post-2';
    $queryArgs = array(
      'post_type' => 'product',
      'post_status' => DZSWTL_POST_STATUS_PREVIEW,
      'post_name__in' => array($the_slug, $the_slug2),
      'numberposts' => 2,
    );
  }
  if (is_array($shopAtts['handpickedIds']) && count($shopAtts['handpickedIds'])) {
    $queryArgs = array(
      'post_type' => 'any',
      'post__in' => $shopAtts['handpickedIds'],
      'paged' => $shopAtts['paged'],
      'orderby' => 'post__in',
      'posts_per_page' => $shopAtts['posts_per_page'],
    );
  }

  if ($shortcodeAtts['exclude_ids']) {
    $queryArgs['post__not_in'] = explode(',', $shortcodeAtts['exclude_ids']);
  }

  if ($shopAtts['return_only_items'] === 'on') {

  }

  // -- create the query here !!!
  $shopQuery = new WP_Query($queryArgs);


  // -- if it is big page, redo query
  if ($shopQuery && $shopQuery->post_count == 0 && intval($shopAtts['paged']) > 1) {
    $queryArgs['paged'] = '1';
    $shopAtts['paged'] = '1';
    $shopQuery = new WP_Query($queryArgs);
  }


  $countAllNumber = null;

  $originalQuery = $shopQuery->request;

  if ($dzswtl->db_mainoptions['filter_calculate_all_products_count'] === 'on') {
    global $wpdb;
    $countAllQuery = $originalQuery;

    $countAllQuery = preg_replace('/SELECT SQL_CALC_FOUND_ROWS.*?' . $wpdb->prefix . 'posts.ID/', 'SELECT COUNT(' . $wpdb->prefix . 'posts.ID) AS CNT', $countAllQuery);
    $countAllQuery = preg_replace('/GROUP BY .*? /', '', $countAllQuery);


    $results = $wpdb->get_results($countAllQuery);

    if (isset($results[0]) && isset($results[0]->CNT) && intval($results[0]->CNT)) {
      $countAllNumber = $results[0]->CNT;
    }
  }

  if ($shopAtts['recalculate_attribute_data'] === 'on') {
    $originalQuery = $shopQuery->request;

    global $wpdb;


    $countAllThatFitQuery = preg_replace('/LIMIT \d*?, .*?\d*?$/', 'LIMIT 0, 100000', $originalQuery);;


    $results = $wpdb->get_results($countAllThatFitQuery);
    $results = DZSWTLFilters::getCountAllQueryResults($originalQuery);


    foreach ($results as $result) {
      array_push($productIdsThatFitQuery, $result->ID);
    }
  }


  if ($shopQuery) {
    $shopPosts = $shopQuery->posts;
  }


  // -- visual start

  /**
   * -----------------
   * visual attributes
   */
  $visualAtts = array(
    'pagination_skin' => '',
    'max_num_pages' => '',
    'layoutSkin' => '', // -- already has skin- in the name
    'actual_search_for_ajax' => 'default',
    'isZfolio' => false,
    'isScroller' => false,
    'show_filtered_by' => $shortcodeAtts['show_filtered_by'],
  );

  $visualAtts['max_num_pages'] = $shopQuery->max_num_pages;

  if ($mainLayoutSettings && isset($mainLayoutSettings['skin'])) {
    $visualAtts['layoutSkin'] = $mainLayoutSettings['skin'];
  }

  $cssClassPaginationSkin = '';

  $visualAtts['pagination_skin'] = $shopAtts['pagination_skin'];
  if ($visualAtts['pagination_skin'] == 'default') {
    $cssClassPaginationSkin = ' pagination-' . $visualAtts['layoutSkin'];
  } else {
    $cssClassPaginationSkin = ' pagination-' . $visualAtts['pagination_skin'];
  }
  if ($shopAtts['actual_search_for_ajax']) {
    $visualAtts['actual_search_for_ajax'] = $shopAtts['actual_search_for_ajax'];
  }


  $pagination_method = '';
  $layout_mode_grid_cols = '';

  if (isset($shortcodeAtts['pagination_method'])) {
    $pagination_method = $shortcodeAtts['pagination_method'];
  }


  if (isset($mainLayoutSettings['layout_mode_grid_cols'])) {
    $layout_mode_grid_cols = $mainLayoutSettings['layout_mode_grid_cols'];
  }


  if (isset($mainLayoutSettings['grid_mode'])) {
    if ($mainLayoutSettings['grid_mode'] == 'masonry' || $mainLayoutSettings['grid_mode'] == 'scroller') {
      $visualAtts['isZfolio'] = true;
    }

    if ($mainLayoutSettings['grid_mode'] == 'scroller') {

      $visualAtts['isScroller'] = true;
    }

  }


  $exo_skeleton = '';

  $isCalledFromNewContent = false;

  if ((isset($_GET['dzswtl_action']) && $_GET['dzswtl_action'] == 'load_new_content') || (isset($_POST['action']) && $_POST['action'] == 'dzswtl_load_new_content')) {
    $isCalledFromNewContent = true;
  }

  if ($isCalledFromNewContent == false && $dzswtl->debug_mode == true) {

  }


  $layout_mode = 'list';
  if ($shopAtts['layout_mode'] == 'default') {
    if (isset($mainLayoutSettings['layout_mode']) && $mainLayoutSettings['layout_mode']) {
      $shopAtts['layout_mode'] = $mainLayoutSettings['layout_mode'];
    }
  }


  if ($shopAtts['layout_mode'] == 'default') {
    $shopAtts['layout_mode'] = 'list';
  }
  $layout_mode = $shopAtts['layout_mode'];


  /**
   * start output
   */

  if (isset($_GET['add-to-cart']) && $_GET['add-to-cart']) {
    $fout .= DZSWTLHelpers::generateHtmlWooCommerceMessage($_GET['add-to-cart']);
  }


  // -- main class
  // -- here
  $fout .= '<div class="dzs-woo-table shop-index-' . $dzswtl->shop_index . ' layout-' . $layout_mode . ' ' . $visualAtts['layoutSkin'] . ' ' . $cssClassPaginationSkin;

  if ($shortcodeAtts['query_is_main_container_target'] === 'on') {
    $fout .= ' ' . DZSWTL_VIEW_AJAX_MAIN_SHORTCODE_CONTAINER;
  }

  if (isset($mainLayoutSettings['extra_classes']) && $mainLayoutSettings['extra_classes']) {
    $fout .= ' ' . $mainLayoutSettings['extra_classes'];
  }

  if ($extra_classes_main_container) {
    $fout .= ' ' . $extra_classes_main_container;
  }


  // -- todo: layout can be array sometimes .. treat that case :)
  if (is_array($shopAtts['layout'])) {

  } else {
    $fout .= ' layout-id-' . $shopAtts['layout'];
  }


  if (isset($mainLayoutSettings['item_transition']) && $mainLayoutSettings['item_transition']) {
    $fout .= ' item-transition-' . $mainLayoutSettings['item_transition'];
  }
  if (isset($mainLayoutSettings['autohidden_has_expandable_button']) && $mainLayoutSettings['autohidden_has_expandable_button'] == 'on') {
    $fout .= ' auto-hide--has-expandable-button';
  }

  if ($layout_mode == 'grid') {
    $fout .= ' dzs-layout';
    $fout .= ' ' . $layout_mode_grid_cols;
  }

  $fout .= ' ' . $shopAtts['extra_classes'];

  if ($visualAtts['isZfolio']) {
    $fout .= ' woo-table-is-zfolio';
  }

  $fout .= '"';


  if (count($hardCodedKeys)) {
    $fout .= ' data-hard-coded-keys=\'' . json_encode($hardCodedKeys) . '\'';
  }

  if (isset($mainLayoutSettings['theme']) && $mainLayoutSettings['theme']) {
    $fout .= ' ' . $mainLayoutSettings['theme'];
  }

  if ($layout_mode == 'grid') {


    if (isset($mainLayoutSettings['layout_mode_grid_cols_gap']) && $mainLayoutSettings['layout_mode_grid_cols_gap']) {

      $fout .= ' data-margin="' . $mainLayoutSettings['layout_mode_grid_cols_gap'] . '"';
    }
  }

  if ($countAllNumber !== null) {
    $fout .= ' data-count-all-number="' . $countAllNumber . '"';
  }


  $dzswootableOptions = dzswtl_view_generateShortcodeOptions($mainLayoutSettings);

  $fout .= ' data-options=\'' . json_encode($dzswootableOptions) . '\'';


  if (count($shopAtts['actual_search_forceUpdateFilters'])) {
    $fout .= ' data-actual_search_forceUpdateFilters=\'' . json_encode($shopAtts['actual_search_forceUpdateFilters']) . '\'';
  }

  if ($post) {
    if ($post->ID) {
      $fout .= ' data-post-id="' . $post->ID . '"';
    }

    if ($post->post_content) {
      $dzswtl->postContentForLoadNewContent = $post->post_content;
    }

  }
  if ($shopAtts['randomize'] == 'on') {
    $fout .= ' data-random-posts="';
    if ($shopPosts) {
      if (is_array($shopPosts)) {
        $sw = false;
        $stringRandomPostIds = '';
        foreach ($shopPosts as $po) {
          if ($sw) {
            $stringRandomPostIds .= ',';
          }
          $stringRandomPostIds .= $po->ID;
          $sw = true;
        }
        if ($stringRandomPostIds) {
          $fout .= $stringRandomPostIds;
          $visualAtts['max_num_pages'] = 1;
          $shopAtts['handpickedIds'] = explode(',', $stringRandomPostIds);
          if (count($shopAtts['handpickedIds']) > intval($shopAtts['posts_per_page'])) {
            $visualAtts['max_num_pages'] = ceil(count($shopAtts['handpickedIds']) / intval($shopAtts['posts_per_page']));
          }
          if (count($shopAtts['handpickedIds']) > intval($shopAtts['posts_per_page'])) {
            $shopAtts['handpickedIds'] = array_slice($shopAtts['handpickedIds'], 0, intval($shopAtts['posts_per_page']));
          }

        }
      }
    }

    $fout .= '"';
  }

  $fout .= ' data-pagination-method="' . $pagination_method . '"';
  $fout .= ' data-max_num_pages="' . $visualAtts['max_num_pages'] . '"';
  $fout .= ' data-curr_paged="' . $paged . '"';
  $fout .= ' data-recalculate_attribute_data="' . $shopAtts['recalculate_attribute_data'] . '"';


  $fout .= ' style="opacity:0; "';

  $fout .= '>';


  if ($visualAtts['show_filtered_by'] === 'on') {
    $filtersByFout = $dzswtl->classFilters->view_generateFiltersConForWooTable($view_filteredByList);
    if ($shopAtts['return_only_items'] !== 'on') {
      $fout .= $filtersByFout;
    } else {
      $ajaxAtts['filters_by_con_output'] = $filtersByFout;
    }
  }


  if ($visualAtts['isZfolio']) {

    $fout .= '<div class=" zfolio skin-custom auto-init delay-effects ' . $layout_mode_grid_cols . '';


    $fout .= '" data-options=\'';


    $arr = array();


    if ($visualAtts['isScroller']) {
      $arr['settings_mode'] = 'scroller';
    }

    $fout .= json_encode($arr);


    $fout .= '\'>';


  }


  $class_main_inner = 'dzs-woo-table--inner ';


  if ($visualAtts['isZfolio']) {

    $class_main_inner = 'dzswtl-ajax-container items';
  }

  $fout .= '<div class="' . $class_main_inner . ' ';

  if ($layout_mode == 'grid') {
  }

  $fout .= '">';


  if ($visualAtts['isZfolio']) {

  }


  if ($layout_mode != 'grid') {

    // -- list header

    $isHavingTitle = false;


    if (isset($layoutData['bars']) && is_array($layoutData['bars'])) {

      foreach ($layoutData['bars'] as $nominatedFilterKey => $layoutDataItem) {

        if ($nominatedFilterKey === 'mainsettings') {
          continue;
        }


        if (isset($layoutDataItem['table_header_title']) && $layoutDataItem['table_header_title']) {
          $isHavingTitle = true;
        }
      }
    }


    if ($isHavingTitle) {

      $fout .= '<div class="dzswtl--item-instance table--header ';
      $fout .= '">';
      $fout .= '<div class="table-item--inner table-item--inner--list ';
      $fout .= '">';


      foreach ($layoutData['bars'] as $nominatedFilterKey => $layoutDataItem) {

        if ($nominatedFilterKey === 'mainsettings') {
          continue;
        }


        if (isset($layoutDataItem['type']) && $layoutDataItem['type'] == 'container') {
          $layoutDataItem['feed_from'] = 'none';
        }


        $args_for_parent = array_merge($shopAtts, array(
          'call_from' => 'header_item',
        ));

        $fout .= '<div class="' . $layout_mode . '-col " style="' . dzswtl_generate_content_for_style_tag($layoutDataItem, $args_for_parent) . '">';


        $fout .= '<div class="table--header--item ">';

        if (isset($layoutDataItem['table_header_title']) && $layoutDataItem['table_header_title']) {
          $fout .= '<span class="table-header--item-label">';
          $fout .= $layoutDataItem['table_header_title'];
          $fout .= '</span>';


          if (isset($layoutDataItem['show_sort_button']) && $layoutDataItem['show_sort_button'] == 'on') {
            include_once(DZSWTL_PATH . 'inc/php/view-functions/shortcode-woo-filter-helpers.php');
            $fout .= dzswtl_view_shortcodeGenerateSortControl($layoutDataItem, $queryArgs);
          }

        }

        $fout .= '</div>';
        $fout .= '</div>';


      }


      $fout .= '</div>';
      $fout .= '</div>';
    }

  }


  if (!$visualAtts['isZfolio']) {

    $fout .= '<div class="dzswtl-ajax-container dzs-woo-table--inner-rows ';


    if ($layout_mode == 'grid') {
      $fout .= ' items';
    }


    $fout .= '">';
  }


  $iout = '';


  $ind_nr = 0;


  try {

    if (isset($mainLayoutSettings['table_responsive_priority'])) {

      $tableResponsivePriority = json_decode($mainLayoutSettings['table_responsive_priority'], true);
      if (count($tableResponsivePriority)) {

        $layoutData['priority_blocks'] = json_decode($mainLayoutSettings['table_responsive_priority'], true);
      }
    }

  } catch (Exception $e) {

  }

  // -- parse shopPosts
  foreach ($shopPosts as $po) {

    // -- start item
    $iout .= dzswtl_parse_item_for_wootable($po, $shopAtts, $ind_nr, $visualAtts['isZfolio'], $layout_mode, $TAXONOMY_CATEGORY, $layoutData);
    $ind_nr++;
  }


  $fout .= $iout;

  if ($visualAtts['isZfolio']) {
  } else {
    $fout .= '</div><!-- end. dzs-woo-table--inner-rows -->';
  }


  if ($visualAtts['isZfolio']) {

  }
  $fout .= '</div><!-- end main ajax container-->';


  $paginationString = dzswtl_view_shortcode_generatePagination($pagination_method, $visualAtts, $shopAtts, $getFiltersQuerySource);


  if ($shopAtts['return_only_items'] == 'on') {
    return dzswtl_main_prepareAjaxResponse($shopAtts, $visualAtts, $iout, $dzswtl, $productIdsThatFitQuery, $originalQuery, $countAllNumber, $ajaxAtts, $paginationString);
  }


  if ($pagination_method == 'scroll') {
    $fout .= '<div class="wheel-loader"><div class="wheel-loader--wrap"><div class="bar1"></div><div class="bar2"></div><div class="bar3"></div><div class="bar4"></div><div class="bar5"></div><div class="bar6"></div><div class="bar7"></div><div class="bar8"></div><div class="bar7"></div><div class="bar8"></div><div class="bar9"></div><div class="bar10"></div></div></div>';
  }


  $fout .= '<div class="clear clearboth"></div>';
  $fout .= '<div class="pagination-and-per-row-con">';


  $fout .= dzswtl_view_shortcode_generatePaginationCon($paginationString, $shortcodeAtts, $shopAtts);

  $fout .= '</div><!--end .pagination-and-per-row-con-->';


  $fout .= '</div><!--end .dzs-woo-table-->';
  // -- end wootable


  $fout .= dzswtl_shortcode_woo_table__addExtraCss($shopAtts, $mainLayoutSettings);

  if ($shopAtts['recalculate_attribute_data'] === 'on') {
    $fout .= '<i class="feed-dzswtl feed-dzswtl_total_attribute_data feed-dzswtl_' . DZSWTL_AJAX_CALCULATE_FILTER_COUNT . '" data-attdata=\'' . json_encode($productIdsThatFitQuery) . '\'></i>';
  }


  if ($dzswtl->isGetAlreadyConsumed == false && defined(DZSWTL_KEY_IS_FILTERS_FROM_GET_ALREADY_CONSUMED) == false) {
    define(DZSWTL_KEY_IS_FILTERS_FROM_GET_ALREADY_CONSUMED, 'on');
  }


  // -- safety
  // -- prevent duplication
  if (!(in_array(json_encode($userInputShortcodeAtts), $dzswtl->previousShortcodeCallsParams))) {
    $dzswtl->shop_index++;
    array_push($dzswtl->previousShortcodeCallsParams, json_encode($userInputShortcodeAtts));
  }

  dzswtl_shortcode_woo_table__enqueueForVisual($visualAtts);


  return $fout;
}

function dzswtl_shortcode_woo_table__addExtraCss($shopAtts, $mainLayoutSettings) {

  $fout = '';

  if (isset($mainLayoutSettings) && isset($mainLayoutSettings['extra_css']) && $mainLayoutSettings['extra_css']) {

    if (is_array($shopAtts['layout'])) {

      error_log(' why is $margs[\'layout\'] an array? - ' . print_r($shopAtts['layout'], true));
    } else {


      $selector = '.dzs-woo-table.layout-id-' . $shopAtts['layout'];

      $fout .= '<style class="dzswtl-style-for-layout dzswtl-style-for-layout-' . $shopAtts['layout'] . '" >';
      $fout .= str_replace('#selector#', $selector, $mainLayoutSettings['extra_css']);
      $fout .= '</style>';
    }
  }

  return $fout;
}

/**
 * @param array $visualAtts
 * @return void
 */
function dzswtl_shortcode_woo_table__enqueueForVisual($visualAtts) {
  DZSWTLHelpers::enqueue_script();

  if ($visualAtts['pagination_skin'] == 'skin-orsai' || $visualAtts['pagination_skin'] == 'skin-orsai') {

    $paginationSkin = str_replace('pagination-','',$visualAtts['pagination_skin']);
    wp_enqueue_style('dzswootable-pagination-skin--' . $visualAtts['pagination_skin'], DZSWTL_URL . "libs/dzswootable/parts/filters/pagination/pagination--" . $paginationSkin . ".css");
  }
  if ($visualAtts['isZfolio']) {

    wp_enqueue_style('dzszfl', DZSWTL_URL . "libs/zfolio/zfolio.css");
    wp_enqueue_script('dzszfl', DZSWTL_URL . "libs/zfolio/zfolio.js");

    if ($visualAtts['isScroller']) {

      wp_enqueue_style('dzscsc', DZSWTL_URL . "libs/contentscroller/contentscroller.css");
      wp_enqueue_script('dzscsc', DZSWTL_URL . "libs/contentscroller/contentscroller.js");
    }
  }
}
