<?php
/**
 * built for DZSWTL_BUILDER_COL_TYPE_ZOOMSOUNDS_PLAYER
 * @param $po
 * @param $layoutDataItem
 * @param $layoutData
 * @param $layerItemBuildFnAtts
 * @param $image
 * @param $dzswtl
 * @return string
 */
function dzswtl_zoomsounds_generateLayerItemFromLayoutData($po, $layoutDataItem, $layoutData, $layerItemBuildFnAtts, $image, $dzswtl) {

  $iout = '';

  global $dzsap;


  $playerdid = $po->ID;
  $arr = array();


  if (class_exists('DZSZoomSoundsHelper')) {
    DZSZoomSoundsHelper::enqueueMainScrips();
  }

  $trackSource = $dzsap->get_track_source($po->ID, $playerdid, $arr);



  if ($trackSource) {


    $wave_mode_canvas_mode = 'reflecto';

    if (isset($layoutDataItem['zoomsounds_wave_mode_canvas_mode']) && $layoutDataItem['zoomsounds_wave_mode_canvas_mode']) {
      $wave_mode_canvas_mode = $layoutDataItem['zoomsounds_wave_mode_canvas_mode'];
    }


    $audioPlayerConfig = array(
      'id' => 'custom-skin-wave-mode-small',
      'skin_ap' => 'skin-wave',
      'settings_backup_type' => 'full',
      'skinwave_dynamicwaves' => 'off',
      'skinwave_enablespectrum' => 'off',
      'skinwave_enablereflect' => 'on',
      'skinwave_comments_enable' => 'off',
      'disable_volume' => 'on',
      'playfrom' => 'default',
      'enable_embed_button' => 'off',
      'loop' => 'off',
      'soundcloud_track_id' => '',
      'soundcloud_secret_token' => '',
      'button_aspect' => 'button-aspect-noir',
      'skinwave_wave_mode_canvas_mode' => $wave_mode_canvas_mode,
      'skinwave_mode' => 'small',
    );


    if (isset($layoutDataItem['zoomsounds_vpconfig']) && $layoutDataItem['zoomsounds_vpconfig']) {
      $audioPlayerConfig = $layoutDataItem['zoomsounds_vpconfig'];
    }

    $audioSource = $po->ID;


    if (isset($layoutData['mainsettings']) && isset($layoutData['mainsettings']['query_remove_out_of_stock_options']) && $layoutData['mainsettings']['query_remove_out_of_stock_options'] == 'on' && $layerItemBuildFnAtts['is_out_of_stock']) {
      $audioSource = 'fake';
    }


    $argsForZoomsounds = array(
      'source' => $audioSource,
      'extra_classes' => ' ap-for-' . $po->ID,
      'extra_init_settings' => '',
      'extra_html' => '',
      'config' => $audioPlayerConfig,
    );


    if ($layoutDataItem['zoomsounds_mode'] == 'just-player') {
      // -- just player ..

    }
    if ($layoutDataItem['zoomsounds_mode'] == 'just-play-button') {

      // -- just play button

      $argsForZoomsounds['extra_classes'] .= ' disable-all-but-play-btn';




      foreach ($layoutData as $ld2) {
        if (isset($ld2['feed_from']) && $ld2['feed_from'] == 'button' && (isset($ld2['button_type']) && ($ld2['button_type'] == 'add-to-cart' || $ld2['button_type'] == 'custom'))) {


          // -- if we have button or add to cart add it here
          $args3 = array_merge(array(), $layerItemBuildFnAtts);

          // -- take from here
          $add_to_cart_html = dzswtl_generate_layer_button($layerItemBuildFnAtts, $ld2, $po);

          if ($add_to_cart_html) {
            $argsForZoomsounds['extra_html'] .= '<div class="feed-dzsap feed-dzsap-for-extra-html-right"><div class="has-player-full-height">' . $add_to_cart_html . '</div></div>';
          }


        }
      }


      $argsForZoomsounds['extra_init_settings'] = array('controls_external_scrubbar' => '.zoomsounds-external-scrubbar-for-' . $po->ID . '');
      $argsForZoomsounds['thumb'] = $image;
    }

    if ($layoutDataItem['zoomsounds_mode'] == 'just-player' || $layoutDataItem['zoomsounds_mode'] == 'just-play-button') {


    }
    if ($layoutDataItem['zoomsounds_mode'] == 'full-player') {

    }

    if ($layoutDataItem['zoomsounds_mode'] == 'just-player' || $layoutDataItem['zoomsounds_mode'] == 'just-play-button' || $layoutDataItem['zoomsounds_mode'] == 'full-player') {

      if (strpos($layoutDataItem['extra_classes'], 'theme-light') !== false) {
        $argsForZoomsounds['extra_classes'] .= '  theme-light';
      }
      if (strpos($layoutDataItem['extra_classes'], 'center-it') !== false) {
        $argsForZoomsounds['extra_classes'] .= '  button-aspect-noir--filled';

        //  -- theme-light
      }

      if ($dzswtl->db_mainoptions['zoomsounds_play_in_footer'] == 'on' || (isset($layoutDataItem['zoomsounds_play_in_footer']) && $layoutDataItem['zoomsounds_play_in_footer'] == 'on')) {
        $argsForZoomsounds['play_target'] = 'footer';
        $argsForZoomsounds['faketarget'] = '.dzsap_footer';
      }
      $argsForZoomsounds['autoplay'] = 'off';
      $argsForZoomsounds['playerid'] = $po->ID;


      $iout .= $dzsap->classView->shortcode_player($argsForZoomsounds);
    }


    if ($layoutDataItem['zoomsounds_mode'] == 'just-waveform') {

      $iout .= '<div class="skin-wave zoomsounds-external-scrubbar-for-' . $po->ID . ' zoomsounds-external-scrubbar">
<div class="   scrubbar"><div class="scrub-bg"></div><div class="scrub-buffer"></div><div class="scrub-prog" style="width: 0.193319px;"></div><div class="scrubBox"></div><div class="scrubBox-prog"></div><div class="scrubBox-hover"></div></div></div>';
    }


  }
  return $iout;
}