import {
  DZSWTL_FILTERS_CUSTOMTAX,
  DZSWTL_FILTERS_CUSTOMTAX_PRODUCT_ATTRIBUTE_ISOLATED_PREFIX,
  DZSWTL_FILTERS_SINGLETON
} from "../config/_dzswtl_constants";

/**
 *
 * @param {DzsWooTable} selfClass
 */
export const ajax_loadNewFilterCount = (selfClass) => {

  const sanitizeTaxonomyName = (taxonomyName) => {

    let realTaxonomyName = '';
    if (taxonomyName.indexOf(DZSWTL_FILTERS_CUSTOMTAX) === 0) {
      realTaxonomyName = taxonomyName.replace(DZSWTL_FILTERS_CUSTOMTAX, '');
    } else {
      if (taxonomyName.indexOf(DZSWTL_FILTERS_CUSTOMTAX_PRODUCT_ATTRIBUTE_ISOLATED_PREFIX) === 0) {
        realTaxonomyName = taxonomyName;
      }
    }

    return realTaxonomyName;
  }

  var $ = jQuery;
  var filtersArray = [];

  if (!window.dzswtl_filter_referenceTaxonomyCount) {
    $('.dzs-woo-feed-filter-obj').each(function () {
      var $tFeedFilterFrom = $(this);

      const taxonomyName = $tFeedFilterFrom.attr('data-dzs-woo-feed-lab');

      var realTaxonomyName = sanitizeTaxonomyName(taxonomyName);


      if (realTaxonomyName) {
        filtersArray.push(realTaxonomyName);
      }

    })


    setTimeout(function () {
      $.ajax({
        async: "false",
        method: "POST",
        url: window.dzswtl_settings.site_url + '/ajax-api/dzswtl_ajax/dzswtl_query_calculate_filter_count/',
        data: {
          postdata: JSON.stringify(filtersArray)
        },
        dataType: 'html',
        success: function (response) {
          var responseLoadFilters = [];
          try {
            responseLoadFilters = null;

            try {
              responseLoadFilters = JSON.parse(response);

              window.dzswtl_filter_referenceTaxonomyCount = responseLoadFilters;


              if (window[DZSWTL_FILTERS_SINGLETON] && window[DZSWTL_FILTERS_SINGLETON].is_recalculate_attribute_data) {
                window[DZSWTL_FILTERS_SINGLETON].filters_recalculateFilterCount();
              }

            } catch (err) {
              console.info('err - ', err);
            }


          } catch (err) {
            console.warn(err);
          }
        }
      })

    }, 400);


  }


}