export class PriorityBlocks{
  constructor($priorityBlocks, selfInstance) {
   this.$priorityBlocks = $priorityBlocks;
   this.selfInstance = selfInstance;
   this.$priorityBlocksItems = null;
  }

  init(){

    let self = this;
    const priorityFromDb = jQuery('*[data-label="table_responsive_priority"]').val();

    let feedSource = 'builderLayers';
    let dbJson = [];
    if(priorityFromDb){

      feedSource = 'dbJson';
      dbJson = JSON.parse(priorityFromDb);
    }

    this.updateFromBuilderLayers({
      feedSource,
      dbJson
    });

    this.$priorityBlocks.nestable({
      'maxDepth': 1

      ,
      action_drag_stop: function (arg) {
        self.updateLayersOrder();
        self.updateToSettingsField();
      }
    });


    jQuery(document).on('change','*[data-label="allow_hide"]', function(){
      self.updateLayersOrder();
      self.updateToSettingsField();
    })
  }

  /**
   * serialize for settings field
   */
  updateToSettingsField(){

    const priorityJson = [];
    // let priorityIndex = 0;
    this.$priorityBlocks.children('li').each(function(){
      const priorityItemKeys = {};
      const $block = jQuery(this);
      $block.find('*[data-priorityKey]').each(function(){
        let val = jQuery(this).val();

        if(jQuery(this).attr('type')==='checkbox'){
          if(!jQuery(this).prop('checked')){
            val = '';
          }
        }
        priorityItemKeys[jQuery(this).attr('data-label')] = val;
        priorityJson.push(priorityItemKeys);
      })
    })
    // console.log({priorityJson});

    jQuery('*[data-label="table_responsive_priority"]').val(JSON.stringify(priorityJson));
    jQuery('*[data-label="table_responsive_priority"]').trigger('change');
  }
  updateLayersOrder(){

    let orderIndex = 0;
    this.$priorityBlocks.children('li').each(function(){
      const $block = jQuery(this);
      $block.find('*[data-label="guid"]').attr('data-priorityKey', `[${orderIndex}][guid]`)
      $block.find('*[data-label="allow_hide"]').attr('data-priorityKey', `[${orderIndex}][allow_hide]`)

      orderIndex++;
    })
  }

  updateFromBuilderLayers(pargs={}){

    var updateOptions = Object.assign({
      'deletedGuid': '',
      'feedSource': 'builderLayers',
      'dbJson': []
    }, pargs);

    console.log({updateOptions});
    var self = this;

    if(updateOptions.deletedGuid){
      self.$priorityBlocks.find('*[value="'+updateOptions.deletedGuid+'"]').eq(0).parent().remove();
    }

    var guidArray = [];


    if(updateOptions.feedSource==='builderLayers'){

      this.selfInstance.$builderLayers.children('li').each(function(){
        var $layer = jQuery(this);
        var guid = $layer.find('*[data-label="guid"]').eq(0).val();

        guidArray.push(guid);
      })
    }
    if(updateOptions.feedSource==='dbJson'){
      updateOptions.dbJson.forEach(function(dbPriority){

        guidArray.push(dbPriority.guid);
      })

    }

    console.log({guidArray}, updateOptions.feedSource, updateOptions.dbJson);

    guidArray.forEach(function(guid, guidIndex){
      if(guid){
        var isFound = false;
        self.$priorityBlocks.find('*[data-label="guid"]').each(function(){
          if(guid===jQuery(this).val()){
            isFound = true;
          }
        })

        if(!isFound){
        const $matchedBuilderLayerInput = self.selfInstance.$builderLayers.find('*[value="'+guid+'"]');

        const $matchedBuilderLayer = $matchedBuilderLayerInput.parent().parent().parent().parent().parent().parent().parent().eq(0);

        let priorityBlockLabel = '';

        if($matchedBuilderLayer.hasClass('builder-layer')){
          if($matchedBuilderLayer.hasClass('type-element')){
            priorityBlockLabel = $matchedBuilderLayer.find('.feed-from-val').html();
          }
          if($matchedBuilderLayer.hasClass('type-container')){
            priorityBlockLabel = 'Container';
          }
          const title = $matchedBuilderLayer.find('*[data-label="table_header_title"]').val();
          if(title){
            priorityBlockLabel += ' (<em>'+title+'</em>)';
          }
        }else{
          console.log('classes not matching')
        }


        var isAllowHideStr = '';

        if(updateOptions.dbJson && updateOptions.dbJson.length){
          if(updateOptions.dbJson[guidIndex].allow_hide==='on'){
            isAllowHideStr = ' checked';
          }
        }

          self.$priorityBlocks.append('<li class="dd-item builder-layer--priority-blocks--block"><input type="hidden" data-label="guid" value="'+guid+'"/><span class="sortable-handle-con dd-handle dd3-handle"><span class="sortable-handle dashicons dashicons-menu-alt2"></span></span><span class="builder-layer--priority-blocks--block--label">'+priorityBlockLabel+'</span><label class="builder-layer--priority-blocks--block--hide-check">AutoHide <input type="checkbox" value="on" data-label="allow_hide" '+isAllowHideStr+'/></label></li>');
        }
      }

    })
    this.updateLayersOrder();
    this.updateToSettingsField();
  }

}