import {PriorityBlocks} from "./js_listbuilder/_priorityBlocks";
import {createUUID, updateLeftRightNames} from "./js_listbuilder/_listHelpers";

window.dzswtl_last_output = '';
window.dzswtl_inited_2000 = false;

class DzsListBuilder {
  constructor($instanceEl_, instanceOptions) {
    this.$instanceEl_ = $instanceEl_;
    this.instanceOptions = instanceOptions;
    this.$priorityBlocks = null;

    this.$builderLayers = null;

    this.PriorityBlocks = null;

    this.classInit();

  }

  classInit() {

    var $ = jQuery;
    var o = this.instanceOptions;
    var selfInstance = this;
    var cthis = $(this.$instanceEl_);

    var $content = $('#content');


    this.$priorityBlocks = jQuery('.builder-layer--priority-blocks')
    console.log('this.$priorityBlocks - ', this.$priorityBlocks);

    this.PriorityBlocks = new PriorityBlocks(this.$priorityBlocks, selfInstance);

    var _input = null
    ;

    var aux_output = '';


    var generate_layer_item_default_margs;


    var ajax_send_aux_output_inter = 0
      , ajax_send_aux_output_inter_timeout = 2000
    ;


    var inter_update_to_editor = 0;


    init();

    function init() {


      if (o.input) {

        if ($(o.input).length) {

          _input = $(o.input).eq(0);
        }
      }
      selfInstance.$builderLayers = cthis.find('.builder-layers').eq(0);
      selfInstance.PriorityBlocks.init();

      if (_input) {
        var arr = {};

        try {
          arr = JSON.parse(_input.val());
        } catch (err) {
          console.info('cannot parse - ', arr);
        }
      }


      generate_layer_item_default_margs = {};

      try {
        generate_layer_item_default_margs = JSON.parse(dzswtl_settings.generate_layout_item_default_margs);
      } catch (e) {
        // console.info(e);
      }

      // console.info('generate_layout_item_default_margs - ', generate_layer_item_default_margs)

      setTimeout(function () {

        // console.info('make nestable - ', selfInstance.$builderLayers.children('.dd'));
        selfInstance.$builderLayers.nestable({
          'maxDepth': 4,
          expandBtnHTML: '<button class="collapse-btn" data-action="expand" type="button"><i class="fa fa-caret-down" ></i></button>',
          collapseBtnHTML: '<button class="collapse-btn" data-action="collapse" type="button"><i class="fa fa-caret-up" ></i></button>'
          // ,action_drag_start: function(_arg,_argItem){
          //     // _argItem.find('.with-tinymce.activated').removeClass('activated').tinymce().remove();
          // 
          // }
          ,
          action_drag_stop: function () {
            arrange_layers({
              calledFrom: 'order_stop'
            });
            update_to_editor({
              'call_from': 'arrange_layers'
            });
          }
        });


      }, 1000);


      $(document).on('click', '.admin-builder-content .table--content--item', handle_mouse);
      setTimeout(function () {

        window.dzswtl_inited_2000 = true;
        update_to_editor({
          'call_from': 'init 2000'
        });

      }, 2000);
      setTimeout(function () {
        $('.builder-demo-con').addClass('ready');
      }, 4000);


      // console.info($('.add-builder-btn'));
      cthis.on('change', '.builder-field,.feed-from-main ', handleChangeBuilderField);
      cthis.on('change', 'select[name="bars[mainsettings][layout_mode]"]', handle_change);
      // cthis.on('change', '.builder-field',change_builder_field);
      cthis.on('click', '.add-builder-btn,.the-title,.builder-layer--btn-delete', handle_mouse);


      $('select[name="bars[mainsettings][layout_mode]"]').trigger('change');


      setTimeout(function () {


        arrange_layers({
          calledFrom: 'init'
        });
        listeners_add_for_layer();
        clearTimeout(ajax_send_aux_output_inter);


        ajax_send_aux_output_inter = setTimeout(ajax_sendOutput, 500);
      }, 1000);
    }

    function handle_change() {
      var _t = $(this);

      if (_t.attr('name') === 'bars[mainsettings][layout_mode]') {

        $('body').attr('data-layout-mode', _t.val());
      }
    }

    function handleChangeBuilderField() {
      var $t = $(this);
      var nameOfInput = $t.attr('name');

      var _con = null;


      if ($t.hasClass('feed-from-main')) {


        if ($t.parent().parent().parent().parent().parent().parent().parent().parent().hasClass('dd-item')) {
          // console.info("FOUND");
          _con = $t.parent().parent().parent().parent().parent().parent().parent().parent();
          _con.find('.feed-from-val').text($t.val());
          // console.info('_con - ', _con, _t.val());
        }
      }


      // console.info('change_builder_field()', _t);
      var isArrangeLayers = false; // restart everything

      if (nameOfInput) {
        updateLeftRightNames($t, nameOfInput);

        isArrangeLayers = true;
      }
      if (isArrangeLayers) {

        // arrange_layers();
      }

      update_to_editor({
        'call_from': 'change_builder_field'
      });
      // update_fields({
      //     'call_from':'change_builder_field'
      // });

      if (isArrangeLayers) {
        setTimeout(function () {

          // arrange_layers();
        }, 100);
      }


    }


    function handle_mouse(e) {

      var _t = $(this);

      // console.info(_t);

      // console.info("CEVA");
      if (e.type === 'click') {


        if (_t.hasClass('table--content--item')) {

          let _con = null
          if (_t.parent().hasClass('table-item--inner')) {
            _con = _t.parent();
          }
          if (_t.parent().parent().hasClass('table-item--inner')) {
            _con = _t.parent().parent();
          }
          if (_con) {
            var ind = _con.find('.table--content--item').index(_t);
            // console.info('.table--content--item ind - ', ind);

            const $builderLayer = $('.builder-layer');

            $builderLayer.each(function () {
              var _t2 = $(this);


              _t2.removeClass('active-selected').find('.builder-layer--inside').removeClass('active');
            })

            var _c = $builderLayer.eq(ind);
            _c.addClass('highlight-it');
            _c.addClass('active-selected');

            setTimeout(function (arg) {

              $('.builder-layer').eq(arg).removeClass('highlight-it');
            }, 300, ind);
            _c.find('.builder-layer--inside').eq(0).addClass('active');

            return false;
          }

        }


        // console.info("CEVA");


        if (_t.hasClass('add-element')) {

          // console.info("CEVA");

          selfInstance.$builderLayers.append(dzswtl_settings.struct_layer_element);
          listeners_add_for_layer();
          arrange_layers({
            calledFrom: 'add-element'
          });
          update_to_editor({
            'call_from': 'add-element'
          });
        }
        if (_t.hasClass('add-container')) {
          // console.info("CEVA");
          selfInstance.$builderLayers.append(dzswtl_settings.struct_layer_container);
          listeners_add_for_layer();
          arrange_layers({
            calledFrom: 'add-element'
          });
          update_to_editor({
            'call_from': 'add-container'
          });
        }
        if (_t.hasClass('the-title')) {

          // console.info("CEVA");

          var _con;

          // console.info('_t.parent().parent() - ', _t.parent().parent());

          _con = _t.parent().parent();

          if (_con.hasClass('active-selected')) {


            _con.removeClass('active-selected');
            _con.find('.dzstooltip').eq(0).removeClass('active');

          } else {

            _con.parent().children().removeClass('active-selected');
            _con.parent().children().each(function () {
              var _t3 = $(this);

              _t3.find('.dzstooltip').eq(0).removeClass('active');
            })

            _con.addClass('active-selected');
            _con.find('.dzstooltip').eq(0).addClass('active');
          }


        }
        if (_t.hasClass('builder-layer--btn-delete')) {


          var isConfirmDelete = confirm("Confirm Item Delete");
          let _t = $(this);
          var _par = _t.parent().parent().parent();


          var deletedGuid = _par.find('*[data-label="guid"]').eq(0).val();
          // console.info('_par - ',_par);

          if (isConfirmDelete) {
            _par.remove();
          }

          arrange_layers({
            calledFrom: 'delete-element',
            deletedGuid
          });

          update_to_editor({
            'call_from': 'btn-delete'
          });
        }
      }
    }

    function listeners_add_for_layer() {


      dzstaa_init('.dzs-tabs.init-layer', {
        init_each: true
        , refresh_tab_height: 1000
        , settings_appendWholeContent: true
      });


      dzstoggle_initalltoggles();
      dzssel_init('select.dzs-style-me', {init_each: true});


      $('.spectrum-me').each(function () {
        var _t = $(this);

        if (_t.hasClass('inited')) {
          return;
        }

        _t.spectrum({
          preferredFormat: "hex"
          , showAlpha: true
          , allowEmpty: true
        });

        _t.addClass('inited');
        // console.info('_t - ',_t);
      })
    }


    function update_to_editor(pargs) {


      var margs = {
        'call_from': 'default'
      }

      if (pargs) {
        margs = $.extend(margs, pargs);
      }

      // aux_output =


      // aux_output = formToJSON('.builder-layers');
      // aux_output = JSON.stringify(aux_output);


      if (window.dzswtl_inited_2000 === false) {
        return false;
      }


      clearTimeout(inter_update_to_editor);
      inter_update_to_editor = setTimeout(function (margs) {
        update_to_editor_really(margs);
      }, 100, margs);

      // console.info('update_to_editor()');

    }

    function update_to_editor_really(pargs) {


      var margs = {
        'call_from': 'default'
      }

      if (pargs) {
        margs = $.extend(margs, pargs);
      }


      $('.builder-field').each(function () {
        var _t = $(this);
        var tval = _t.val();
        if (_t.hasClass('dzs-select-wrapper')) {
          return;
        }

        // console.info('data-input-label - ',_t.attr('data-input-label'), _t, tval);


        if (_t.attr('data-input-label')) {
          var lab = _t.attr('data-input-label');

          if (lab) {


            if (generate_layer_item_default_margs && generate_layer_item_default_margs.hasOwnProperty(lab)) {
              // console.warn('generate_layer_item_default_margs[lab] |',generate_layer_item_default_margs[lab], '|', tval);
              if (generate_layer_item_default_margs[lab] === tval) {
                // console.info('disable it .. ',_t);

                _t.addClass('temp-disable');

                _t.prop('disabled', true);
              }
            }
          }
        }

      })

      setTimeout(function () {

        $('.temp-disable').each(function () {

          $(this).removeClass('temp-disable');
          $(this).prop('disabled', false);
        });

      }, 1000);

      aux_output = $('.list-builder-con').eq(0).serializeAnything();

      window.dzswtl_last_output = aux_output;
      // aux_output = selfInstance.$builderLayers.serializeArray();

      // console.warn('aux_output - ',aux_output);
      // _areaCanvas.append(aux_output);


      console.groupCollapsed();


      console.info('update_to_editor() really margs - ', margs)
      console.info(' old output - ', $content.val())

      console.info('update_to_editor() new output - ', aux_output)
      console.groupEnd();


      $content.val(aux_output);

      clearTimeout(ajax_send_aux_output_inter);


      ajax_send_aux_output_inter = setTimeout(ajax_sendOutput, ajax_send_aux_output_inter_timeout);


      if (ajax_send_aux_output_inter_timeout === 2000) {

        setTimeout(function () {
          ajax_send_aux_output_inter_timeout = 500
        }, ajax_send_aux_output_inter_timeout);
      }
    }


    function ajax_sendOutput() {
      $('.builder-demo-con').addClass('builder-demo--is-loading-ajax')

      $.ajax({
        method: "POST"
        , url: ajaxurl
        , data: {
          action: 'dzswtl_listBuilder_previewFout'
          , postdata: aux_output
        }
        , success: function (response) {
          $('.builder-demo-con').removeClass('builder-demo--is-loading-ajax')
          $('.builder-demo-con').eq(0).html(response);
          $('.dzs-woo-table').dzswootable();
        }
      });
    }


    /**
     * @arrange layers, name inputs and build the main canvas area
     */
    function arrange_layers(pargs = {}) {

      let arrangeLayersOptions = Object.assign({
        'calledFrom': 'default',
        'deletedGuid': '',
      }, pargs)

      // console.log('arrange_layers()');


      var _c = $('*[name="bars[mainsettings][max_width]"]').eq(0);

      if (_c.val()) {
      }


      if (arrangeLayersOptions.calledFrom !== 'order_stop') {


      }

      var selector_inputs = '>*:not(.dd-list) *[name^="bars["]';
      for (var i = 0; i < selfInstance.$builderLayers.find(' > .builder-layer').length; i++) {
        var $layerItem = selfInstance.$builderLayers.find(' > .builder-layer').eq(i);


        // console.info("_layer - ", _layer);

        $layerItem.find('textarea.with-tinymce').each(function () {
          var _t = $(this);
          if (_t.hasClass('activated') === false) {
            if ($.fn.tinymce) {
              // _t.addClass('activated').tinymce(tinymce_settings);
            }
          }
        })

        if ($layerItem.find('*[data-label="guid"]').val() === '') {
          $layerItem.find('*[data-label="guid"]').val(createUUID());
        }


        // console.info('_layer prime - ', _layer, i);

        $layerItem.find(selector_inputs).each(function () {
          var _t = $(this);
//                console.info(_t);
          var aux = _t.attr('name');
          aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]/g, "bars[" + i + "]");
          _t.attr('name', aux);
        });

//            console.info(_layer);

        let layerType = $layerItem.find('.the-title').eq(0).attr('data-type');


        if (layerType === 'circ') {
        } else {
          if (layerType === 'container') {
          } else {

          }
        }

        // console.info('_layer5 - ', _layer);


        // -- level 2
        if (layerType === 'container') {

          for (var j = 0; j < $layerItem.find('> .dd-list > .builder-layer').length; j++) {
            var _layerkid = $layerItem.find('> .dd-list > .builder-layer').eq(j);

            _layerkid.find('textarea.with-tinymce').each(function () {
              // var _t = $(this);
              // if(_t.hasClass('activated')==false){
              //     if($.fn.tinymce) {
              //         _t.addClass('activated').tinymce(tinymce_settings);
              //     }
              // }
            })


            // console.info('_layerkid - ',_layerkid, j);

            _layerkid.find(selector_inputs).each(function () {
              var _t = $(this);
//                console.info(_t);

              var aux = _t.attr('name');


              aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][$4");
              aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][$3");
              aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[([a-z].*)\]/g, "bars[" + i + "][" + j + "][$2]");

              _t.attr('name', aux);
            })


            let aux_type = _layerkid.find('.the-title').eq(0).attr('data-type');


            if (aux_type === 'container') {

              // -- level 3

              for (var k = 0; k < _layerkid.find('> .dd-list > .builder-layer').length; k++) {
                var _layerkid_kid = _layerkid.find('> .dd-list > .builder-layer').eq(k);

                // console.warn('_layerkid_kid - ',_layerkid_kid);

                _layerkid_kid.find('textarea.with-tinymce').each(function () {
                  // var _t = $(this);
                  // if(_t.hasClass('activated')==false){
                  //     if($.fn.tinymce) {
                  //         _t.addClass('activated').tinymce(tinymce_settings);
                  //     }
                  // }
                })


                // console.info('_layerkid - ',_layerkid, j);


                _layerkid_kid.find(selector_inputs).each(function () {
                  var _t3 = $(this);
//                console.info(_t);

                  var aux = _t3.attr('name');

                  // console.info('aux [ the name of kid kid layer ] - ',aux);


                  aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][" + k + "][$4");
                  aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][" + k + "][$3");
                  aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[([a-z].*)\]/g, "bars[" + i + "][" + j + "][" + k + "][$2]");

                  // console.info('new aux [ the name of kid kid layer ] - ',aux, _t3);
                  _t3.attr('name', aux);


                  var aux_type = _layerkid.find('.the-title').eq(0).attr('data-type');


                  if (aux_type === 'container') {

                    // -- level 4

                    for (var li = 0; li < _layerkid_kid.find('> .dd-list > .builder-layer').length; li++) {
                      var _layerkid4 = _layerkid_kid.find('> .dd-list > .builder-layer').eq(li);

                      // console.warn('_layerkid4 - ',_layerkid4);


                      _layerkid4.find(selector_inputs).each(function () {
                        var _t3 = $(this);
//                console.info(_t);

                        var aux = _t3.attr('name');

                        // console.info('aux [ the name of kid kid layer ] - ',aux);


                        aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][" + k + "][" + li + "][$5");
                        aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][" + k + "][" + li + "][$4");
                        aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][" + k + "][" + li + "][$3");
                        aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[([a-z].*)\]/g, "bars[" + i + "][" + j + "][" + k + "][" + li + "][$2]");

                        // console.info('new aux [ the name of kid kid layer ] - ',aux, _t3);
                        _t3.attr('name', aux);


                      })


                    }
                  }


                })


              }
            }

//            console.info(_layerkid);


          }
        }


        if (layerType === 'circ') {
        } else {
          if (layerType === 'container') {
          } else {

          }
        }


      }

      selfInstance.PriorityBlocks.updateFromBuilderLayers({
        deletedGuid: arrangeLayersOptions.deletedGuid
      });

    }


  }
}

(function ($) {
  $.fn.dzslistbuilder = function (o) {
    var defaults = {
      settings_slideshowTime: '5' //in seconds
      , settings_preloadall: 'on'
      , settings_dummy_items_nr: 10
      , grid: 'dzs-layout--5-cols'
      , input: ''

    }


    o = $.extend(defaults, o);
    this.each(function () {
      new DzsListBuilder(this, o);
    })

  }
})(jQuery);

require('./js_listbuilder/_jQueryExtends');