var fs = require('fs');

const SOURCE_FILE = 'package.json';
const TARGET = 'wootable.php';
const TARGET_CHANGELOG = 'CHANGELOG.md';
const TARGET_README = 'README.md';

let aux = null;
let version = '';

fs.readFile(SOURCE_FILE, 'utf8', function (err, contents) {

  var regex = /"version": "(.*?)"/g;

  if (aux = regex.exec(contents)[1]) {
    version = aux;
  }

  fs.readFile(TARGET, 'utf8', function (err, contentsTarget) {

    if (version) {

      var regex2 = /(Version: )(.*?)[\t\n\r]/g;
      var regex3 = /const DZSWTL_VERSION = '(.*?)'/g;

      contentsTarget = contentsTarget.replace(regex2, '$1' + version + (require('os').EOL));
      contentsTarget = contentsTarget.replace(regex3, `const DZSWTL_VERSION = '${version}'`);


      fs.writeFile(TARGET, contentsTarget, 'utf8', function () {

      });
    }
  });
});

fs.readFile(TARGET_CHANGELOG, 'utf8', function (err, contents) {

  var regex2 = /[\(| ]\[.*?\]\(.*?\)[\)|]/g;
  var contentsStrippedChangelog = contents.replace(regex2, '');
  var regex3 = /\(h.*?\)/g;
  contentsStrippedChangelog = contentsStrippedChangelog.replace(regex3, '');
  var regex4 = /\n\n/g;
  contentsStrippedChangelog = contentsStrippedChangelog.replace(regex4, '\n');


  fs.readFile(TARGET_README, 'utf8', function (err, contentsReadme) {

    var regex23 = /(# Changelog)[\s|\S]*?(\<\!)/g;
    var contentsNewReadme = contentsReadme.replace(regex23, ''+contentsStrippedChangelog+'\\n$2');


    fs.writeFile(TARGET_README, contentsNewReadme, 'utf8', function () {

    });
  })

});
