const path = require( 'path' );
const webpack = require( 'webpack' );




module.exports = {
  entry: {
    './dist/block-shop' : './gutenberg/block-shop.js'
  },
  output: {
    path: path.resolve( __dirname ),
    filename: '[name].js',
  },
  mode: 'development',
  watch: true,
  // devtool: 'cheap-eval-source-map',
  module: {
    rules: [
      {
        test: /\.js$/,
        exclude: /(node_modules)/,
        use: {
          loader: 'babel-loader',
          options: {
            presets: [
              [
                "@babel/preset-react",
                {
                  development: process.env.BABEL_ENV === "development",
                },
              ],
            ],
          }
        },
      },
      {
        test: /\.s[ac]ss$/i,
        exclude: /(node_modules)/,
        use: [
          // Creates `style` nodes from JS strings
          'style-loader',
          // Translates CSS into CommonJS
          'css-loader',
          // Compiles Sass to CSS
          'sass-loader',
        ],
      }
    ],
  },
  plugins: [
  ],
};
